#include<iostream>
#include<vector>
#include<algorithm>
#include<stack>
#include<queue>
using namespace std;

class Vertex
{
public:
    int x, y;
    int index=-1;
    int up, down, left, right;
    int allup, alldown, allleft, allright;
    bool isStone = false;
    Vertex()
    {
        this->up = this->down = this->left = this->right = -1;
        this->allup = this->alldown = this->allleft = this->allright = -1;
        this->x = this->y = 0;
    }
    Vertex(int x, int y, bool stone = false)
    {
        this->up = this->down = this->left = this->right = -1;
        this->allup = this->alldown = this->allleft = this->allright = -1;
        this->x = x;
        this->y = y;
        this->isStone = stone;
    }
};
vector<Vertex> all, v;
enum Direction {VERTICAL = 1, HORIZONTAL = 2};
class Edge
{
public:
    int a, b;
    Direction d;
    Edge(int a, int b, Direction d)
    {
        this->a = a;
        this->b = b;
        this->d = d;
    }
};
class SupremeEdge
{
public:
    int a, b;
    Direction d;
    SupremeEdge(int a, int b, Direction d)
    {
        this->a = a;
        this->b = b;
        this->d = d;
    }
    SupremeEdge(Edge x)
    {
        this->a = x.a;
        this->b = x.b;
        this->d = x.d;
    }
};

bool g1(Vertex a, Vertex b)
{
    if (a.x < b.x) return true;
    if (a.x > b.x) return false;
    if (a.y < b.y) return true;
    return false;
}
bool g2(Vertex a, Vertex b)
{
    if (a.y < b.y) return true;
    if (a.y > b.y) return false;
    if (a.x < b.x) return true;
    return false;
}

int findParent(int x, vector<int> * parents)
{
    if (parents->at(x) == x) return x;
    return findParent(parents->at(x), parents);
}

struct assignAlls
{
    int index;
    assignAlls(int x){this->index = x;}
    bool operator< (assignAlls x) const
    {
        int score1 = 0, score2 = 0;
        if (v[this->index].allup > -1) score1++;
        if (v[this->index].alldown > -1) score1++;
        if (v[this->index].allleft > -1) score1++;
        if (v[this->index].allright > -1) score1++;
        if (v[x.index].allup > -1) score2++;
        if (v[x.index].alldown > -1) score2++;
        if (v[x.index].allleft > -1) score2++;
        if (v[x.index].allright > -1) score2++;
        return score1 < score2;
    }
};

int n, m;
bool obhoden[400001];

int main ()
{
    cin>>n;
    for (int i=0; i<n; i++)
    {
        int a, b;
        cin>>a>>b;
        v.emplace_back(a, b);
        all.emplace_back(a, b);
        v[i].index = i;
        all[i].index = i;
    }
    cin>>m;
    for (int i=0; i<m; i++)
    {
        int a, b;
        cin>>a>>b;
        all.emplace_back(a, b, true);
    }
    sort(all.begin(), all.end(), g1);

    for (int i=0; i<all.size()-1; i++)
    {

        if (all[i].x == all[i+1].x && all[i].isStone == false && all[i+1].isStone == false)
        {
            v[all[i].index].down = all[i+1].index;
            v[all[i+1].index].up = all[i].index;
        }
    }
    sort(all.begin(), all.end(), g2);
    for (int i=0; i<all.size()-1; i++)
    {

        if (all[i].y == all[i+1].y && all[i].isStone == false && all[i+1].isStone == false)
        {
            v[all[i].index].right = all[i+1].index;
            v[all[i+1].index].left = all[i].index;
        }
    }

    vector<Edge> edges;
    {
        vector<int> parents;
        for (int i=0; i<n; i++)
        {
            parents.push_back(i);
            if (v[i].up != -1) edges.emplace_back(i, v[i].up, VERTICAL);
            if (v[i].left != -1) edges.emplace_back(i, v[i].left, HORIZONTAL);
        }
        for (int i=0; i<edges.size(); i++)
        {
            int a = findParent(edges[i].a, &parents);
            int b = findParent(edges[i].b, &parents);
            if (a != b)
            {
                parents[b] = a;
            }
            else
            {
                if (edges[i].d == VERTICAL)
                {
                    v[edges[i].a].up = -1;
                    v[edges[i].b].down = -1;
                }
                else
                {
                    v[edges[i].a].left = -1;
                    v[edges[i].b].right = -1;
                }
            }
        }
    }

    for (int i=0; i<n; i++)
    {
        if (obhoden[i]) continue;
        vector<int> vertexes;
        queue<int> q;
        q.push(i);
        obhoden[i] = true;
        vertexes.push_back(i);

        priority_queue<assignAlls> leaves;
        while (!q.empty())
        {
            int top = q.front();
            q.pop();
            if (v[top].up == -1) v[top].allup = 0;
            else
            {
                if (!obhoden[v[top].up])
                {
                    obhoden[v[top].up] = true;
                    q.push(v[top].up);
                    vertexes.push_back(v[top].up);
                }
            }
            if (v[top].down == -1) v[top].alldown = 0;
            else
            {
                if (!obhoden[v[top].down])
                {
                    obhoden[v[top].down] = true;
                    q.push(v[top].down);
                    vertexes.push_back(v[top].down);
                }
            }
            if (v[top].left == -1) v[top].allleft = 0;
            else
            {
                if (!obhoden[v[top].left])
                {
                    obhoden[v[top].left] = true;
                    q.push(v[top].left);
                    vertexes.push_back(v[top].left);
                }
            }
            if (v[top].right == -1) v[top].allright = 0;
            else
            {
                if (!obhoden[v[top].right])
                {
                    obhoden[v[top].right] = true;
                    q.push(v[top].right);
                    vertexes.push_back(v[top].right);
                }
            }

            leaves.emplace(top);
        }
        int allcur = leaves.size();

        while (leaves.size() > 1)
        {
            int top = leaves.top().index;
            leaves.pop();
            if (v[top].allup == -1)
            {
                v[top].allup = allcur - 1 - v[top].alldown - v[top].allleft - v[top].allright;
                v[v[top].up].alldown = allcur - v[top].allup;
            }
            else if (v[top].alldown == -1)
            {
                v[top].alldown = allcur - 1 - v[top].allup - v[top].allleft - v[top].allright;
                v[v[top].down].allup = allcur - v[top].alldown;
            }
            else if (v[top].allleft == -1)
            {
                v[top].allleft = allcur - 1 - v[top].allup - v[top].alldown - v[top].allright;
                v[v[top].left].allright = allcur - v[top].allleft;
            }
            else if (v[top].allright == -1)
            {
                v[top].allright = allcur - 1 - v[top].allup - v[top].alldown - v[top].allleft;
                v[v[top].right].allleft = allcur - v[top].allright;
            }
        }
    }

    cout<<endl;
    for (int i=0; i<n; i++) cout<<v[i].index<<": "<<v[i].allup<<" "<<v[i].alldown<<" "<<v[i].allleft<<" "<<v[i].allright<<endl;
}
/**
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9
*/
