#include <bits/stdc++.h>

using namespace std;

struct point{
    int x, y;

    point(){}
};

const int MAXN = 8e5 + 7;
point box[MAXN], rock[MAXN];
int n, m;
set<pair<int, int> > row[MAXN], col[MAXN];
set<int> set_row, set_col;
map<int, int> idx_row, idx_col;
int cnt_row, cnt_col, rev_row[MAXN], rev_col[MAXN];

void index(){
    for(int i = 0; i < n; ++i){
        set_row.insert(box[i].x);
        set_col.insert(box[i].y);
    }
    for(int i = 0; i < m; ++i){
        set_row.insert(rock[i].x);
        set_col.insert(rock[i].y);
    }

    cnt_row = 0;
    for(int x: set_row){
        rev_row[cnt_row] = x;
        idx_row[x] = cnt_row++;
    }

    cnt_col = 0;
    for(int x: set_col){
        rev_col[cnt_col] = x;
        idx_col[x] = cnt_col++;
    }
}
void place(){
    for(int i = 0; i < n; ++i){
        row[idx_row[box[i].x]].insert({box[i].y, i});
        col[idx_col[box[i].y]].insert({box[i].x, i});
    }
    for(int i = 0; i < m; ++i){
        row[idx_row[rock[i].x]].insert({rock[i].y, i + n});
        col[idx_col[rock[i].y]].insert({rock[i].x, i + n});
    }
}

vector<array<int, 3> > adj[MAXN];

void build_graph(){
    for(int i = 0; i < cnt_row; ++i){
        pair<int, int> pr = {-1, -1};
        for(pair<int, int> p: row[i]){
            if(pr.first == -1){
                pr = p;
                continue;
            }
            if(p.second < n && pr.second < n){
                adj[p.second].push_back({pr.second, rev_row[i], p.first - 1});
                adj[pr.second].push_back({p.second, rev_row[i], p.first - 1});
            }
            pr = p;
        }
    }

    for(int i = 0; i < cnt_col; ++i){
        pair<int, int> pr = {-1, -1};
        for(pair<int, int> p: col[i]){
            if(pr.first == -1){
                pr = p;
                continue;
            }
            if(p.second < n && pr.second < n){
                adj[p.second].push_back({pr.second, p.first - 1, rev_col[i]});
                adj[pr.second].push_back({p.second, p.first - 1, rev_col[i]});
            }
            pr = p;
        }
    }
}

bool used[MAXN];
vector<array<int, 3> > ins;
set<int> neigh[5];
int curr[MAXN];

void dummy_solve(){
    for(int i = 0; i < n; ++i){
        curr[i] = (int)adj[i].size();
        neigh[curr[i]].insert(i);
    }

    int cnt = n;
    while(cnt){
        while(!neigh[0].empty()){
            int u = *neigh[0].begin();
            ins.push_back({0, box[u].x + 1, box[u].y});
            neigh[0].erase(u);
            --cnt;
        }

        for(int i = 1; i <= 4; ++i){
            if(!neigh[i].empty()){
                int u = *neigh[i].begin();
                int mn = 5;
                array<int, 3> best;
                for(array<int, 3> arr: adj[u]){
                    int to = arr[0];
                    if(used[to]){
                        continue;
                    }
                    if(curr[to] < mn){
                        mn = curr[to];
                        best = arr;
                    }
                }

                int to = best[0];
                if(box[to].x == box[u].x){
                    ins.push_back({1, best[1], best[2]});
                }
                else{
                    ins.push_back({0, best[1], best[2]});
                }
                used[u] = true;
                used[to] = true;
                neigh[i].erase(u);
                neigh[curr[to]].erase(to);

                for(array<int, 3> arr: adj[u]){
                    int to2 = arr[0];
                    if(used[to2]){
                        continue;
                    }
                    neigh[curr[to2]].erase(to2);
                    --curr[to2];
                    neigh[curr[to2]].insert(to2);
                }
                for(array<int, 3> arr: adj[to]){
                    int to2 = arr[0];
                    if(used[to2]){
                        continue;
                    }
                    neigh[curr[to2]].erase(to2);
                    --curr[to2];
                    neigh[curr[to2]].insert(to2);
                }
                cnt -= 2;
                break;
            }
        }
    }
}

void solve(){
    index();
    place();
    build_graph();

    dummy_solve();
}

void write(){
    cout << (int)ins.size() << "\n";
    for(auto x: ins){
        cout << x[0] << " " << x[1] << " " << x[2] << "\n";
    }
}

void read(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> box[i].x >> box[i].y;
    }

    cin >> m;
    for(int i = 0; i < m; ++i){
        cin >> rock[i].x >> rock[i].y;
    }
}

int main(){
    read();
    solve();
    write();
}
/*
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9
*/
