#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
#include <map>
using namespace std;

const int MAXN = 100005;

struct edge
{
    int adj, use, cap, rev;
    edge(int adj, int use, int cap, int rev)
    {
        this -> adj = adj;
        this -> use = use;
        this -> cap = cap;
        this -> rev = rev;
    }
};

int n;
vector<edge> g[3 * MAXN];
map<int, int> mp;

int source = 0, sink;

int aa[MAXN], cc[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    sink = 3 * n + 5;

    for (int i = 1; i <= n; ++ i)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        if (mp.count(a) == 0)
        {
            int sz = mp.size() + 1;
            mp[a] = sz;
        }
        if (mp.count(c) == 0)
        {
            int sz = mp.size() + 1;
            mp[c] = sz;
        }

        a = b = mp[a] + n;
        c = d = mp[c] + n;

        aa[i] = a;
        cc[i] = c;

        g[a].emplace_back(i, 0, 1, g[i].size());
        g[i].emplace_back(a, 0, 0, g[a].size() - 1);

        // cout << "edge: " << a << ' ' << i << endl;

        g[c].emplace_back(i, 0, 1, g[i].size());
        g[i].emplace_back(c, 0, 0, g[c].size() - 1);

        //cout << "edge: " << c << ' ' << i << endl;

        g[i].emplace_back(sink, 0, 1, g[sink].size());
        g[sink].emplace_back(i, 0, 0, g[i].size() - 1);
        // cout << "edge: " << i << ' ' << sink << endl;
    }

    for (auto p : mp)
    {
        g[0].emplace_back(p.second + n, 0, 1, g[p.second + n].size());
        g[p.second + n].emplace_back(0, 0, 0, g[0].size() - 1);
        // cout << "edge: " << 0 << ' ' << p.second + n << endl;
    }
}

int vis[MAXN];

int DFS(int u = 0, int f = 1)
{
    if (u == sink) return f;

    vis[u] = 1;

    for (int i = 0; i < g[u].size(); ++ i)
    {
        if (vis[g[u][i].adj] == 0 and g[u][i].use < g[u][i].cap)
        {
            int flow = DFS(g[u][i].adj);
            if (flow == 1)
            {
                g[u][i].use++;
                g[g[u][i].adj][g[u][i].rev].use--;
                vis[u] = 0;
                return flow;
            }
        }
    }

    vis[u] = 0;
    return 0;
}

int main()
{
    Init();

    int flow = 0;
    while (DFS())
    {
        flow++;
    }

    if (flow != n)
    {
        cout << "No" << endl;
        return 0;
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 0; j < g[i].size(); ++ j)
        {
            if (g[i][j].use == -1)
            {
                // cout << "this" << endl;
                if (g[i][j].adj == mp[aa[i]] + n) cout << 1 << endl;
                else cout << 2 << endl;
                break;
            }
        }
    }

    return 0;

}

