#include <bits/stdc++.h>

const int32_t MAX_N = 1e5;

struct Vertex {
	bool vis;
	int32_t comp;
	std::vector< std::pair< int32_t, int32_t > > v, revV;
};

int32_t n, a[MAX_N + 5], b[MAX_N + 5], c[MAX_N + 5], d[MAX_N + 5], ans[MAX_N + 5];
Vertex g[MAX_N + 5][2];

bool do_intersect(int32_t l1, int32_t r1, int32_t l2, int32_t r2) {
	if(l2 >= l1 && l2 <= r1) {
		return true;
	}
	if(r2 >= l1 && r2 <= r1) {
		return true;
	}
	if(l1 >= l2 && l1 <= r2) {
		return true;
	}
	if(r1 >= l2 && r1 <= r2) {
		return true;
	}

	return false;
}

void add_edge(int32_t x, int32_t i, int32_t y, int32_t j) {
	g[x][i].v.push_back({ y, j });
	g[y][j].revV.push_back({ x, i });
}

void build_graph() {
	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = i + 1; j < n; j++) {
			if(do_intersect(a[i], b[i], a[j], b[j])) {
				add_edge(i, 0, j, 1);
				add_edge(j, 0, i, 1);
			}
			if(do_intersect(a[i], b[i], c[j], d[j])) {
				add_edge(i, 0, j, 0);
				add_edge(j, 1, i, 1);
			}
			if(do_intersect(c[i], d[i], a[j], b[j])) {
				add_edge(i, 1, j, 1);
				add_edge(j, 0, i, 0);
			}
			if(do_intersect(c[i], d[i], c[j], d[j])) {
				add_edge(i, 1, j, 0);
				add_edge(j, 1, i, 0);
			}
		}
	}
}

void dfs(int32_t i, int32_t j, std::stack< std::pair< int32_t, int32_t > > &st) {
	g[i][j].vis = true;
	
	for(auto &x : g[i][j].v) {
		if(!g[x.first][x.second].vis) {
			dfs(x.first, x.second, st);
		}
	}

	st.push({ i, j });
}

void dfs_rev(int32_t i, int32_t j, int32_t comp) {
	g[i][j].comp = comp;

	for(auto &x : g[i][j].revV) {
		if(g[x.first][x.second].comp == 0) {
			dfs_rev(x.first, x.second, comp);
		}
	}
}

void compute_sccs() {
	std::stack< std::pair< int32_t, int32_t > > st;
	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < 2; j++) {
			if(!g[i][j].vis) {
				dfs(i, j, st);
			}
		}
	}
	
	int32_t comp = 1;
	while(!st.empty()) {
		auto x = st.top();
		st.pop();

		if(g[x.first][x.second].comp == 0) {
			dfs_rev(x.first, x.second, comp);
			comp++;
		}
	}
}

bool check_2sat() {
	compute_sccs();	

	for(int32_t i = 0; i < n; i++) {
		if(g[i][0].comp == g[i][1].comp) {
			return false;
		}
	}

	return true;
}

void compute_ans() {
	std::stack< std::pair< int32_t, int32_t > > st;

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < 2; j++) {
			g[i][j].vis = false;
		}
	}

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < 2; j++) {
			if(!g[i][j].vis) {
				dfs(i, j, st);
			}
		}
	}

	std::stack< std::pair< int32_t, int32_t > > stRev;
	while(!st.empty()) {
		stRev.push(st.top());
		st.pop();
	}

	while(!stRev.empty()) {
		auto x = stRev.top();
		stRev.pop();

		if(ans[x.first] == 0) {
			ans[x.first] = x.second + 1;
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;

	for(int32_t i = 0; i < n; i++) {
		std::cin >> a[i] >> b[i] >> c[i] >> d[i];		
	}

	build_graph();

	if(check_2sat()) {
		std::cout << "Yes" << '\n';
		compute_ans();

		for(int32_t i = 0; i < n; i++) {
			std::cout << ans[i] << '\n';
		}
	}
	else {
		std::cout << "No" << '\n';
	}
}
