#include <bits/stdc++.h>

const int32_t MAX_N = 4e5;
const int32_t MAX_M = 4e5;

const int32_t DELTA_R[] = { -1, 0, 1, 0 };
const int32_t DELTA_C[] = { 0, 1, 0, -1 };

bool active[MAX_N + 5];
int32_t n, m, edges[MAX_N + 5][4];
std::pair< int32_t, int32_t > boxes[MAX_N + 5], stones[MAX_M + 5];
std::vector< std::pair< int32_t, std::pair< int32_t, int32_t > > > ans;

int32_t get_dist(int32_t i, int32_t j) {
	return abs(boxes[i].first - boxes[j].first) + abs(boxes[i].second - boxes[j].second);
}

void build_graph() {
	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < n; j++) {
			if(i == j) {
				continue;
			}
			
			if(boxes[i].first == boxes[j].first) {
				if(boxes[i].second < boxes[j].second) {
					if(edges[i][1] == -1 || get_dist(i, edges[i][1]) > get_dist(i, j)) {
						edges[i][1] = j;
					}
				}
				else {
					if(edges[i][3] == -1 || get_dist(i, edges[i][3]) > get_dist(i, j)) {
						edges[i][3] = j;
					}
				}
			}
			else if(boxes[i].second == boxes[j].second) {
				if(boxes[i].first < boxes[j].first) {
					if(edges[i][2] == -1 || get_dist(i, edges[i][2]) > get_dist(i, j)) {
						edges[i][2] = j;
					}
				}
				else {
					if(edges[i][0] == -1 || get_dist(i, edges[i][0]) > get_dist(i, j)) {
						edges[i][0] = j;
					}
				}
			}
		}
	}

	for(int32_t i = 0; i < n; i++) {
		for(int32_t j = 0; j < m; j++) {
			if(boxes[i].first == stones[j].first) {
				if(boxes[i].second < stones[j].second) {
					if(edges[i][1] != -1 && get_dist(i, edges[i][1]) > abs(stones[j].second - boxes[i].second)) {
						edges[i][1] = -1;
					}
				}
				else {
					if(edges[i][3] != -1 && get_dist(i, edges[i][3]) > abs(stones[j].second - boxes[i].second)) {
						edges[i][3] = -1;
					}
				}
			}
			else if(boxes[i].second == stones[j].second) {
				if(boxes[i].first < stones[j].first) {
					if(edges[i][2] != -1 && get_dist(i, edges[i][2]) > abs(stones[j].first - boxes[i].first)) {
						edges[i][2] = -1;
					}
				}
				else {
					if(edges[i][0] != -1 && get_dist(i, edges[i][0]) > abs(stones[j].first - boxes[i].first)) {
						edges[i][0] = -1;
					}
				}
			}
		}
	}
}

void compute_ans() {
	int32_t cntBoxes = n;
	while(cntBoxes > 0) {
		std::vector< std::pair< int32_t, std::pair< int32_t, int32_t > > > v1, v2;
		for(int32_t i = 0; i < n; i++) {
			if(active[i]) {
				continue;
			}

			if(edges[i][0] != -1) {
				int32_t other = edges[i][0];		
			
				int32_t newCnt = 0;
				if((edges[other][0] == -1 && edges[i][2] != -1) || (edges[other][0] != -1 && edges[i][2] == -1)) {
					newCnt--;
				}
				if((edges[i][1] == -1 && edges[i][3] != -1) || (edges[i][1] != -1 && edges[i][3] == -1)) {
					newCnt--;
				}
				if((edges[other][1] == -1 && edges[other][3] != -1) || (edges[other][1] != -1 && edges[other][3] == -1)) {
					newCnt--;
				}

				v1.push_back({ newCnt, { i, 0 } });
			}
			else {
				int32_t newCnt = 0;
				if((edges[i][1] == -1 && edges[i][3] != -1) || (edges[i][1] != -1 && edges[i][3] == -1)) {
					newCnt--;
				}
				if(edges[i][2] != -1) {
					newCnt--;
				}
				
				v2.push_back({ newCnt, { i, 0 } });
			}

			if(edges[i][2] != -1) {
				int32_t other = edges[i][2];		
			
				int32_t newCnt = 0;
				if((edges[other][2] == -1 && edges[i][0] != -1) || (edges[other][2] != -1 && edges[i][0] == -1)) {
					newCnt--;
				}
				if((edges[i][1] == -1 && edges[i][3] != -1) || (edges[i][1] != -1 && edges[i][3] == -1)) {
					newCnt--;
				}
				if((edges[other][1] == -1 && edges[other][3] != -1) || (edges[other][1] != -1 && edges[other][3] == -1)) {
					newCnt--;
				}
				
				v1.push_back({ newCnt, { i, 2 } });
			}
			else {
				int32_t newCnt = 0;
				if((edges[i][1] == -1 && edges[i][3] != -1) || (edges[i][1] != -1 && edges[i][3] == -1)) {
					newCnt--;
				}
				if(edges[i][0] != -1) {
					newCnt--;
				}
				
				v2.push_back({ newCnt, { i, 2 } });
			}

			if(edges[i][1] != -1) {
				int32_t other = edges[i][1];		
			
				int32_t newCnt = 0;
				if((edges[other][1] == -1 && edges[i][3] != -1) || (edges[other][1] != -1 && edges[i][3] == -1)) {
					newCnt--;
				}
				if((edges[i][0] == -1 && edges[i][2] != -1) || (edges[i][0] != -1 && edges[i][2] == -1)) {
					newCnt--;
				}
				if((edges[other][0] == -1 && edges[other][2] != -1) || (edges[other][0] != -1 && edges[other][2] == -1)) {
					newCnt--;
				}

				v1.push_back({ newCnt, { i, 1 } });
			}
			else {
				int32_t newCnt = 0;
				if((edges[i][0] == -1 && edges[i][2] != -1) || (edges[i][0] != -1 && edges[i][2] == -1)) {
					newCnt--;
				}
				if(edges[i][3] != -1) {
					newCnt--;
				}

				v2.push_back({ newCnt, { i, 1 } });
			}

			if(edges[i][3] != -1) {
				int32_t other = edges[i][3];		
			
				int32_t newCnt = 0;
				if((edges[other][3] == -1 && edges[i][1] != -1) || (edges[other][3] != -1 && edges[i][1] == -1)) {
					newCnt--;
				}
				if((edges[i][0] == -1 && edges[i][2] != -1) || (edges[i][0] != -1 && edges[i][2] == -1)) {
					newCnt--;
				}
				if((edges[other][0] == -1 && edges[other][2] != -1) || (edges[other][0] != -1 && edges[other][2] == -1)) {
					newCnt--;
				}

				v1.push_back({ newCnt, { i, 3 } });
			}
			else {
				int32_t newCnt = 0;
				if((edges[i][0] == -1 && edges[i][2] != -1) || (edges[i][0] != -1 && edges[i][2] == -1)) {
					newCnt--;
				}
				if(edges[i][1] != -1) {
					newCnt--;
				}

				v2.push_back({ newCnt, { i, 3 } });
			}
		}
		
		std::sort(v1.begin(), v1.end());	
		std::reverse(v1.begin(), v1.end());
		
		std::sort(v2.begin(), v2.end());
		std::reverse(v2.begin(), v2.end());

		int32_t curr, other, dir;
		if(v1.size() != 0) {
			curr = v1[0].second.first;
			other = edges[curr][v1[0].second.second];
			dir = v1[0].second.second;

			active[curr] = true;
			cntBoxes--;
			if(other != -1) {
				active[other] = true;
				cntBoxes--;
			}

			int32_t x = boxes[curr].first + DELTA_R[v1[0].second.second]; 
			int32_t y = boxes[curr].second + DELTA_C[v1[0].second.second];
			ans.push_back({ (v1[0].second.second % 2 == 0 ? 0 : 1), { x, y } });
		}
		else {
			curr = v2[0].second.first;
			other = edges[curr][v2[0].second.second];
			dir = v2[0].second.second;

			active[curr] = true;
			cntBoxes--;
			if(other != -1) {
				active[other] = true;
				cntBoxes--;
			}

			int32_t x = boxes[curr].first + DELTA_R[v2[0].second.second]; 
			int32_t y = boxes[curr].second + DELTA_C[v2[0].second.second];
			ans.push_back({ (v2[0].second.second % 2 == 0 ? 0 : 1), { x, y } });
		}
		if(dir == 0) {
			if(edges[curr][3] != -1) {
				edges[edges[curr][3]][1] = edges[curr][1];
			}
			if(edges[curr][1] != -1) {
				edges[edges[curr][1]][3] = edges[curr][3];
			}

			if(other != -1) {
				if(edges[other][0] != -1) {
					edges[edges[other][0]][2] = edges[curr][2];
				}
				if(edges[curr][2] != -1) {
					edges[edges[curr][2]][0] = edges[other][0];
				}
			}
		}
		else if(dir == 1) {
			if(edges[curr][0] != -1) {
				edges[edges[curr][0]][2] = edges[curr][2];
			}
			if(edges[curr][2] != -1) {
				edges[edges[curr][2]][0] = edges[curr][0];
			}

			if(other != 0) {
				if(edges[other][1] != -1) {
					edges[edges[other][1]][3] = edges[curr][3];
				}
				if(edges[curr][3] != -1) {
					edges[edges[curr][3]][1] = edges[other][1];
				}
			}
		}
		else if(dir == 2) {
			if(edges[curr][3] != -1) {
				edges[edges[curr][3]][1] = edges[curr][1];
			}
			if(edges[curr][1] != -1) {
				edges[edges[curr][1]][3] = edges[curr][3];
			}

			if(other != -1) {
				if(edges[other][2] != -1) {
					edges[edges[other][2]][0] = edges[curr][0];
				}
				if(edges[curr][0] != -1) {
					edges[edges[curr][0]][2] = edges[other][2];
				}
			}
		}
		else {
			if(edges[curr][0] != -1) {
				edges[edges[curr][0]][2] = edges[curr][2];
			}
			if(edges[curr][2] != -1) {
				edges[edges[curr][2]][0] = edges[curr][0];
			}

			if(other != 0) {
				if(edges[other][3] != -1) {
					edges[edges[other][3]][1] = edges[curr][1];
				}
				if(edges[curr][1] != -1) {
					edges[edges[curr][1]][3] = edges[other][3];
				}
			}
		}
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n;

	for(int32_t i = 0; i < n; i++) {
		std::cin >> boxes[i].first >> boxes[i].second;
	}

	std::cin >> m;

	for(int32_t i = 0; i < m; i++) {
		std::cin >> stones[i].first >> stones[i].second;
	}

	memset(edges, -1, sizeof(edges));
	build_graph();
	
	compute_ans();

	std::cout << ans.size() << '\n';
	for(auto &x : ans) {
		std::cout << x.first << " " << x.second.first << " " << x.second.second << '\n';
	}
}
