#include<iostream>
#include<vector>
#include<queue>
#include<math.h>

using namespace std;

const int MAXN = 1E5;
const int MAXF = 1E6;

int n, m;
struct coordinates
{
    int x, y;
};
struct box_coordinates
{
    int ex;
    int x, y;
};
struct bomb_coordinates
{
    bool ori;
    int x, y;
};
box_coordinates box[MAXN+100];
coordinates stone[MAXN+100];
vector<int> con[MAXN+100];
vector<int> bx[MAXF+10], by[MAXF+10];
vector<int> sx[MAXF+10], sy[MAXF+10];

vector<bomb_coordinates> bomb;

void input()
{
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>box[i].x>>box[i].y;
        bx[box[i].x/1000].push_back(i);
        by[box[i].y/1000].push_back(i);
    }

    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>stone[i].x>>stone[i].y;
        sx[stone[i].x/1000].push_back(i);
        sy[stone[i].y/1000].push_back(i);
    }

}

void output()
{
    cout<<bomb.size()<<'\n';
    for (int i=0; i<bomb.size(); i++)
    {
        cout<<bomb[i].ori<<' '<<bomb[i].x<<' '<<bomb[i].y<<'\n';
    }
}

void MakeConnections()
{
    bool check;
    for (int j=0; j<n; j++)
    {
        for (int z=0; z<j; z++)
        {
            check = 0;
            for (int v=0; v<m; v++)
            {
                if (box[j].x==stone[v].x)
                {
                    if (!(box[j].x==box[z].x &&
                    ((box[j].y>stone[v].y && box[z].y>stone[v].y) ||
                     (box[j].y<stone[v].y && box[z].y<stone[v].y))))
                     {
                         check = 1;
                         break;
                     }
                }

                if (stone[v].y==box[j].y)
                {
                    if (!(box[j].y==box[z].y &&
                    ((box[j].x>stone[v].x && box[z].x>stone[v].x) ||
                     (box[j].x<stone[v].x && box[z].x<stone[v].x))))
                     {
                         check = 1;
                         break;
                     }
                }
            }
            if (!check)
            {
                con[j].push_back(z);
                con[z].push_back(j);
            }
        }
    }
}

void TopologySorting() //tva sys sigurnsot ne e taka na anglijski
{
    int cc = n;
    int curr;
    int mm = -1, mn=-1;
    queue<int> ts;

    for (int i=0; i<n; i++)
    {
        if (con[i].size()<2) ts.push(i);
    }

    while (cc>0)
    {
        if (ts.empty())
        {
            for (int i=0; i<n; i++)
            {
                if (!box[i].ex)
                {
                    ts.push(i);
                    for (int j=0; j<con[i].size(); j++)
                    {
                        if (box[i].x==box[con[i][j]].x)
                        {
                            if (mm>fabs(box[con[i][j]].y-box[i].y) && !box[con[i][j]].ex)
                            {
                                mm = fabs(box[con[i][j]].y-box[i].y);
                                mn = con[i][j];
                            }
                        }
                        else
                        {
                            if (mm>fabs(box[con[i][j]].x-box[i].x) && !box[con[i][j]].ex)
                            {
                                mm = fabs(box[con[i][j]].x-box[i].x);
                                mn = con[i][j];
                            }
                        }
                    }
                    if (mn>0) swap (con[i][0], con[i][mn]);
                    break;
                }
            }
        }

        curr = ts.front();
        ts.pop();
        if (box[curr].ex) continue;
        box[curr].ex = 1;
        cc--;
        if (con[curr].size()==1)
        {
            if (box[con[curr][0]].ex) bomb.push_back({1, box[curr].x, box[curr].y+1});
            else
            {
                box[con[curr][0]].ex = 1;
                cc--;
                if (box[curr].x==box[con[curr][0]].x)
                {
                    if (box[curr].y<box[con[curr][0]].y) bomb.push_back({1, box[curr].x, box[curr].y+1});
                    else bomb.push_back({1, box[curr].x, box[curr].y-1});
                }
                else
                {
                    if (box[curr].x<box[con[curr][0]].x) bomb.push_back({0, box[curr].x+1, box[curr].y});
                    else bomb.push_back({0, box[curr].x-1, box[curr].y});
                }
                for (int i=0; i<con[con[curr][0]].size(); i++)
                {
                    for (int j=0; j<con[con[con[curr][0]][i]].size(); j++)
                    {
                        if (con[con[con[curr][0]][i]][j]==curr)
                        {
                            swap(con[con[con[curr][0]][i]][con[con[con[curr][0]][i]].size()-1], con[con[con[curr][0]][i]][j]);
                            con[con[con[curr][0]][i]].pop_back();
                            break;
                        }
                    }
                    if (con[con[con[curr][0]][i]].size()<2 && !box[con[con[curr][0]][i]].ex) ts.push(con[con[curr][0]][i]);
                }
            }
        }
        else if (con[curr].size()==0)
        {
            bomb.push_back({1, box[curr].x, box[curr].y+1});
        }
        else
        {
            box[con[curr][0]].ex = 1;
            cc--;
            if (box[curr].x==box[con[curr][0]].x)
            {
                if (box[curr].y<box[con[curr][0]].y) bomb.push_back({1, box[curr].x, box[curr].y+1});
                else bomb.push_back({1, box[curr].x, box[curr].y-1});
            }
            else
            {
                if (box[curr].x<box[con[curr][0]].x) bomb.push_back({0, box[curr].x+1, box[curr].y});
                else bomb.push_back({0, box[curr].x-1, box[curr].y});
            }
            for (int i=0; i<con[con[curr][0]].size(); i++)
            {
                for (int j=0; j<con[con[con[curr][0]][i]].size(); j++)
                {
                    if (con[con[con[curr][0]][i]][j]==curr)
                    {
                        swap(con[con[con[curr][0]][i]][con[con[con[curr][0]][i]].size()-1], con[con[con[curr][0]][i]][j]);
                        con[con[con[curr][0]][i]].pop_back();
                        break;
                    }
                }
                if (con[con[con[curr][0]][i]].size()<2 && !box[con[con[curr][0]][i]].ex) ts.push(con[con[curr][0]][i]);
            }
            for (int i=0; i<con[curr].size(); i++)
            {
                for (int j=0; j<con[con[curr][i]].size(); j++)
                {
                    if (con[con[curr][i]][j]==curr)
                    {
                        swap(con[con[curr][i]][con[con[curr][i]].size()-1], con[con[curr][i]][j]);
                        con[con[curr][i]].pop_back();
                        break;
                    }
                }
                if (con[con[curr][i]].size()<2 && !box[con[curr][i]].ex) ts.push(con[curr][i]);
            }
        }

        /*for (int i=0; i<n; i++)
        {
            cerr<<box[i].ex<<' ';
        }cerr<<endl;*/
    }
}

void solve()
{
    MakeConnections();
    TopologySorting();
}

int main()
{
    ios::sync_with_stdio(false);
    //cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

/*
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9

*/
