#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5;
const int MAXM = 1e5 * 4;
const int INF = 1e9;

struct Edge
{
    int to, next, c;

    Edge(){};
    Edge(int _to, int _next, int _c)
    {
        to = _to; next = _next; c = _c;
    }
};

int n;
int head[MAXN * 4], br;
Edge e[MAXM];
map <int, int> st;
int timer;

int get_ind(int ft)
{
    if(st[ft] == 0)
    {
        st[ft] = timer++;
    }
    return st[ft];
}

set <int> s;
pair <int, int> prt[MAXN];

void add_edge(int v, int w, int c)
{
    e[br] = Edge(w, head[v], c);
    head[v] = br++;
}

int source, target;

void read_input()
{
    scanf("%d", &n);

    for(int i = 0; i < MAXN * 4; i++)
    {
        head[i] = -1;
    }
    int a, b, c, d;
    timer = n;
    for(int i = 0; i < n; i++)
    {
        scanf("%d %d %d %d", &a, &b, &c, &d);

        a = get_ind(a);
        c = get_ind(c);

        prt[i] = {a, c};

        s.insert(a);
        s.insert(c);

        add_edge(i, a, 1);
        add_edge(a, i, 0);

        add_edge(i, c, 1);
        add_edge(c, i, 0);

    }

    source = timer++;
    target = timer++;

    for(auto x : s)
    {
        //printf("%d %d\n", x, target);
        add_edge(x, target, 1);
        add_edge(target, x, 0);
    }

    for(int i = 0; i < n; i++)
    {
        add_edge(source, i, 1);
        add_edge(i, source, 0);
    }
}

int lvl[MAXN * 4], pr[MAXN * 4];

bool bfs(int v, int w)
{
    for(int i = 0; i < timer; i++)
    {
        lvl[i] = -1;
    }

    queue <int> q;
    q.push(v);
    lvl[v] = 0;

    while(!q.empty())
    {
        int temp = q.front(); q.pop();

        for(int z = head[temp]; z != -1; z = e[z].next)
        {
            int to = e[z].to;

            if(lvl[to] == -1 && e[z].c > 0)
            {
                q.push(to);
                lvl[to] = lvl[temp] + 1;
            }
        }
    }

    return lvl[w] != -1;
}

int dfs(int v, int flow)
{
    if(v == target)
    {
        return flow;
    }

    for(int z = head[v]; z != -1; z = e[z].next)
    {
        int to = e[z].to;
        int cp = e[z].c;

        if(lvl[to] == lvl[v] + 1 && cp > 0)
        {
            int aug_flow = dfs(to, min(flow, cp));
            if(aug_flow)
            {
                e[z].c -= aug_flow;
                e[z ^ 1].c += aug_flow;
                return aug_flow;
            }
        }
    }
    return 0;
}

int dinic()
{
    int ans = 0;
    while(bfs(source, target))
    {
        for(int i = 0; i < timer; i++)
        {
            pr[i] = head[i];
        }

        int delta;
        do
        {
            delta = dfs(source, INF);
            ans += delta;
        }while(delta);
    }
    return ans;
}

int answer[MAXN];

void solve()
{
    int temp = dinic();

    //printf("%d\n", temp);

    if(temp != n)
    {
        printf("No\n");
        return;
    }
    else
    {
        printf("Yes\n");
        for(int i = 0; i < n; i++)
        {
            for(int z = head[i]; z != -1; z = e[z].next)
            {
                int to = e[z].to;
                int cp = e[z].c;

                if(cp == 0 && to != source)
                {
                    answer[i] = to;
                    break;
                }
            }
        }
        for(int i = 0; i < n; i++)
        {
            int answr = 1;
            if(prt[i].second == answer[i]) answr++;
            printf("%d\n", answr);
        }
    }
}

int main()
{
    read_input();
    solve();

    return 0;
}


/*
3
0 0 1 6
2 2 3 4
1 3 5 5

*/
