#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

const int MAXN = 4e3 + 5;

struct singer
{
    pair <int, int> a, b;
    int index;
};

bool cmp1(const singer A, const singer B)
{
    if(A.a!=B.a) return A.a<B.a;
    return A.b<B.b;
}

bool cmp2(const singer A, const singer B)
{
    if(A.b!=B.b) return A.b<B.b;
    return A.a<B.a;
}

bool areIntersecting(pair <int, int> x, pair <int, int> y)
{
    if(x.first<=y.first && y.first<=x.second) return true;
    if(y.first<=x.first && x.first<=y.second) return true;
    return false;
}

int n;
singer s[MAXN];

int codeNum = 0;
map <int, int> code;

int memo[MAXN][MAXN];
pair <int, int> pos[MAXN];
singer order1[MAXN], order2[MAXN];

int compress(int x)
{
    if(code.count(x)==false)
    {
        code[x] = codeNum;
        codeNum++;

        return codeNum - 1;
    }

    return code[x];
}

void Init()
{
    set <int> values;
    for(int i = 0;i<n;i++)
    {
        values.insert(s[i].a.first);
        values.insert(s[i].a.second);

        values.insert(s[i].b.first);
        values.insert(s[i].b.second);
    }

    for(auto it = values.begin();it!=values.end();it++)
    {
        compress(*it);
    }

    for(int i = 0;i<n;i++)
    {
        //s[i].a.first = compress(s[i].a.first);
    }
}

bool check1(pair <int, int > x, int p1)
{
    for(int i = 0;i<p1;i++)
    {
        if(areIntersecting(order1[i].a, x)==true)
        {
            return false;
        }
    }

    return true;
}

bool check2(pair <int, int> x, int p2)
{
    for(int i = 0;i<p2;i++)
    {
        if(areIntersecting(order2[i].b, x)==true)
        {
            return false;
        }
    }

    return true;
}

int answer[MAXN];
void bruteForce(int index)
{
    if(index==n)
    {
        cout << "Yes" << '\n';
        for(int i = 0;i<n;i++)
        {
            cout << answer[i] << '\n';
        }

        exit(0);
    }

    //1
    bool fail = false;
    for(int i = 0;i<index;i++)
    {
        if(answer[i]==1 && areIntersecting(s[i].a, s[index].a)==true)
        {
            fail = true;
            break;
        }
        if(answer[i]==2 && areIntersecting(s[i].b, s[index].a)==true)
        {
            fail = true;
            break;
        }
    }
    if(fail==false)
    {
        answer[index] = 1;
        bruteForce(index+1);
    }

    //2
    fail = false;
    for(int i = 0;i<index;i++)
    {
        if(answer[i]==1 && areIntersecting(s[i].a, s[index].b)==true)
        {
            fail = true;
            break;
        }
        if(answer[i]==2 && areIntersecting(s[i].b, s[index].b)==true)
        {
            fail = true;
            break;
        }
    }
    if(fail==false)
    {
        answer[index] = 2;
        bruteForce(index+1);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    for(int i = 0;i<n;i++)
    {
        cin >> s[i].a.first >> s[i].a.second;
        cin >> s[i].b.first >> s[i].b.second;
        s[i].index = i;

        order1[i] = s[i];
        order2[i] = s[i];
    }

    sort(order1, order1+n, cmp1);
    sort(order2, order2+n, cmp2);

    for(int i = 0;i<n;i++)
    {
        pos[ order1[i].index ].first = i;
        pos[ order2[i].index ].second = i;
    }

    bruteForce(0);
    cout << "No" << '\n';
}
