#include <iostream>
#include <bitset>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;

/*
№1->res   carry
0 -> 0      0
1 -> 1      0
2 -> 0      1
3 -> 1      1
4 -> 0      2
5 -> 1      2
*/

typedef unsigned long long ull;

ull craft101(int n) {
	ull out = 0;
	for(int i = 0;i < n;i += 2) {
		out |= (1ull << (n-i-1));
	}
	return out;
}

inline ull craft111(int n) {
	return (1ull << n) - 1;
}

bool poss(ull target, ull sumables, int from) {
	if(target == 0) return true;
	if(sumables == 0) return false;

	for(int i = from;;i ++) {
		const ull curr = craft111(i);
		if(curr > target) break;
		if(poss(target - curr, sumables - 1, i+1)) return true;
	}	
	return false;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	int n;
	cin >> n;

	//cout << std::bitset<20>(craft101(n)) << endl;
	//cout << std::bitset<20>(craft111(n)) << endl;

	for(int i = 1;i < 30;i ++) {
		bool p = poss(craft101(n), i, 1);
		//cout << i << '.' << p << endl;
		if(p){
			cout << i << endl;
			break;
		}
	}
	//cout << endl;
	return 0;
}