#include <iostream>
#include <vector>
#include <queue>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;

const int MAX_N = 1e3 + 10;
int a[MAX_N], b[MAX_N], c[MAX_N], d[MAX_N];

std::vector<int> graph[2 * MAX_N];
int n;

void add(int a, int b) {
	graph[a].push_back(b);
}

bool inter(int a, int b, int c, int d) {
	if(c <= a and a <= d) return true;
	if(c <= b and b <= d) return true;
	if(a <= c and c <= b) return true;
	if(a <= d and d <= b) return true;
	return false;
}

void gen_graph() {
	// TODO O(N)

	for(int i = 0;i < n;i ++) {
		for(int j = 0;j < n;j ++) {
			if(i == j) continue;
			if(!inter(a[i], b[i], a[j], b[j]) and b[i] < a[j]) add(i*2 + 0, j*2 + 0);
			if(!inter(a[i], b[i], c[j], d[j]) and b[i] < c[j]) add(i*2 + 0, j*2 + 1);
			if(!inter(c[i], d[i], a[j], b[j]) and d[i] < a[j]) add(i*2 + 1, j*2 + 0);
			if(!inter(c[i], d[i], c[j], d[j]) and d[i] < c[j]) add(i*2 + 1, j*2 + 1);
		}
	}	

	/*
	for(int i = 0;i < 2*n;i ++) {
		cout << i << ") ";
		for(auto nei : graph[i]) {
			cout << nei << ' ';
		}
		cout << endl;
	}
	*/
}

int from[MAX_N][MAX_N*2];
int ANS = -1;
bool idk() { 
	std::vector<int> q, nq;
	for(int i = 0;i < 2*n;i ++) q.push_back(i);

	for(int step = 0;step < n-1;step ++) {
		std::fill(from[step], from[step] + 2*n, -1);
		/*
		cout << "step " << step << ")";
		for(auto x : q) {
			cout << x << ' ';
		}
		cout << endl;
		*/
		for(int ci = 0;ci < q.size();ci ++) {
			const int curr = q[ci];
			for(auto nei : graph[curr]) {
				if(from[step][nei] != -1) continue;
				from[step][nei] = curr;
				nq.push_back(nei);
			}
		}
		/*
		cout << "end from" << endl;
		for(int i = 0;i < 2*n;i ++) {
			cout << i << '.' << from[step][i] << endl;
		}
		cout << endl;
		*/
		q = nq;
		nq.clear();
	}

	/*
	cout << "idk final) ";
	for(auto x : q) {
		cout << x << ' ';
	}
	cout << endl;
	*/

	if(q.empty()) return false;
	ANS = q[0];
	return true;
}

void path(int curr) {
	std::vector<int> ans;	
	for(int step = n-2;step >= 0;step --) {
		//cout << "path " << step << ' ' << curr << endl;
		ans.push_back(curr);
		curr = from[step][curr];
	}
	//cout << "path begin " << curr << endl;
	ans.push_back(curr);

	for(int i = ans.size()-1;i >= 0;i --) cout << (ans[i] % 2) + 1 << '\n';
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	cin >> n;
	for(int i = 0;i < n;i ++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
	}
	
	gen_graph();

	if(idk()) {
		cout << "Yes" << endl;
		path(ANS);
		return 0;
	}

	cout << "No" << endl;
	return 0;
}