#include <iostream>
#include <vector>
#include <bitset>
#include <random>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;

const int MAX_N = 1e3 + 10;
int a[MAX_N], b[MAX_N], c[MAX_N], d[MAX_N];

std::vector<int> graph[2 * MAX_N];
int n;

void add(int a, int b) {
	graph[a].push_back(b);
}

bool inter(int a, int b, int c, int d) {
	if(c <= a and a <= d) return true;
	if(c <= b and b <= d) return true;
	if(a <= c and c <= b) return true;
	if(a <= d and d <= b) return true;
	return false;
}

bool dp[MAX_N][2];

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	cin >> n;
	for(int i = 0;i < n;i ++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
	}

	std::random_device rd;
	std::default_random_engine eng(rd());
	std::uniform_int_distribution<int> dist(0, 1);

	std::vector<int> S(n);
	while(true) {
		for(int i = 0;i < n;i ++) S[i] = dist(eng);
		bool fail = false;
		for(int i = 0;i < n;i ++) {
			int x, y;
			if(S[i] == 0) { x = a[i]; y = b[i]; }
			else          { x = c[i]; y = d[i]; }
			for(int j = i+1;j < n;j ++) {
				int z, w;
				if(S[j] == 0) { z = a[j]; w = b[j]; }
				else          { z = c[j]; w = d[j]; }
				if(inter(x, y, z, w)) {
					fail = true;
					break;
				}
			}
			if(fail) break;
		}
		if(!fail) {
			cout << "Yes\n";
			for(int i = 0;i < n;i ++) cout << S[i] + 1 << '\n';
			return 0;
		}
	}

	cout << "No" << endl;
	return 0;
}