#include <iostream>
#include <vector>
#include <bitset>
#include <random>

#pragma GCC optimize "O3"
using std::cin; using std::cout; using std::endl;

const int MAX_N = 1e5 + 10;
int a[MAX_N], b[MAX_N], c[MAX_N], d[MAX_N], n;

constexpr inline bool inter(int a, int b, int c, int d) {
	return (c <= a and a <= d) or (c <= b and b <= d) or (a <= c and c <= b) or (a <= d and d <= b);
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	cin >> n;
	for(int i = 0;i < n;i ++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
	}

	std::random_device rd;
	std::default_random_engine eng(rd());
	std::uniform_int_distribution<int> dist(0, 1);

	std::vector<int> S(n);
	for(int i = 0;i < n;i ++) S[i] = dist(eng);
	int cnt = 0;
	while(true) {
		cnt ++;
		bool fail = false;
		for(int i = 0;i < n;i ++) {
			int x, y;
			if(S[i] == 0) { x = a[i]; y = b[i]; }
			else          { x = c[i]; y = d[i]; }
			for(int j = i+1;j < n;j ++) {
				int z, w;
				if(S[j] == 0) { z = a[j]; w = b[j]; }
				else          { z = c[j]; w = d[j]; }
				if(inter(x, y, z, w)) {
					fail = true;
					S[i] = dist(eng);
					S[j] = dist(eng);
					break;
				}
			}
			if(fail) break;
		}
		if(!fail) {
			cout << "Yes\n";
			for(int i = 0;i < n;i ++) cout << S[i] + 1 << '\n';
			return 0;
		}
		if((cnt & 0b11111) == 0) {
			clock_t time = clock();
			if(time > 2.5 * CLOCKS_PER_SEC) break;
		}
	}

	cout << "No" << endl;
	return 0;
}