#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

class Point {
public:
	int x;
	int add;

	Point(int x, int add) {
		this->x = x;
		this->add = add;
	}

	bool operator <(const Point &other) const {
		if (this->x == other.x) {
			return this->add > other.add;
		}

		return this->x < other.x;
	}
};

int n;
vector<pair<pair<Point, Point>, pair<Point, Point>>> people;

bool good(int mask) {
	vector<Point> line;
	for (int i = 0; i < n; i++) {
		if (mask & (1 << i)) {
			line.emplace_back(people[i].second.first);
			line.emplace_back(people[i].second.second);
		} else {
			line.emplace_back(people[i].first.first);
			line.emplace_back(people[i].first.second);
		}
	}

	sort(line.begin(), line.end());

	int depth = 0;
	for (auto &i : line) {
		depth += i.add;

		if (depth > 1) {
			return false;
		}
	}

	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> n;

	people.reserve(n + 1);
	for (int i = 0; i < n; i++) {
		int si, ei, sj, ej;
		cin >> si >> ei >> sj >> ej;

		pair<Point, Point> first = {{si, 1}, {ei, -1}};
		pair<Point, Point> second = {{sj, 1}, {ej, -1}};

		people.emplace_back(first, second);
	}

	for (int mask = 0; mask < (1 << n); mask++) {
		if (good(mask)) {
			cout << "Yes\n";
			for (int i = 0; i < n; i++) {
				if (mask & (1 << i)) {
					cout << 2 << endl;
				} else {
					cout << 1 << endl;
				}
			}

			return EXIT_SUCCESS;
		}
	}

	cout << "No\n";

	return EXIT_SUCCESS;
}