#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 100000;
const int MAX_VAR = 2 * MAX_N;     // Una pentru fiecare concert
const int MAX_NODES = 2 * MAX_VAR; // Afirmatia si negatia pentru fiecare variabila

int negation[1+MAX_NODES];

/***********    TARJAN    **************/

int lastid;
int low[1+MAX_NODES], id[1+MAX_NODES];
int stiva[1+MAX_NODES], top;
bool inStiva[1+MAX_NODES];
int SATsolution[1+MAX_NODES];

vector<int> graph[1+MAX_NODES];

int variablePrep(int N) { // Am N variabile
	for(int i = 1; i <= N; ++i) {
		negation[i] = i + N;
		negation[i + N] = i;
		SATsolution[i] = SATsolution[i + N] = -1;
	}
	return 2 * N;
}

void insertImplication(int a, int b) {
	graph[a].push_back(b);
}

void addXorRelation(int a, int b) { // a xor b == true
	insertImplication(a, negation[b]);
	insertImplication(negation[a], b);
	insertImplication(b, negation[a]);
	insertImplication(negation[b], a);
}

void addNandRelation(int a, int b) {
	insertImplication(a, negation[b]);
	insertImplication(b, negation[a]);
}

vector<int> getNeighbours(int nod) {
	return graph[nod];
}

bool SATfailure = false;

void Tarjan(int nod) {
	vector<int> graph = getNeighbours(nod);

	stiva[top++] = nod;
	inStiva[nod] = true;
	id[nod] = low[nod] = ++lastid;

	for(auto it: graph) {
		if(id[it] == 0) {
			Tarjan(it);
			low[nod] = min(low[nod], low[it]);
		} else if(inStiva[it])
			low[nod] = min(low[nod], low[it]);
	}

	//low[nod] = min(low[nod], lowRange(...));
	if(low[nod] == id[nod]) {
		int restriction = -1;

		vector<int> SCcomp;
		do {
			--top;
			SCcomp.push_back(stiva[top]);
			if(SATsolution[stiva[top]] != -1 && restriction == -1)
				restriction = SATsolution[stiva[top]];
			else if(SATsolution[stiva[top]] != -1 && SATsolution[stiva[top]] != restriction)
				SATfailure = true;
		} while(stiva[top] != nod);
		
		if(restriction == -1)
			restriction = 1;
		for(auto it: SCcomp) {
			SATsolution[it] = restriction;
			if(SATsolution[negation[it]] == restriction)
				SATfailure = true;
			SATsolution[negation[it]] = 1 - restriction;
		}
	}

	inStiva[nod] = false;
}

struct Artist {
	int l1, r1, l2, r2;
} artist[1+MAX_N];

bool rangeIntersect(int l1, int r1, int l2, int r2) {
	return max(l1, l2) <= min(r1, r2);
}

int main() {
	int N, NV;
	scanf("%d", &N);
	for(int i = 1; i <= N; ++i)
		scanf("%d%d%d%d", &artist[i].l1, &artist[i].r1, &artist[i].l2, &artist[i].r2);

	NV = variablePrep(N);

	for(int i = 1; i <= N; ++i) {
		for(int j = i + 1; j <= N; ++j) {
			if(rangeIntersect(artist[i].l1, artist[i].r1, artist[j].l1, artist[j].r1)) {
				addNandRelation(negation[i], negation[j]);
			}
			if(rangeIntersect(artist[i].l1, artist[i].r1, artist[j].l2, artist[j].r2))
				addNandRelation(negation[i], j);
			if(rangeIntersect(artist[i].l2, artist[i].r2, artist[j].l1, artist[j].r1))
				addNandRelation(i, negation[j]);
			if(rangeIntersect(artist[i].l2, artist[i].r2, artist[j].l2, artist[j].r2))
				addNandRelation(i, j);
		}
	}

	for(int i = 1; i <= NV; ++i)
		if(id[i] == 0)
			Tarjan(i);
	
	if(SATfailure)
		printf("No");
	else {
		printf("Yes\n");
		for(int i = 1; i <= N; ++i)
			printf("%d\n", SATsolution[i] + 1);
	}
	return 0;
}

