#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <stack>
#define ll long long


using namespace std;

map <int, int> mp;

inline int norm(vector <int> vals) {
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    for(int i = 0; i < vals.size(); i++) {
        mp[vals[i]] = i + 1;
    }
    return vals.size();
}

int main() {
#ifdef HOME
    ifstream cin("A.in");
    ofstream cout("A.out");
#endif // HOME
    int i, n;
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n;

    vector <int> a(n), b(n), c(n), d(n);
    vector <int> vals;
    for(i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i] >> d[i];
        b[i]++, d[i]++;
        vals.push_back(a[i]);
        vals.push_back(b[i]);
        vals.push_back(c[i]);
        vals.push_back(d[i]);
    }

    int sz = norm(vals);
    vector <int> sp(sz + 2);

    for(i = 0; i < n; i++) {
        a[i] = mp[a[i]], b[i] = mp[b[i]], c[i] = mp[c[i]], d[i] = mp[d[i]];
    }

    for(int conf = 0; conf < (1 << n); conf++) {
        fill(sp.begin(), sp.end(), 0);
        for(i = 0; i < n; i++) {
            if(conf & (1 << i)) {
                sp[a[i]]++, sp[b[i]]--;
            }
            else {
                sp[c[i]]++, sp[d[i]]--;
            }
        }
        bool ok = 1;
        for(i = 1; i <= sz; i++) {
            sp[i] += sp[i - 1];
            if(sp[i] > 1) {
                ok = 0;
            }
        }
        if(ok) {
            cout << "Yes\n";
            for(i = 0; i < n; i++) {
                cout << 2 - ((conf & (1 << i)) > 0) << "\n";
            }
            return 0;
        }
    }

    cout << "No";

    return 0;
}
