#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <queue>
#include <stack>
#define ll long long


using namespace std;

const int MAXN = (int) 4e3;

struct Point {
    int x, y;
};

Point box[MAXN + 1], rock[MAXN + 1];
map <int, int> mpx, mpy;

inline int norm(vector <int> vals, map <int, int> &mp) {
    sort(vals.begin(), vals.end());
    vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
    for(int i = 0; i < vals.size(); i++) {
        mp[vals[i]] = i + 1;
    }
    return vals.size();
}

bool edge[MAXN + 1][MAXN + 1];
int sp[MAXN + 1][MAXN + 1], deg[MAXN + 1];

inline int get(int l1, int c1, int l2, int c2) {
    return sp[l2][c2] - sp[l1 - 1][c2] - sp[l2][c1 - 1] + sp[l1 - 1][c1 - 1];
}

struct Op {
    int dir, x, y;
};

inline void del(int nod, int n) {
    for(int i = 1; i <= n; i++) {
        if(edge[i][nod]) {
            deg[i]--;
        }
    }
}

int main() {
#ifdef HOME
    ifstream cin("A.in");
    ofstream cout("A.out");
#endif // HOME
    int i, j, n, m;
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n;
    vector <int> valsx, valsy;
    for(i = 1; i <= n; i++) {
        cin >> box[i].x >> box[i].y;
        valsx.push_back(box[i].x);
        valsy.push_back(box[i].y);
    }
    cin >> m;
    for(i = 1; i <= m; i++) {
        cin >> rock[i].x >> rock[i].y;
        valsx.push_back(rock[i].x);
        valsy.push_back(rock[i].y);
    }

    int mxx = norm(valsx, mpx);
    int mxy = norm(valsy, mpy);

    for(i = 1; i <= m; i++) {
        sp[mpx[rock[i].x]][mpy[rock[i].y]]++;
    }
    for(i = 1; i <= mxx; i++) {
        for(j = 1; j <= mxy; j++) {
            sp[i][j] += sp[i - 1][j] + sp[i][j - 1] - sp[i - 1][j - 1];
        }
    }

    vector <int> bx(n + 1), by(n + 1);
    for(i = 1; i <= n; i++) {
        bx[i] = mpx[box[i].x];
        by[i] = mpy[box[i].y];
    }

    for(i = 1; i <= n; i++) {
        for(j = i + 1; j <= n; j++) {
            int x1 = min(bx[i], bx[j]), x2 = max(bx[i], bx[j]);
            int y1 = min(by[i], by[j]), y2 = max(by[i], by[j]);

            if((x1 == x2 || y1 == y2) && get(x1, y1, x2, y2) == 0) {
                edge[i][j] = edge[j][i] = 1;
                deg[i]++, deg[j]++;
            }
        }
    }

    vector <bool> vis(n + 1);
    vector <Op> sol;

    int cnt = 0;
    while(cnt < n) {
        int mn = n + 1, id = -1;
        for(i = 1; i <= n; i++) {
            if(vis[i] == 0 && mn > deg[i]) {
                mn = deg[i];
                id = i;
            }
        }

        int mn2 = n + 1, id2 = -1;
        for(i = 1; i <= n; i++) {
            if(vis[i] == 0 && edge[id][i] && mn2 > deg[i]) {
                mn2 = deg[i];
                id2 = i;
            }
        }

        //cerr << id << " " << id2 << "\n";

        vis[id] = 1, cnt++;
        del(id, n);

        Op cur;
        if(id2 == -1) {
            cur.dir = 1, cur.x = box[id].x + 1, cur.y = box[id].y;
            sol.push_back(cur);
        }
        else {
            vis[id2] = 1, cnt++;
            if(box[id].x == box[id2].x) {
                cur.dir = 0, cur.x = box[id].x, cur.y = min(box[id].y, box[id2].y) + 1;
                sol.push_back(cur);
            }
            else {
                cur.dir = 1, cur.x = min(box[id].x, box[id2].x) + 1, cur.y = box[id].y;
                sol.push_back(cur);
            }
            del(id2, n);
        }
    }

    cout << sol.size() << "\n";
    for(i = 0; i < sol.size(); i++) {
        cout << sol[i].dir << " " << sol[i].x << " " << sol[i].y << "\n";
    }

    return 0;
}
