#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

const int MAX_N = 2e5 + 10;
int a[MAX_N], b[MAX_N];
int comp[MAX_N];
vector<int> e[MAX_N];
vector<int> e0[MAX_N];

vector<int> ord;
int viz[MAX_N];

void dfs1(int u) {
    viz[u] = 1;
    for (int v : e[u])
        if (!viz[v])
            dfs1(v);
    ord.push_back(u);
}

int c = 0;
void dfs2(int u) {
    comp[u] = c;
    for (int v : e0[u])
        if (!comp[v])
            dfs2(v);
}

#define neg(x) (x <= n ? x + n : x - n)

int main() {
    freopen("input.txt", "r", stdin);

    int n;
    cin >> n;

    if (n >= 4e3)
        return 0;

    for (int i = 1; i <= n; i++)
        cin >> a[i] >> b[i] >> a[i + n] >> b[i + n];

    for (int i = 1; i <= 2 * n; i++)
        for (int j = i + 1; j <= 2 * n; j++)
            if (i != j && max(a[i], a[j]) <= min(b[i], b[j])) {
                e[i].push_back(neg(j)); /// i -> not j
                e[j].push_back(neg(i)); /// j -> not i
            }

    for (int i = 1; i <= 2 * n; i++)
        for (int j : e[i])
            e0[j].push_back(i);

    for (int i = 1; i <= 2 * n; i++)
        if (viz[i] == 0)
            dfs1(i);

    for (int i = 2 * n - 1; i >= 0; i--) {
        if (!comp[ord[i]]) {
            c++;
            dfs2(ord[i]);
        }
    }


    int i = 1;
    while (i <= n && comp[i] != comp[i + n])
        i++;
    if (i <= n) {
        cout << "No" << endl;
        return 0;
    }

    cout << "Yes" << endl;
    for (int i = 1; i <= n; i++) {
        if (comp[i] > comp[i + n])
            cout << "1\n";
        else
            cout << "2\n";
    }

    return 0;
}
