#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <set>

#define neg(x) (x <= n ? x + n : x - n)

using namespace std;

const int MAX_N = 2e5 + 10;
int a[MAX_N], b[MAX_N];
int p[MAX_N];
int comp[MAX_N];
vector<int> e[MAX_N];
vector<int> e0[MAX_N];

int inc[MAX_N];
int rest[MAX_N];

vector<int> ord;
int viz[MAX_N];
set<pair<int, int>> not_viz;

int n;

void dfs1(int u) {
    viz[u] = 1;
    do {
        auto x = not_viz.lower_bound({a[u], -1});
        if (x == not_viz.end() || x->first > b[u])
            break;
        int v = x->second;
        not_viz.erase(x);
        if (!viz[v] && v != neg(u)) {
            dfs1(v);
        }
    } while (1);
    int x = inc[u];
    while (x != 0 && !rest[x]) {
        rest[x] = 1;
        if (!viz[neg(x)])
            dfs1(neg(x));
        x = inc[x];
    }
    ord.push_back(u);
}

int c = 0;
void dfs2(int u) {
    comp[u] = c;
    do {
        auto x = not_viz.lower_bound({a[neg(u)], -1});
        if (x == not_viz.end() || x->first > b[neg(u)])
            break;
        int v = x->second;
        not_viz.erase(x);
        if (!comp[v] && v != neg(u)) {
            dfs2(v);
        }
    } while (1);
    int x = inc[neg(u)];
    while (x != 0 && !rest[x]) {
        rest[x] = 1;
        if (!comp[x])
            dfs2(x);
        x = inc[x];
    }
}

bool cmp(int x, int y) {
    return a[x] != a[y] ? a[x] < a[y] : b[x] > b[y];
}

int main() {
    freopen("input.txt", "r", stdin);

    cin >> n;

    for (int i = 1; i <= n; i++) {
        cin >> a[i] >> b[i] >> a[i + n] >> b[i + n];
        p[i] = i;
        p[i + n] = i + n;
    }

    sort(p + 1, p + 2 * n + 1, cmp);
    vector<int> stk;
    stk.push_back(0);
    b[0] = 2e9;
    for (int i = 1; i <= 2 * n; i++) {
        while (b[p[i]] >= b[stk.back()])
            stk.pop_back();
        inc[p[i]] = stk.back();
        stk.push_back(p[i]);
    }

    for (int i = 1; i <= 2 * n; i++) {
        not_viz.emplace(a[i], neg(i));
        not_viz.emplace(b[i], neg(i));
    }

    for (int i = 1; i <= 2 * n; i++)
        if (viz[i] == 0)
            dfs1(i);

    not_viz.clear();
    for (int i = 1; i <= 2 * n; i++) {
        rest[i] = 0;
        not_viz.emplace(a[i], i);
        not_viz.emplace(b[i], i);
    }

    for (int i = 2 * n - 1; i >= 0; i--) {
        if (!comp[ord[i]]) {
            c++;
            dfs2(ord[i]);
        }
    }

    int i = 1;
    while (i <= n && comp[i] != comp[i + n])
        i++;
    if (i <= n) {
        cout << "No" << endl;
        return 0;
    }

    cout << "Yes" << endl;
    for (int i = 1; i <= n; i++) {
        if (comp[i] > comp[i + n])
            cout << "1\n";
        else
            cout << "2\n";
    }

    return 0;
}
