#include <bits/stdc++.h>

using namespace std;

const int inf = 1e9;
const int MAXN = 1e5 + 5;

int a[MAXN], b[MAXN], c[MAXN], d[MAXN];
map<int, int>mp;

struct Edge {
	int to, cap, flow, rev;
};

struct maxFlow {
	int n, s, d;
	vector<vector<Edge> >g;
	vector<int>rem;
	vector<int>dist;
	vector<int>from;

	maxFlow(int _n = 0, int _s = 0, int _d = 0) {
		n = _n;
		s = _s;
		d = _d;
		g.resize(n + 1);
		rem.resize(n + 1);
		dist.resize(n + 1);
	}

	void addEdge(int u, int v, int cap) {
		g[u].push_back({v, cap, 0, g[v].size()});
		g[v].push_back({u, 0, 0, g[u].size() - 1});
	}

	bool bfs() {
		for (int i = 1; i <= n; ++i)
			dist[i] = inf;
		dist[s] = 0;
		queue<int>q;
		q.push(s);
		while (!q.empty()) {
			int aux = q.front();
			q.pop();
			for (int i = 0; i < g[aux].size(); ++i) {
				Edge e = g[aux][i];
				if (dist[e.to] == inf && e.cap > e.flow) {
					dist[e.to] = 1 + dist[aux];
					q.push(e.to);
				}
			}
		}
		return (dist[d] != inf);
	}

	int dfs(int node, int flow) {
		if (node == d)
			return flow;
		for (int& h = rem[node]; h < g[node].size(); ++h) {
			Edge& e = g[node][h];
			if (dist[e.to] == 1 + dist[node] && e.cap > e.flow) {
				int flow1 = min(flow, e.cap - e.flow);
				flow1 = dfs(e.to, flow1);
				if (flow1) {
					e.flow += flow1;
					g[e.to][e.rev].flow -= flow1;
					return flow1;
				}
			}
		}
		return 0;
	}

	int calcFlow() {
		int ans = 0;
		while (bfs()) {
			for (int i = 1; i <= n; ++i)
				rem[i] = 0;
			int flow = dfs(s, inf);
			while (flow) {
				ans += flow;
				flow = dfs(s, inf);
			}
		}
		return ans;
	}
};


int main() {
	//freopen("date.in", "r", stdin);
	//freopen("date.out", "w", stdout);

	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n; ++i) {
		scanf("%d%d%d%d", &a[i], &b[i], &c[i], &d[i]);
		mp[a[i]] = mp[b[i]] = mp[c[i]] = mp[d[i]] = 1;
	}

	int k = 0;
	for (auto& it:mp)
		it.second = ++k;

	for (int i = 1; i <= n; ++i) {
		a[i] = mp[a[i]];
		b[i] = mp[b[i]];
		c[i] = mp[c[i]];
		d[i] = mp[d[i]];
	}

	maxFlow net(1 + n + k + 1, 1, 1 + n + k + 1);
	for (int i = 1; i <= n; ++i)
		net.addEdge(1, i + 1, 1);
	for (int i = 1; i <= n; ++i) {
		for (int j = a[i]; j <= b[i]; ++j)
			net.addEdge(i + 1, n + 1 + j, 1);
		for (int j = c[i]; j <= d[i]; ++j)
			net.addEdge(i + 1, n + 1 + j, 1);
	}
	for (int i = n + 2; i <= n + k + 1; ++i)
		net.addEdge(i, 1 + n + k + 1, 1);

	if (net.calcFlow() == n) {
		printf("Yes\n");
		for (int i = 1; i <= n; ++i) {
			for (auto it:net.g[i + 1]) {
				if (it.to == a[i] + n + 1 && it.cap == it.flow) {
					printf("1\n");
					break;
				} else if (it.to == c[i] + n + 1 && it.cap == it.flow) {
					printf("2\n");
					break;
				}
			}
		}
	} else {
		printf("No\n");
	}

	return 0;
}

