#include <bits/stdc++.h>
using namespace std;

#ifndef HOME
	const int NMAX = 4e5 + 5;
	const int MMAX = 4e5 + 5;
#else
	const int NMAX = 30;
	const int MMAX = 30;
#endif

vector<int> crdX, crdY;
vector<pair<int, int>> lin[NMAX + MMAX], col[NMAX + MMAX];
int edg[NMAX][4]; bool oki[NMAX];

struct Object {
	int x, y, nx, ny, id;
	
	Object(int _x = 0, int _y = 0, int _nx = 0, int _ny = 0, int _id = 0) :
		x(_x), y(_y), nx(_nx), ny(_ny), id(_id) {}
} box[NMAX], rock[MMAX], ord[NMAX];

struct Struct {
	int d, x, y, t;
	
	Struct(int _d = 0, int _x = 0, int _y = 0, int _t = 0) :
		d(_d), x(_x), y(_y), t(_t) {}
}; vector<Struct> ans, aux;

void addEdge(int x, int y, int d) {
	edg[x][d] = y;
	edg[y][(d + 2) & 3] = x;
}

pair<int, int> getMidpoint(int p, int q) {
	return make_pair((box[p].x + box[q].x) / 2, (box[p].y + box[q].y) / 2);
}

int dfs(int x, int d, bool isRoot, int lev) {
	int val[8] = {0, 0, 0, 0, 0, 0, 0, 0};
	oki[x] = true;
	for (int nd = ((d + 1) & 3); nd != d; nd = ((nd + 1) & 3))
		if (edg[x][nd] and !oki[edg[x][nd]])
			val[nd] = val[nd + 4] = dfs(edg[x][nd], ((nd + 2) & 3), false, lev + 2);
	if (isRoot) {
		if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 0) 
			aux.push_back(Struct(1, box[x].x - 1, box[x].y, 0));
		if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 1) { 
			if (val[d + 1]) 
				aux.push_back(Struct(0, box[x].x, box[x].y + 1, 0));
			else
				aux.push_back(Struct(1, box[x].x + 1, box[x].y, 0));
		}
		if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 2) { 
			aux.push_back(Struct(0, box[x].x, box[x].y + 1, 0));
			aux.push_back(Struct(1, box[x].x + 1, box[x].y, 0));
		}
		return 0;
	}
	if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 0) 
		return x;
	if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 1) {
		int nd = d + 1;
		while (!val[nd]) 
			++nd;
		pair<int, int> mid = getMidpoint(x, val[nd]);
		aux.push_back(Struct(((nd & 1) ? 0 : 1), mid.first, mid.second, -lev));
		return 0;
	}
	if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 2) {
		int nd1 = d + 1;
		while (!val[nd1])
			++nd1;
		int nd2 = nd1 + 1;
		while (!val[nd2])
			++nd2;
		if (nd1 == d + 1 and nd2 == d + 3) {
			pair<int, int> mid = getMidpoint(val[d + 1], val[d + 3]);
			aux.push_back(Struct(((nd1 & 1) ? 0 : 1), mid.first, mid.second, lev));
			return x;
		} else {
			if (nd1 == d + 2)
				swap(nd1, nd2);
			pair<int, int> mid = getMidpoint(x, val[nd1]);
			aux.push_back(Struct(((nd1 & 1) ? 0 : 1), mid.first, mid.second, -lev));
			return val[nd2];
		}
	}	
	if ((val[0] > 0) + (val[1] > 0) + (val[2] > 0) + (val[3] > 0) == 3) {
		pair<int, int> mid1 = getMidpoint(x, val[d + 2]);
		aux.push_back(Struct(((d & 1) ? 0 : 1), mid1.first, mid1.second, -lev));
		pair<int, int> mid2 = getMidpoint(val[d + 1], val[d + 3]);
		aux.push_back(Struct((((d + 1) & 1) ? 0 : 1), mid2.first, mid2.second, -lev + 1));
		return 0;
	}
	return -1;
}

int main(void) {
#ifdef HOME
	freopen("bombs.in", "r", stdin);
	freopen("bombs.out", "w", stdout);
#endif
	int n;
	scanf("%d", &n);
	for (int i = 1; i <= n; ++i) {
		scanf("%d %d", &box[i], &box[i].y);
		box[i].id = i;
		crdX.push_back(box[i].x);
		crdY.push_back(box[i].y);
	}
	int m;
	scanf("%d", &m);
	for (int i = 1; i <= m; ++i) {
		scanf("%d %d", &rock[i].x, &rock[i].y);
		rock[i].id = i;
		crdX.push_back(rock[i].x);
		crdY.push_back(rock[i].y);
	}
	sort(crdX.begin(), crdX.end());
	sort(crdY.begin(), crdY.end());
	crdX.resize(unique(crdX.begin(), crdX.end()) - crdX.begin());
	crdY.resize(unique(crdY.begin(), crdY.end()) - crdY.begin());
	for (int i = 1; i <= n; ++i) {
		box[i].nx = lower_bound(crdX.begin(), crdX.end(), box[i].x) - crdX.begin();	
		box[i].ny = lower_bound(crdY.begin(), crdY.end(), box[i].y) - crdY.begin();	
		lin[box[i].nx].push_back(make_pair(box[i].ny, i));
		col[box[i].ny].push_back(make_pair(box[i].nx, i));
	}
	for (int i = 1; i <= m; ++i) {
		rock[i].nx = lower_bound(crdX.begin(), crdX.end(), rock[i].x) - crdX.begin();	
		rock[i].ny = lower_bound(crdY.begin(), crdY.end(), rock[i].y) - crdY.begin();	
		lin[rock[i].nx].push_back(make_pair(rock[i].ny, -i));
		col[rock[i].ny].push_back(make_pair(rock[i].nx, -i));
	}
	for (int i = 0; i < crdX.size(); ++i)
		sort(lin[i].begin(), lin[i].end());
	for (int i = 0; i < crdY.size(); ++i)
		sort(col[i].begin(), col[i].end());
	for (int i = 1; i <= n; ++i) {
		//determine the adjacent boxes
		pair<int, int> ps(box[i].nx, box[i].ny);
		auto it1 = lower_bound(lin[ps.first ].begin(), lin[ps.first ].end(), make_pair(ps.second, i));
		auto it2 = lower_bound(col[ps.second].begin(), col[ps.second].end(), make_pair(ps.first , i));
		if (it2 != col[ps.second].begin() and (it2 - 1) -> second > 0)
			addEdge(i, (it2 - 1) -> second, 0);
		if ((it2 + 1) != col[ps.second].end() and (it2 + 1) -> second > 0)
			addEdge(i, (it2 + 1) -> second, 2);
		if (it1 != lin[ps.first].begin() and (it1 - 1) -> second > 0)
			addEdge(i, (it1 - 1) -> second, 3);
		if ((it1 + 1) != lin[ps.first].end() and (it1 + 1) -> second > 0)
			addEdge(i, (it1 + 1) -> second, 1);
	}
	for (int i = 1; i <= n; ++i)
		ord[i] = box[i];
	sort(ord + 1, ord + n + 1, 
		[](const Object &b1, const Object &b2) {
			if (b1.x != b2.x)
				return b1.x < b2.x;
			return b1.y < b2.y;
		}
	);
	for (int i = 1; i <= n; ++i) {
		int id = ord[i].id;
		if (oki[id])
			continue;
		aux.clear();
		dfs(id, 0, true, 2);
		sort(aux.begin(), aux.end(), 
			[](const Struct &s1, const Struct &s2) {
				return s1.t < s2.t;
			}
		);
		for (Struct &s : aux)
			ans.push_back(s);
	}
	printf("%d\n", ans.size());
	for (Struct &s : ans)
		printf("%d %d %d\n", 1 - s.d, s.x, s.y);
	return 0;
}
