#include <bits/stdc++.h>

using namespace std;


const int Nmax = 4e5 + 5;
typedef pair<int,int> Pair;

int n, N, nr_comps;
int where[Nmax];
vector<int> v[Nmax];
vector<Pair> w;
vector<int> ord;

bool concert[Nmax], used[Nmax];



bool in(int x, Pair a)
{
    return x >= a.first && x <= a.second;
}

bool intersect(Pair a, Pair b)
{
    return in(a.first, b) || in(a.second, b) || in(b.first, a) || in(b.second, a);
}


void dfs(int node, int rev)
{
    used[node] = 1;
    if(rev) where[node] = nr_comps;

    for(auto it : v[node])
        if(!used[it]) dfs(it, rev);

    if(!rev) ord.push_back(node);
}


void solve1()
{
    int i, j;
    N = 2*n;
    for(i=0; i<N; ++i)
        for(j=0; j<N; ++j)
            if(i!=j && intersect(w[i], w[j]))
                v[i].push_back(j + N);

    for(i=0; i<n; ++i)
        v[N + 2*i].push_back((2*i+1)),
        v[N + 2*i+1].push_back((2*i));

    for(i=0; i<N; ++i)
        if(!used[i]) dfs(i, 0);
}


void solve2()
{
    int i, j;
    N = 2*n;

    for(i=0; i<2*N; ++i)
        v[i].clear();

    for(i=0; i<N; ++i)
        for(j=0; j<N; ++j)
            if(i!=j && intersect(w[i], w[j]))
                v[j+N].push_back(i);

    for(i=0; i<n; ++i)
        v[(2*i+1)].push_back(N + 2*i),
        v[(2*i)].push_back(N + 2*i+1);

    memset(used, 0, sizeof(used));
    reverse(ord.begin(), ord.end());

    for(auto it : ord)
        if(!used[it])
        {
            ++nr_comps;
            dfs(it, 1);
        }
}

void print()
{
    int i;
    for(i=0; i<N; ++i)
        if(where[i] == where[i + N])
        {
            cout << "No\n";
            return;
        }
     //   else cerr << where[i] << ' ' << where[i+N] << '\n';

    cout << "Yes\n";

    for(i=0; i<N; ++i)
        concert[i] = (where[i] > where[i+N]);

    for(i=0; i<n; ++i)
        if(concert[2*i]) cout << 1 << '\n';
            else cout << 2 << '\n';
}

int main()
{
 //   freopen("input", "r", stdin);
    cin.sync_with_stdio(false); cin.tie(0);

    cin >> n;
    int i;
    for(i=0; i<n; ++i)
    {
        int A, B, C, D;
        cin >> A >> B >> C >> D;
        w.push_back({A, B});
        w.push_back({C, D});
    }

    solve1();
    solve2();
    print();

    return 0;
}

