#include <iostream>
#include <algorithm>

using namespace std;

const int NMAX = 4e3 + 5;

int N;

pair < int, int > A[NMAX];

int B[2 * NMAX], V[2 * NMAX];

int Ap[2 * NMAX];
int Type[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    for(int i = 1; i <= N; ++i)
    {
        int x = 0, y = 0, z = 0, t = 0;

        cin >> x >> y >> z >> t;

        A[i] = {x, z};

        B[++B[0]] = x;
        B[++B[0]] = z;
    }

    return;
}

static inline void Normalize ()
{
    sort(B + 1, B + B[0] + 1);

    V[++V[0]] = B[1];

    for(int i = 2; i <= B[0]; ++i)
        if(B[i] != B[i - 1])
            V[++V[0]] = B[i];

    for(int i = 1; i <= N; ++i)
    {
        A[i].first = lower_bound(V + 1, V + V[0] + 1, A[i].first) - V;

        A[i].second = lower_bound(V + 1, V + V[0] + 1, A[i].second) - V;
    }

    return;
}

static inline void Task ()
{
    for(int i = 1; i <= N; ++i)
        ++Ap[A[i].first], ++Ap[A[i].second];

    bool done = 1;
    int op = N;

    while(done && op)
    {
        done = 0;
        --op;

        for(int i = 1; i <= N; ++i)
            if(Type[i])
                continue;
            else
            {
                done = 1;

                if(Ap[A[i].first] == 1)
                {
                    Type[i] = 1;

                    --Ap[A[i].second];

                    continue;
                }

                if(Ap[A[i].second] == 1)
                {
                    Type[i] = 2;

                    --Ap[A[i].first];
                }
            }
    }

    bool Ok = 1;

    for(int i = 1; i <= N; ++i)
        if(!Type[i])
        {
            Ok = 0;

            break;
        }

    if(!Ok)
    {
        cout << "No" << '\n';

        return;
    }

    cout << "Yes" << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Type[i] << '\n';

    return;
}

int main()
{
    Read();

    Normalize();

    Task();

    return 0;
}
