#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int NMAX = 4e3 + 5;

int N;

pair < int, int > A[NMAX];

int B[2 * NMAX], V[2 * NMAX];

int Type[NMAX];

int Left[NMAX], Right[2 * NMAX];
vector < int > G[NMAX];
bool Marked[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    for(int i = 1; i <= N; ++i)
    {
        int x = 0, y = 0, z = 0, t = 0;

        cin >> x >> y >> z >> t;

        A[i] = {x, z};

        B[++B[0]] = x;
        B[++B[0]] = z;
    }

    return;
}

static inline void Normalize ()
{
    sort(B + 1, B + B[0] + 1);

    V[++V[0]] = B[1];

    for(int i = 2; i <= B[0]; ++i)
        if(B[i] != B[i - 1])
            V[++V[0]] = B[i];

    for(int i = 1; i <= N; ++i)
    {
        A[i].first = lower_bound(V + 1, V + V[0] + 1, A[i].first) - V;

        A[i].second = lower_bound(V + 1, V + V[0] + 1, A[i].second) - V;
    }

    return;
}

static inline void Check ()
{
    bool Ok = 1;

    for(int i = 1; i <= N; ++i)
        if(!Type[i])
        {
            Ok = 0;

            break;
        }

    if(!Ok)
    {
        cout << "No" << '\n';

        return;
    }

    cout << "Yes" << '\n';

    for(int i = 1; i <= N; ++i)
        cout << Type[i] << '\n';

    return;
}

static inline void Add_Edges ()
{
    for(int i = 1; i <= N; ++i)
    {
        G[i].push_back(A[i].first);
        G[i].push_back(A[i].second);
    }

    return;
}

static inline bool Cupleaza (int Node)
{
    Marked[Node] = 1;

    for(auto it : G[Node])
        if(!Right[it])
        {
            Left[Node] = it;
            Right[it] = Node;

            return 1;
        }

    for(auto it : G[Node])
        if(!Marked[Right[it]] && Cupleaza(Right[it]))
        {
            Left[Node] = it;
            Right[it] = Node;

            return 1;
        }

    return 0;
}

static inline void Max_Match ()
{
    bool done = 1;

    while(done)
    {
        done = 0;

        for(int i = 1; i <= N; ++i)
            Marked[i] = 0;

        for(int i = 1; i <= N; ++i)
            if(!Left[i] && !Marked[i])
                done |= Cupleaza(i);
    }

    return;
}

static inline void Go ()
{
    for(int i = 1; i <= N; ++i)
        if(Left[i])
        {
            if(Left[i] == A[i].first)
                Type[i] = 1;
            else
                Type[i] = 2;
        }

    return;
}

static inline void Task ()
{
    Add_Edges();

    Max_Match();

    Go();

    Check();

    return;
}

int main()
{
    Read();

    Normalize();

    Task();

    return 0;
}
