#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int NMAX = 4e5 + 5;

int N, M;

pair < int, int > Box[NMAX], Stone[NMAX];

int BX[2 * NMAX], BY[2 * NMAX];
int VX[2 * NMAX], VY[2 * NMAX];

bool Sel[NMAX];

vector < pair < int, pair < int, int > > > Sol;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    for(int i = 1; i <= N; ++i)
    {
        cin >> Box[i].first >> Box[i].second;

        BX[++BX[0]] = Box[i].first;
        BY[++BY[0]] = Box[i].second;
    }

    cin >> M;

    for(int i = 1; i <= M; ++i)
    {
        cin >> Stone[i].first >> Stone[i].second;

        BX[++BX[0]] = Stone[i].first;
        BY[++BY[0]] = Stone[i].second;
    }

    return;
}

static inline void Normalize ()
{
    sort(BX + 1, BX + BX[0] + 1);
    sort(BY + 1, BY + BY[0] + 1);

    VX[++VX[0]] = BX[1];
    for(int i = 2; i <= BX[0]; ++i)
        if(BX[i] != BX[i - 1])
            VX[++VX[0]] = BX[i];

    VY[++VY[0]] = BY[1];
    for(int i = 2; i <= BY[0]; ++i)
        if(BY[i] != BY[i - 1])
            VY[++VY[0]] = BY[i];

    for(int i = 1; i <= N; ++i)
    {
        Box[i].first = lower_bound(VX + 1, VX + VX[0] + 1, Box[i].first) - VX;
        Box[i].second = lower_bound(VY + 1, VY + VY[0] + 1, Box[i].second) - VY;
    }

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}

static inline void Try1 ()
{
    bool done = 1;

    while(done)
    {
        done = 0;

        for(int i = 1; i < N; ++i)
            for(int j = i + 1; j <= N; ++j)
                if(!Sel[i] && !Sel[j])
                {
                    if(Box[i].first == Box[j].first)
                    {
                        if(my_abs(Box[i].second - Box[j].second) == 1)
                        {
                            done = 1;

                            Sel[i] = Sel[j] = 1;

                            if(Box[i].second < Box[j].second)
                                Sol.push_back({1, {VX[Box[i].first], VY[Box[i].second] + 1}});
                            else
                                Sol.push_back({1, {VX[Box[j].first], VY[Box[j].second] + 1}});

                            continue;
                        }
                    }

                    if(Box[i].second == Box[j].second)
                    {
                        if(my_abs(Box[i].first - Box[j].first) == 1)
                        {
                            done = 1;

                            Sel[i] = Sel[j] = 1;

                            if(Box[i].first < Box[j].first)
                                Sol.push_back({0, {VX[Box[i].first] + 1, VY[Box[i].second]}});
                            else
                                Sol.push_back({0, {VX[Box[j].first] + 1, VY[Box[j].second]}});
                        }
                    }
                }
    }

    return;
}

static inline void Try2 ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            Sol.push_back({0, {VX[Box[i].first] + 1, VY[Box[i].second]}});

    return;
}

static inline void Solve ()
{
    Try1();

    Try2();

    return;
}

static inline void Write ()
{
    cout << (int)Sol.size() << '\n';

    for(auto it : Sol)
        cout << it.first << ' ' << it.second.first << ' ' << it.second.second << '\n';

    return;
}

int main()
{
    Read();

    Normalize();

    Solve();

    Write();

    return 0;
}
