#include <bits/stdc++.h>
using namespace std;

struct orizontal{
    int x, y;
    bool operator < (orizontal const &aux)const{
        if(x != aux.x) return x < aux.x;
        return y < aux.y;
    }
};
orizontal ox[400005];

struct vertical{
    int x, y;
    bool operator < (vertical const &aux)const{
        if(y != aux.y) return y < aux.y;
        return x < aux.x;
    }
};
vertical oy[400005];

int n, m;

int x[400005], y[400005];
int lx[400005], ly[400005];
int rx[400005], ry[400005];
int bx[400005], by[400005];

int nx, ny;
set <pair <int, int> > sx;
set <pair <int, int> > sy;

map <pair <int, int>, int> fx;
map <pair <int, int>, int> fy;

int apx[400005], apy[400005];

void build_buckets(){
    for(int i = 1; i <= n ; ++i){
        ly[i] = lx[i] = 0; rx[i] = ry[i] = 1e9;

        int st = 1, dr = m;
        while(st <= dr){
            int mij = (st + dr) / 2;
            if(ox[mij].x < x[i] || (ox[mij].x == x[i] && ox[mij].y <= y[i])) st = mij + 1;
            else dr = mij - 1;
        }

        if(ox[dr].x == x[i]) ly[i] = ox[dr].y;
        if(ox[dr + 1].x == x[i]) ry[i] = ox[dr + 1].y;

        st = 1, dr = m;
        while(st <= dr){
            int mij = (st + dr) / 2;
            if(oy[mij].y < y[i] || (oy[mij].y == y[i] && oy[mij].x <= x[i])) st = mij + 1;
            else dr = mij - 1;
        }

        if(oy[dr].y == y[i]) lx[i] = oy[dr].x;
        if(oy[dr + 1].y == y[i]) rx[i] = oy[dr + 1].x;

        sx.insert({lx[i], rx[i]});
        sy.insert({ly[i], ry[i]});
    }

    for(auto it : sx) fx[it] = ++nx;
    for(auto it : sy) fy[it] = ++ny;

    for(int i = 1; i <= n ; ++i){
        bx[i] = fx[{lx[i], rx[i]}];
        by[i] = fy[{ly[i], ry[i]}];
        ++apx[bx[i]]; ++apy[by[i]];
    }
}

struct bomba{
    int tip, x, y;
};

vector <bomba> sol;
map <int, int> Fx;
map <int, int> Fy;

void blow(){
    for(int i = 1; i <= n ; ++i){
        if(apx[bx[i]] == 2){
            if(Fx[bx[i]] == 0) Fx[bx[i]] = y[i];
            else{
                int ad = 1;
                if(y[i] > Fx[bx[i]]) ad = -1;
                sol.push_back({0, x[i], y[i] + ad});
            }
        }
        else if(apy[by[i]] == 2){
            if(Fy[by[i]] == 0) Fy[by[i]] = x[i];
            else{
                int ad = 1;
                if(x[i] > Fy[by[i]]) ad = -1;
                sol.push_back({1, x[i] + ad, y[i]});
            }
        }
        else sol.push_back({1, x[i], y[i] + 1});
    }
}

void afis(){
    printf("%d\n", sol.size());
    for(auto it : sol) printf("%d %d %d\n", it.tip, it.x, it.y);
}

bool pa[100005];

int main()
{
    scanf("%d", &n);
    for(int i = 1; i <= n ; ++i)
        scanf("%d%d", &x[i], &y[i]);

    scanf("%d", &m);
    int a, b;
    for(int i = 1; i <= m ; ++i){
        scanf("%d%d", &a, &b);
        ox[i] = {a, b};
        oy[i] = {a, b};
    }

    sort(ox + 1, ox + m + 1);
    sort(oy + 1, oy + m + 1);

    for(int i = 1; i <= n ; ++i){
        if(pa[i]) continue ;
        for(int j = i + 1; j <= n && !pa[i] ; ++j){
            if(pa[j]) continue ;

            if(x[i] == x[j]){
                ///caut piatra intre
                bool found = false;

                int my = min(y[i], y[j]), My = max(y[i], y[j]);

                if(m > 0){
                    int st = 1, dr = m;
                    while(st <= dr){
                        int mij = (st + dr) / 2;
                        if(ox[mij].x < x[i] || (ox[mij].x == x[i] && ox[mij].y <= my)) st = mij + 1;
                        else dr = mij - 1;
                    }

                    if(ox[st].x == x[i] && ox[st].y >= my && ox[st].y <= My) found = true;
                }

                if(!found){
                    pa[j] = pa[i] = true;
                    sol.push_back({1, x[i], my + 1});
                }
            }

            if(y[i] == y[j]){
                ///caut piatra intre
                bool found = false;

                int mx = min(x[i], x[j]), Mx = max(x[i], x[j]);

                if(m > 0){
                    int st = 1, dr = m;
                    while(st <= dr){
                        int mij = (st + dr) / 2;
                        if(oy[mij].y < y[i] || (oy[mij].y == y[i] && oy[mij].x <= mx)) st = mij + 1;
                        else dr = mij - 1;
                    }

                    if(oy[st].y == y[i] && oy[st].x >= mx && oy[st].x <= Mx) found = true;
                }

                if(!found){
                    pa[j] = pa[i] = true;
                    sol.push_back({0, mx + 1, y[i]});
                }
            }
        }
        if(!pa[i]) sol.push_back({0, x[i] + 1, y[i]});
    }

    printf("%d\n", sol.size());
    for(auto it : sol) printf("%d %d %d\n", it.tip, it.x, it.y);



//    ///impart in bucket-uri
//    build_buckets();
//
//    ///acum rezolv problema propriu-zisa
//    blow();


    return 0;
}
