#include<bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

struct edge {
    int v, to, f, c;
    edge(int v_, int to_, int c_) {
        v = v_;
        to = to_;
        c = c_;
        f = 0;
    }
};

vector<edge> e;
vector<vector<int>> g;
vector<int> d, p;
int n, s, t;

void add_edge(int v, int to) {
    edge e1(v, to, 1), e2(to, v, 0);
    g[v].push_back(size(e));
    e.push_back(e1);
    g[to].push_back(size(e));
    e.push_back(e2);
}

bool bfs() {
    d.assign(n, -1);
    queue<int> q;
    q.push(s);
    d[s] = 0;
    while(!q.empty() && d[t] == -1) {
        int v = q.front();
        q.pop();
        for(int i : g[v]) {
            if(d[e[i].to] == -1 && e[i].c > e[i].f) {
                d[e[i].to] = d[v] + 1;
                q.push(e[i].to);
            }
        }
    }
    return d[t] != -1;
}

int dfs(int v, int flow = 1000000000) {
    if(v == t) {
        return flow;
    }
    if(flow == 0) {
        return flow;
    }
    for(; p[v] < size(g[v]); p[v]++) {
        int i = g[v][p[v]];
        if(d[e[i].to] != d[v] + 1) {
            continue;
        }
        int l = dfs(e[i].to, min(flow, e[i].c - e[i].f));
        if(l) {
            e[i].f += l;
            e[i^1].f -= l;
            return l;
        }
    }
    return 0;
}

int dinic() {
    int flow = 0;
    while(true) {
        if(!bfs()) {
            break;
        }
        p.assign(n, 0);
        int l;
        while(l = dfs(s)) {
            flow += l;
        }
    }
    return flow;
}

vector<vector<int>> g1;
vector<int> col;

void dfs1(int v, int c) {
    col[v] = c;
    for(int i : g1[v]) {
        if(col[i] == -1) {
            dfs1(i, 1 - c);
        }
    }
}

void solve() {
	cin >> n;
	map<int, vector<pair<int, int>>> x, y;
	vector<int> aa(n), bb(n);
	for(int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        aa[i] = a;
        bb[i] = b;
        x[a].push_back(make_pair(b, i + 1));
        y[b].push_back(make_pair(a, i + 1));
	}
	int m;
	cin >> m;
	for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        x[a].push_back(make_pair(b, -1));
        y[b].push_back(make_pair(a, -1));
	}
	g1.resize(n);
	for(auto it : x) {
        sort(all(it.s));
        for(int i = 1; i < size(it.s); i++) {
            if(it.s[i].s != -1 && it.s[i - 1].s != -1) {
                g1[it.s[i].s - 1].push_back(it.s[i - 1].s - 1);
                g1[it.s[i - 1].s - 1].push_back(it.s[i].s - 1);
            }
        }
	}
	for(auto it : y) {
        sort(all(it.s));
        for(int i = 1; i < size(it.s); i++) {
            if(it.s[i].s != -1 && it.s[i - 1].s != -1) {
                g1[it.s[i].s - 1].push_back(it.s[i - 1].s - 1);
                g1[it.s[i - 1].s - 1].push_back(it.s[i].s - 1);
            }
        }
	}
	col.assign(n, -1);
	for(int i = 0; i < n; i++) {
        if(col[i] == -1) {
            dfs1(i, 0);
        }
	}
	g.resize(n + 2);
	s = 0, t = n + 1;
	for(int i = 0; i < n; i++) {
        if(col[i] == 0) {
        add_edge(s, i + 1);
        }else {
        add_edge(i + 1, t);
        }
        for(int j : g1[i]) {
            if(col[i] == 0 && col[j] == 1) {
                add_edge(i + 1, j + 1);
            }
        }
	}
	n += 2;
	dinic();
	n -= 2;
    vector<int> us(n, 0);
    vector<int> anst, ansx, ansy;
    for(edge e1 : e) {
        //cout << e1.v << " " << e1.to << " " << e1.f << " " << e1.c << "\n";
        if(e1.v != s && e1.v != t && e1.to != s && e1.to != t) {
            if(col[e1.v - 1] != col[e1.to - 1] && e1.f == 1) {
                int a = e1.v - 1;
                int b = e1.to - 1;
                if(aa[a] == aa[b]) {
                    anst.push_back(1);
                    ansx.push_back(aa[a]);
                    ansy.push_back(min(bb[a], bb[b]) + 1);
                }else {
                    anst.push_back(0);
                    ansx.push_back(min(aa[a], aa[b]) + 1);
                    ansy.push_back(bb[a]);
                }
                us[a] = 1;
                us[b] = 1;
            }
        }
    }
    for(int i = 0; i < n; i++) {
        if(us[i] == 0) {
            anst.push_back(1);
            ansx.push_back(aa[i]);
            ansy.push_back(bb[i] + 1);
        }
    }
    cout << size(anst) << "\n";
    for(int i = 0; i < size(anst); i++) {
        cout << anst[i] << " " << ansx[i] << " " << ansy[i] << "\n";
    }
}

int main() {
	io();
	solve();
	return 0;
}
