#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <string>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
using namespace std;
//#pragma GCC target("avx")
//#pragma GCC optimize(/*"Ofast",*/ "fast-math", "unroll-loops", "no-stack-protector")

struct segment_tree {
    vector < int > t;
    vector < int > delta;
    int siz;
    void build(int siz1) {
        siz = siz1;
        t.resize(4 * siz);
        delta.resize(4 * siz);
    }
    void push(int v, int l, int r) {
        if (v * 2 + 1 < 4 * siz)
            delta[v * 2 + 1] += delta[v];
        if (v * 2 + 2 < 4 * siz)
            delta[v * 2 + 2] += delta[v];
        t[v] += delta[v] * (r - l + 1);
        delta[v] = 0;
    }
    int ask(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int ans = 0;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) ans += (v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1) ans += (v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        return ans;
    }
    void upd(int v, int l, int r, int tl, int tr, int val) {
        if (l == tl && r == tr) {
            delta[v] += val;
            push(v, l, r);
            return ;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) upd(v * 2 + 1, l, m, tl, min(m, tr), val);
        if (tr >= m + 1) upd(v * 2 + 2, m + 1, r, max(m + 1, tl), tr, val);
        return ;
    }
    int reask(int l, int r) {
        return ask(0, 0, siz - 1, l, r);
    }
    int reupd(int l, int r, int val) {
        upd(0, 0, siz - 1, l, r, val);
    }
};
int main() {
    /*segment_tree test;
    int n = 10;
    vector < int > a(n, 0);
    test.build(n);
    srand(time(NULL));
    fori(100) {
        int l = rand() % n;
        int r = rand() % n;
        if (l > r) swap(l, r);
        test.reupd(l, r, 1);
        for (int j = l; j <= r; j++) {
            a[j]++;
        }
    }
    fori(n) cout << a[i] << " ";
    cout << "\n";
    fori(n) cout << test.reask(i, i) << " ";
    cout << "\n";
    return 0;*/
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector < pair < int, int > > a, b;
    a.resize(n);
    b.resize(n);
    fori(n) cin >> a[i].ff >> a[i].ss >> b[i].ff >> b[i].ss;
    for (int msk = 0; msk < (1<<n); msk++) {
        vector < pair < int, int > > keks;
        for (int i = 0; i < n; i++) {
            if ((msk>>i)&1) keks.pb(b[i]);
            else keks.pb(a[i]);
        }
        sort(all(keks));
        bool ok = true;
        fori(n - 1) if (keks[i].ss >= keks[i + 1].ff) {
            ok = false;
            break;
        }
        if (!ok) continue;
        cout << "Yes\n";
        fori(n) {
            if ((msk>>i)&1)
                cout << 2;
            else
                cout << 1;
            cout << "\n";
        }
        return 0;
    }
    cout << "No";
    return 0;
}








