#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <string>
#include <bitset>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
using namespace std;
#pragma GCC target("avx")
#pragma GCC optimize("Ofast", "fast-math", "unroll-loops", "no-stack-protector")

struct segment_tree {
    vector < int > t;
    vector < int > delta;
    int siz;
    void build(int siz1) {
        siz = siz1;
        t.resize(4 * siz);
        delta.resize(4 * siz);
    }
    void push(int v, int l, int r) {
        if (v * 2 + 1 < 4 * siz)
            delta[v * 2 + 1] += delta[v];
        if (v * 2 + 2 < 4 * siz)
            delta[v * 2 + 2] += delta[v];
        t[v] += delta[v] * (r - l + 1);
        delta[v] = 0;
    }
    int ask(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int ans = 0;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) ans += (v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1) ans += (v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        return ans;
    }
    void upd(int v, int l, int r, int tl, int tr, int val) {
        if (l == tl && r == tr) {
            delta[v] += val;
            push(v, l, r);
            return ;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) upd(v * 2 + 1, l, m, tl, min(m, tr), val);
        if (tr >= m + 1) upd(v * 2 + 2, m + 1, r, max(m + 1, tl), tr, val);
        return ;
    }
    int reask(int l, int r) {
        return ask(0, 0, siz - 1, l, r);
    }
    int reupd(int l, int r, int val) {
        upd(0, 0, siz - 1, l, r, val);
    }
};




int solve(int n) {
    if (n == 1) return 1;
    bitset < 1000010 > a;
    for (int i = n - 1; i >= 0; i -= 2) {
        a[i] = 1;
    }
    fori(n / 2 + 10) {
        for (int j = 0; j < n; j++) {
            if (a[j] == 1) {
                a[j] = 0;
            } else {
                a[j] = 1;
                break;
            }
        }
        if (a.count() == i + 1) {
            return i + 1;
        }
    }
    return 0;
}
int main() {
    int n;
    cin >> n;
    cout << solve(n);
}

/**
0 :
1 : 1
2 : 0
3 : 0
4 : 2 3
5 : 0
6 : 1 2 3 5
7 : 3 4 6
8 : 0
9 : 1 3 4 6 8
10 : 0
11 : 0
12 : 0
13 : 2 3 4 6 8 10 12
14 : 4 5 7 9 11 13
15 : 1 2 3 4 6 8 10 12 14
16 : 1 4 5 7 9 11 13 15
17 : 0
18 : 0
19 : 0
20 : 2 4 5 7 9 11 13 15 17 19


0 0
1 1
2 2
3 5
4 10
5 21
6 42
7 85
8 170
9 341
10 682
11 1365
12 2730
13 5461
14 10922
15 21845
16 43690
17 87381
18 174762
19 349525
20 699050
**/





