#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <string>
#include <bitset>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
using namespace std;
#pragma GCC target("avx")
#pragma GCC optimize("Ofast", "fast-math", "unroll-loops", "no-stack-protector", "O3", "-sse3")

struct segment_tree {
    vector < int > t;
    vector < int > delta;
    int siz;
    void build(int siz1) {
        siz = siz1;
        t.resize(4 * siz);
        delta.resize(4 * siz);
    }
    void push(int v, int l, int r) {
        if (v * 2 + 1 < 4 * siz)
            delta[v * 2 + 1] += delta[v];
        if (v * 2 + 2 < 4 * siz)
            delta[v * 2 + 2] += delta[v];
        t[v] += delta[v] * (r - l + 1);
        delta[v] = 0;
    }
    int ask(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int ans = 0;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) ans += (v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1) ans += (v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        return ans;
    }
    void upd(int v, int l, int r, int tl, int tr, int val) {
        if (l == tl && r == tr) {
            delta[v] += val;
            push(v, l, r);
            return ;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) upd(v * 2 + 1, l, m, tl, min(m, tr), val);
        if (tr >= m + 1) upd(v * 2 + 2, m + 1, r, max(m + 1, tl), tr, val);
        return ;
    }
    int reask(int l, int r) {
        return ask(0, 0, siz - 1, l, r);
    }
    int reupd(int l, int r, int val) {
        upd(0, 0, siz - 1, l, r, val);
    }
};



int fn, fm;
int n, m;
vector < pair < int, int > > box;
vector < pair < int, int > > rock;
vector < int > pipkax, pipkay;
void rebuild() {
    set < int > allx, ally;
    allx.insert(1);
    ally.insert(1);
    allx.insert(1e9);
    ally.insert(1e9);
    fori(n) {
        allx.insert(box[i].ff);
        ally.insert(box[i].ss);

        if (box[i].ff != 1e9) allx.insert(box[i].ff + 1);
        if (box[i].ss != 1e9) ally.insert(box[i].ss + 1);

        if (box[i].ff != 1) allx.insert(box[i].ff - 1);
        if (box[i].ss != 1) ally.insert(box[i].ss - 1);
    }
    fori(m) {
        allx.insert(rock[i].ff);
        ally.insert(rock[i].ss);

        if (rock[i].ff != 1e9) allx.insert(rock[i].ff + 1);
        if (rock[i].ss != 1e9) ally.insert(rock[i].ss + 1);

        if (rock[i].ff != 1) allx.insert(rock[i].ff - 1);
        if (rock[i].ss != 1) ally.insert(rock[i].ss - 1);
    }
    map < int, int > kekx, keky;
    int cuca = 0;
    for (auto c: allx) {
        kekx[c] = cuca;
        pipkax.pb(c);
        cuca++;
    }
    fn = cuca;
    cuca = 0;
    for (auto c: ally) {
        keky[c] = cuca;
        pipkay.pb(c);
        cuca++;
    }
    fm = cuca;
    fori(n) {
        box[i].ff = kekx[box[i].ff];
        box[i].ss = keky[box[i].ss];
    }
    fori(m) {
        rock[i].ff = kekx[rock[i].ff];
        rock[i].ss = keky[rock[i].ss];
    }
    return ;
}
vector < vector < int > > field;
bool ok(int x, int y) {
    if (x < 0 || x >= fn || y < 0 || y >= fm) return 0;
    if (field[x][y] != 0) return 0;
    return 1;
}
vector < int > dp;
vector < int > shuba;
vector < pair < int, pair < int, int > >  > where;
void relax(int msk, int past, int t, int x, int y) {
    if (dp[msk] > dp[past] + 1) {
        dp[msk] = dp[past] + 1;
        where[msk] = {t, {x, y}};
        shuba[msk] = past;
    }
}
bool isclear(int x, int y, int x1, int y1) {
    for (int i = x; i <= x1; i++) {
        for (int j = y; j <= y1; j++) {
            if (field[i][j] != 0) return false;
        }
    }
    return true;
}
int main() {
    cin >> n;
    box.resize(n);
    fori(n) cin >> box[i].ff >> box[i].ss;
    cin >> m;
    rock.resize(m);
    fori(m) cin >> rock[i].ff >> rock[i].ss;
    rebuild();
    //fn = 100;
    //fm = 100;
    int mx = (1<<n);
    dp.resize(mx);
  /// what boxes are killed
    where.resize(mx);
    fori(dp.size()) dp[i] = n + 1;
    dp[0] = 0;
    vector < set < int > > badx, bady;
    badx.resize(fn);
    bady.resize(fm);
    shuba.resize(mx);
    for (int msk = 1; msk < mx; msk++) {
        field.clear();
        field.resize(fn);
        fori(fn) field[i].resize(fm);
        fori(m) field[rock[i].ff][rock[i].ss] = -1;
        vector < int > cuca;

        for (int i = 0; i < n; i++) {
            if ((msk>>i)&1) {
                cuca.pb(i);
                field[box[i].ff][box[i].ss] = i + 1;
            }
        }
        fori(fn) {
            forj(fm) {
                if (field[i][j] >= 1) {
                    if (ok(i - 1, j)) {
                        //cout << "a";
                        relax(msk, msk - (1<<(field[i][j] - 1)), 1, i - 1, j);
                    }
                    if (ok(i + 1, j)) {
                        //cout << "b";
                        relax(msk, msk - (1<<(field[i][j] - 1)), 1, i + 1, j);
                    }
                    if (ok(i, j - 1)) {
                        //cout << "c";
                        relax(msk, msk - (1<<(field[i][j] - 1)), 0, i, j - 1);
                    }
                    if (ok(i, j + 1)) {
                        //cout << "d";
                        relax(msk, msk - (1<<(field[i][j] - 1)), 0, i, j + 1);
                    }
                    //cout << "\n";
                }
            }
        }
        for (int i = 0; i < cuca.size(); i++) {
            for (int j = i + 1; j < cuca.size(); j++) {
                int d1 = cuca[i];
                int d2 = cuca[j];
                if (box[d1].ff == box[d2].ff) {
                    int x = box[d1].ff;
                    int y1 = box[d1].ss;
                    int y2 = box[d2].ss;
                    if (y1 > y2) swap(y1, y2);
                    if (y1 + 1 == y2) continue;
                    if (isclear(x, y1 + 1, x, y2 - 1)) {
                        relax(msk, msk - (1<<d1) - (1<<d2), 1, x, y1 + 1);
                    }
                }
                if (box[d1].ss == box[d2].ss) {
                    int y = box[d1].ss;
                    int x1 = box[d1].ff;
                    int x2 = box[d2].ff;
                    if (x1 > x2) swap(x1, x2);
                    if (isclear(x1 + 1, y, x2 - 1, y)) {
                        relax(msk, msk - (1<<d1) - (1<<d2), 0, x1 + 1, y);
                    }
                }
            }
        }
    }
    cout << dp[mx - 1] << "\n";
    mx--;
    while (true) {
        if (mx == 0) break;
        cout << where[mx].ff << " " << pipkax[where[mx].ss.ff] << " " << pipkay[where[mx].ss.ss] << "\n";
        mx = shuba[mx];
    }
}

/**
0 :
1 : 1
2 : 0
3 : 0
4 : 2 3
5 : 0
6 : 1 2 3 5
7 : 3 4 6
8 : 0
9 : 1 3 4 6 8
10 : 0
11 : 0
12 : 0
13 : 2 3 4 6 8 10 12
14 : 4 5 7 9 11 13
15 : 1 2 3 4 6 8 10 12 14
16 : 1 4 5 7 9 11 13 15
17 : 0
18 : 0
19 : 0
20 : 2 4 5 7 9 11 13 15 17 19


0 0
1 1
2 2
3 5
4 10
5 21
6 42
7 85
8 170
9 341
10 682
11 1365
12 2730
13 5461
14 10922
15 21845
16 43690
17 87381
18 174762
19 349525
20 699050
**/





