#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <math.h>
#include <string>
#include <bitset>
typedef long long ll;
#define fori(n) for (int i = 0; i < n; i++)
#define forj(n) for (int j = 0; j < n; j++)
#define ss second
#define ff first
#define pb push_back
#define all(v) v.begin(), v.end()
using namespace std;
//#pragma GCC target("avx")
#pragma GCC optimize("Ofast", "fast-math", "unroll-loops", "no-stack-protector")

struct segment_tree {
    vector < int > t;
    vector < int > delta;
    int siz;
    void build(int siz1) {
        siz = siz1;
        t.resize(4 * siz);
        delta.resize(4 * siz);
    }
    void push(int v, int l, int r) {
        if (v * 2 + 1 < 4 * siz)
            delta[v * 2 + 1] += delta[v];
        if (v * 2 + 2 < 4 * siz)
            delta[v * 2 + 2] += delta[v];
        t[v] += delta[v] * (r - l + 1);
        delta[v] = 0;
    }
    int ask(int v, int l, int r, int tl, int tr) {
        push(v, l, r);
        if (l == tl && r == tr) {
            return t[v];
        }
        int m = (l + r) / 2;
        int ans = 0;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) ans += (v * 2 + 1, l, m, tl, min(m, tr));
        if (tr >= m + 1) ans += (v * 2 + 2, m + 1, r, max(m + 1, tl), tr);
        return ans;
    }
    void upd(int v, int l, int r, int tl, int tr, int val) {
        if (l == tl && r == tr) {
            delta[v] += val;
            push(v, l, r);
            return ;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        push(v * 2 + 1, l, m);
        push(v * 2 + 2, m + 1, r);
        if (tl <= m) upd(v * 2 + 1, l, m, tl, min(m, tr), val);
        if (tr >= m + 1) upd(v * 2 + 2, m + 1, r, max(m + 1, tl), tr, val);
        return ;
    }
    int reask(int l, int r) {
        return ask(0, 0, siz - 1, l, r);
    }
    int reupd(int l, int r, int val) {
        upd(0, 0, siz - 1, l, r, val);
    }
};
vector < int > a, b;
int cnt = 0;
int n;
void rebuild() {
    set < int > all;
    map < int, int > kekind;
    fori(n) all.insert(a[i]);
    fori(n) all.insert(b[i]);
    cnt = 0;
    for (auto c: all) {
        kekind[c] = cnt;
        cnt++;
    }
    fori(n) {
        a[i] = kekind[a[i]];
        b[i] = kekind[b[i]];
    }
}
vector < vector < int > > index; /// inidex[a] - kto hochet v etot den'
vector < int > taken; /// komy prinadleshit etot den'
bool ok = true;
vector < int > used;
void f(int v) {
    used.pb(v);
    if (taken[a[v]] == -1) {
        if (taken[b[v]] != v)
            taken[a[v]] = v;
        for (auto to: index[a[v]]) {
            if (taken[a[to]] == to || taken[b[to]] == to) continue;
            f(to);
            if (!ok) return ;
        }
    } else if (taken[b[v]] == -1) {
        if (taken[a[v]] != v)
            taken[b[v]] = v;
        for (auto to: index[b[v]]) {
            if (taken[a[to]] == to || taken[b[to]] == to) continue;
            f(to);
            if (!ok) return ;
        }
    } else {
        ok = false;
        return ;
    }
}
vector < int > stupid(int n, vector < pair < int, int > > a, vector < pair < int, int > > b) {
    for (int msk = 0; msk < (1<<n); msk++) {
        vector < pair < int, int > > keks;
        for (int i = 0; i < n; i++) {
            if ((msk>>i)&1) keks.pb(b[i]);
            else keks.pb(a[i]);
        }
        sort(all(keks));
        bool ok = true;
        fori(n - 1) if (keks[i].ss >= keks[i + 1].ff) {
            ok = false;
            break;
        }
        if (!ok) continue;
        vector < int > ret;
        fori(n) {
            if ((msk>>i)&1)
                ret.pb(2);
            else
                ret.pb(1);
        }
        return ret;
    }
    return {-1};
}
int main() {
    cin >> n;
    a.resize(n);
    b.resize(n);
    srand(time(NULL));
    vector < pair < int, int > > a1, b1;
    a1.resize(n); b1.resize(n);
    fori(n) cin >> a[i] >> a[i] >> b[i] >> b[i];
    fori(n) {
        a1[i] = {a[i], a[i]};
        b1[i] = {b[i], b[i]};
    }
    //auto c = stupid(n, a1, b1);
    //fori(c.size()) cout << c[i] << " ";
    //cout << "\n\n";
    rebuild();
    taken.resize(cnt);
    fori(cnt) taken[i] = -1;
    index.resize(cnt);
    fori(n) {
        index[a[i]].pb(i);
        index[b[i]].pb(i);
    }
    fori(n) {
        if (taken[a[i]] != -1 || taken[b[i]] != -1) continue;

        ok = true;
        taken[a[i]] = i;
        used.clear();
        used.pb(i);
        for (auto to: index[a[i]]) {
            if (to == i) continue;
            f(to);
        }
        if (!ok) {
            for (auto v: used) {
                taken[a[v]] = -1;
                taken[b[v]] = -1;
            }
            taken[b[i]] = i;
            ok = true;
            for (auto to: index[b[i]]) {
                if (to == i) continue;
                f(to);
            }
            if (!ok) {
                cout << "No";
                return 0;
            }
        }

    }
    cout << "Yes\n";
    fori(n) {
        if (taken[a[i]] == i) cout << 1;
        else cout << 2;
        cout << "\n";
    }
}
/**
3
0 0 1 1
0 0 2 2
1 1 2 2
4
2 2 4 4
4 4 3 3
3 3 1 1
3 3 4 4

6
0 0 1 1
1 1 2 2
1 1 4 4
0 0 3 3
3 3 4 4
4 4 5 5
0 :
1 : 1
2 : 0
3 : 0
4 : 2 3
5 : 0
6 : 1 2 3 5
7 : 3 4 6
8 : 0
9 : 1 3 4 6 8
10 : 0
11 : 0
12 : 0
13 : 2 3 4 6 8 10 12
14 : 4 5 7 9 11 13
15 : 1 2 3 4 6 8 10 12 14
16 : 1 4 5 7 9 11 13 15
17 : 0
18 : 0
19 : 0
20 : 2 4 5 7 9 11 13 15 17 19


0 0
1 1
2 2
3 5
4 10
5 21
6 42
7 85
8 170
9 341
10 682
11 1365
12 2730
13 5461
14 10922
15 21845
16 43690
17 87381
18 174762
19 349525
20 699050
**/





