#include <bits/stdc++.h>
#define int long long
#define ld long double
#define fs first
#define sc second
#define pr pair
#define mp make_pair
#define vc vector
#define pb push_back
#define len(v) (int)v.size()
#define all(v) v.begin(),v.end()
#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,mmx,abm,tune=native")

using namespace std;

mt19937 rnd(228);

const int N = 2e5;
const int MAXN = 2 * N;
vc<int> g[MAXN];
vc<int> gr[MAXN];
bool used[MAXN];
int col[MAXN];
int lasts = 0;
int peps[MAXN];


void add_edge(int a, int b){
	g[a].pb(b);
	gr[b].pb(a);
}

int t[3 * MAXN];

void build(int v, int l, int r){
	if (l == r){
		t[v] = lasts++;
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v, l, mid);
	build(2 * v + 1, mid + 1, r);
	t[v] = lasts++;
	add_edge(t[v], t[2 * v]);
	add_edge(t[v], t[2 * v + 1]);
	add_edge(t[2 * v] + N, t[v] + N);	
	add_edge(t[2 * v + 1] + N, t[v] + N);	
}

void add_connection(int v, int l, int r, int pos, int st){
	if (l == r && r == pos){
		add_edge(st + N, t[v] + N);
		add_edge(t[v], st);
		return;
	}
	if (pos < l || r < pos){
		return;
	}
	int mid = (l + r) / 2;
	add_connection(2 * v, l, mid, pos, st);
	add_connection(2 * v + 1, mid + 1, r, pos, st);
}

void add_sex(int v, int l, int r, int tl, int tr, int st){
	if (tl <= l && r <= tr){
		add_edge(st + N, t[v]);
		add_edge(t[v] + N, st);
		return;
	}
	if (l > tr || tl > r){
		return;
	}
	int mid = (l + r) / 2;
	add_sex(2 * v, l, mid, tl, tr, st);
	add_sex(2 * v + 1, mid + 1, r, tl, tr, st);
}
vc<int> obh;

void dfsrev(int v){
	used[v] = 1;
	for (auto to : gr[v]){
		if (!used[to]){
			dfsrev(to);
		}
	}
	obh.pb(v);
}

void dfs(int v, int color){
	col[v] = color;
	used[v] = 1;
	for (auto to : g[v]){
		if (!used[to]){
			dfs(to, color);
		}
	}
}


void solve(istream &in, ostream &out){
	int n;
	in >> n;
	vc<pr<int, int>> a(2 * n);
	map<int, int> kes;
	for (int i = 0; i < 2 * n; i++){
		in >> a[i].fs >> a[i].sc;
		kes[a[i].sc] = 0;
		kes[a[i].fs] = 0;
	}
	int msse = 0;
	for (auto &v : kes){
		v.sc = msse++;
	}
	for (int i = 0; i < 2 * n; i++){
		a[i].fs = kes[a[i].fs], a[i].sc = kes[a[i].sc];
	}
	for (int i = 0; i < n; i++){
		add_edge(2 * i, 2 * i + 1 + N);
		add_edge(2 * i + 1, 2 * i + N);
	}
	lasts = 2 * n;
	build(1, 0, msse - 1);
	fill(peps, peps + MAXN, -1);
	for (int i = 0; i < 2 * n; i++){
		add_connection(1, 0, msse - 1, a[i].sc, i);
	}
	for (int i = 0; i < 2 * n; i++){
		if (a[i].fs != a[i].sc){
			add_sex(1, 0, msse - 1, a[i].fs, a[i].sc - 1, i);
		}
		if (peps[a[i].sc] == -1){
			peps[a[i].sc] = i;
		}
		else{
			int x = lasts++;
			int xx = peps[a[i].sc];
			add_edge(xx + N, x + N);
			add_edge(x, xx);
			add_edge(i + N, xx);
			add_edge(xx + N, i);
			add_edge(x, i);
			add_edge(i + N, x + N);
			peps[a[i].sc] = x;
		}
		
	}
	for (int i = 0; i < lasts; i++){
		if (!used[i]){
			dfsrev(i);
		}
		if (!used[i + N]){
			dfsrev(i + N);
		}
	}
	fill(used, used + MAXN, 0);
	int lastcol = 0;
	reverse(all(obh));
	for (auto v : obh){
		if (!used[v]){
			dfs(v, lastcol++);
		}
	}
	for (int i = 0; i < 2 * n; i++){
		if (col[i] == col[i + N]){
			out << "No";
			return;
		}
	}
	out << "Yes\n";
	for (int i = 0; i < n; i++){
		if (col[2 * i] < col[2 * i + N]){
			out << "2\n";
		}
		else{
			out << "1\n";
		}
	}
}

signed main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve(cin, cout);
}