#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second
using ull = unsigned long long;
#define mp make_pair

struct event {
    int x, id;
    bool t;
};

bool operator<(const event &a, const event &b) {
    if (a.x == b.x) {
        if (a.t == b.t) return a.id < b.id;
        return a.t < b.t;
    }
    return a.x < b.x;
}

const int MAXN = 1e5 + 5;
const int MAXNODE = MAXN * 2 + MAXN * 4 * 4 + MAXN * 4 * 4;
int n, m;
int a[MAXN][4];
vector<int> g[MAXNODE];
vector<int> gr[MAXNODE];
int node[MAXN * 4 * 4];
int last;

void link(int u, int v) {
    g[u].push_back(v);
    gr[v].push_back(u);
}

void build(int v, int tl, int tr, bool up) {
    node[v] = last++;
    if (tr - tl == 1) {
        return;
    }

    int tm = tl + (tr - tl) / 2;
    build(v * 2 + 1, tl, tm, up);
    build(v * 2 + 2, tm, tr, up);
    if (up) {
        link(node[v * 2 + 1], node[v]);
        link(node[v * 2 + 2], node[v]);
    } else {
        link(node[v], node[v * 2 + 1]);
        link(node[v], node[v * 2 + 2]);
    }
}

void link_seg(int v, int tl, int tr, int l, int r, int id, bool up) {
    if (r <= tl || tr <= l) return;
    if (l <= tl && tr <= r) {
        if (up) {
            link(node[v], id);
        } else {
            link(id, node[v]);
        }
        return;
    }

    int tm = tl + (tr - tl) / 2;
    link_seg(v * 2 + 1, tl, tm, l, r, id, up);
    link_seg(v * 2 + 2, tm, tr, l, r, id, up);
}

void link_item(int v, int tl, int tr, int p, int id, bool up) {
    if (tr - tl == 1) {
        if (up) {
            link(id, node[v]);
        } else {
            link(node[v], id);
        }
        return;
    }

    int tm = tl + (tr - tl) / 2;
    if (p < tm) {
        link_item(v * 2 + 1, tl, tm, p, id, up);
    } else {
        link_item(v * 2 + 2, tm, tr, p, id, up);
    }
}

void compress() {
    vector<pair<int, pair<int, int>>> v;
    rep(i, n) {
        v.push_back({a[i][0], {0, i}});
        v.push_back({a[i][1], {1, i}});
        v.push_back({a[i][2], {0, i}});
        v.push_back({a[i][3], {1, i}});
    }
    sort(all(v));
    v.resize(unique(all(v)) - v.begin());
    m = v.size();
    assert(m == n * 4);
    rep(i, n) {
        a[i][0] = lower_bound(all(v), mp(a[i][0], mp(0, i))) - v.begin();
        a[i][1] = lower_bound(all(v), mp(a[i][1], mp(1, i))) - v.begin();
        a[i][2] = lower_bound(all(v), mp(a[i][2], mp(0, i))) - v.begin();
        a[i][3] = lower_bound(all(v), mp(a[i][3], mp(1, i))) - v.begin();
    }
}

bool used[MAXNODE];
vector<int> top;
int col[MAXNODE];

void dfs(int v) {
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    top.push_back(v);
}

void cfs(int v, int c) {
    col[v] = c;
    for (auto to : gr[v]) {
        if (col[to] == -1) {
            cfs(to, c);
        }
    }
}

int main() {
    FAST_IO;
    cin >> n;
    rep(i, n) {
        rep(j, 4) {
            cin >> a[i][j];
        }
    }
    compress();
    last = n * 2;

    build(0, 0, m, false);
    rep(i, n) {
        link_seg(0, 0, m, a[i][0] + 1, a[i][1], i, false);
        link_item(0, 0, m, a[i][0], i + n, false);
        link_item(0, 0, m, a[i][1], i + n, false);

        link_seg(0, 0, m, a[i][2] + 1, a[i][3], i + n, false);
        link_item(0, 0, m, a[i][2], i, false);
        link_item(0, 0, m, a[i][3], i, false);
    }

    build(0, 0, m, true);
    rep(i, n) {
        link_seg(0, 0, m, a[i][0] + 1, a[i][1], i + n, true);
        link_item(0, 0, m, a[i][0], i, true);
        link_item(0, 0, m, a[i][1], i, true);

        link_seg(0, 0, m, a[i][2] + 1, a[i][3], i, true);
        link_item(0, 0, m, a[i][2], i + n, true);
        link_item(0, 0, m, a[i][3], i + n, true);
    }

    // rep(i, n * 2) {
    //     int i2 = (i < n ? i + n : i - n);
    //     int l1, r1;
    //     if (i < n) {
    //         l1 = a[i][0], r1 = a[i][1];
    //     } else {
    //         l1 = a[i - n][2], r1 = a[i - n][3];
    //     }
    //     rep(j, n * 2) {
    //         if (j == i || j == i2) continue;
    //         int j2 = (j < n ? j + n : j - n);
    //         int l2, r2;
    //         if (j < n) {
    //             l2 = a[j][0], r2 = a[j][1];
    //         } else {
    //             l2 = a[j - n][2], r2 = a[j - n][3];
    //         }

    //         if (min(r1, r2) >= max(l1, l2)) {
    //             // cout << "bad " << i << ' ' << j << endl;
    //             link(i, j2);
    //             link(j, i2);
    //         }
    //     }
    // }

    rep(i, last) {
        if (!used[i]) {
            dfs(i);
        }
    }

    assert(top.size() == last);

    fill(col, col + last, -1);
    for (int i = last - 1; i >= 0; --i) {
        int v = top[i];
        if (col[v] == -1) {
            cfs(v, i);
        }
    }

    vector<int> ans(n);

    rep(i, n) {
        if (col[i] == col[i + n]) {
            cout << "No" << endl;
            return 0;
        }
        if (col[i] > col[i + n]) {
            ans[i] = 2;
        } else {
            ans[i] = 1;
        }
    }

    cout << "Yes" << '\n';
    rep(i, n) {
        cout << ans[i] << '\n';
    }
}
