// #include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
using ull = unsigned long long;
#define mp make_pair
#define x first
#define y second
#define f first
#define s second

const int MAXN = 1e6 + 5;
int n, m;
pii a[MAXN];
pii b[MAXN];
vector<int> vx, vy;

struct answer {
    int t, x, y;
    void print() {
        cout << t << ' ' << x << ' ' << y << '\n';
    }
};

answer get_kill(int i) {
    return {1, vx[a[i].x], vy[a[i].y] + 1};
}

answer get_kill(int i, int j) {
    if (a[i].x == a[j].x) {
        if (a[i].y < a[j].y) {
            return {1, vx[a[i].x], vy[a[i].y] + 1};
        } else {
            return {1, vx[a[i].x], vy[a[i].y] - 1};
        }
    } else if (a[i].y == a[j].y) {
        if (a[i].x < a[j].x) {
            return {0, vx[a[i].x] + 1, vy[a[i].y]};
        } else {
            return {0, vx[a[i].x] - 1, vy[a[i].y]};
        }
    } else {
        assert(false);
    }
}

void compress() {
    rep(i, n) {
        vx.push_back(a[i].x);
        vy.push_back(a[i].y);
    }
    rep(i, m) {
        vx.push_back(b[i].x);
        vy.push_back(b[i].y);
    }
    sort(all(vx));
    sort(all(vy));
    vx.resize(unique(all(vx)) - vx.begin());
    vy.resize(unique(all(vy)) - vy.begin());
    rep(i, n) {
        a[i].x = lower_bound(all(vx), a[i].x) - vx.begin();
        a[i].y = lower_bound(all(vy), a[i].y) - vy.begin();
    }
    rep(i, m) {
        b[i].x = lower_bound(all(vx), b[i].x) - vx.begin();
        b[i].y = lower_bound(all(vy), b[i].y) - vy.begin();
    }
}

vector<pii> by_x[MAXN];
int last_hor;
int hor[MAXN];
vector<int> by_hor[MAXN];
vector<pii> by_y[MAXN];
int last_ver;
int ver[MAXN];
vector<int> by_ver[MAXN];
// vector<int> g[MAXN];

// void link(int u, int v) {
//     g[u].push_back(v);
//     g[v].push_back(u);
// }

int ans = 1e9;
int best[MAXN];
int cur;
int col[MAXN];
// bool killed[MAXN];

void gen(int i) {
    if (i == n) {
        if (cur < ans) {
            ans = cur;
            rep(i, n) {
                best[i] = col[i];
            }
        }
        return;
    }

    if (col[i] != -1) {
        gen(i + 1);
        return;
    }

    cur++;
    col[i] = i;
    gen(i + 1);
    for (int j = i + 1; j < n; ++j) {
        if ((hor[i] == hor[j] || ver[i] == ver[j]) && col[j] == -1) {
            col[i] = j;
            col[j] = i;
            gen(i + 1);
            col[j] = -1;
        }
    }
    cur--;
    col[i] = -1;
}

int main() {
    FAST_IO;
    cin >> n;
    rep(i, n) {
        cin >> a[i].x >> a[i].y;
    }
    cin >> m;
    rep(i, m) {
        cin >> b[i].x >> b[i].y;
    }

    compress();

    rep(i, n) {
        by_x[a[i].x].push_back({i, 0});
    }
    rep(i, m) {
        by_x[b[i].x].push_back({i, 1});
    }

    // rep(i, vx.size()) {
    //     cout << i << " : ";
    //     for (auto it : by_x[i]) {
    //         cout << it.f << ' ' << it.s << endl;
    //     }
    // }

    rep(x, vx.size()) {
        if (by_x[x].empty()) continue;
        sort(all(by_x[x]), [&](const pii &x, const pii &y){
            return (x.s ? b[x.f].y : a[x.f].y) < (y.s ? b[y.f].y : a[y.f].y);
        });
        int last = -1;
        int maxl = -1;
        for (auto &it : by_x[x]) {
            if (it.s == 0) {
                if (last != -1 && a[last].y > maxl) {
                    hor[it.f] = hor[last];
                } else {
                    hor[it.f] = last_hor++;
                }
                by_hor[hor[it.f]].push_back(it.f);

                last = it.f;
            } else {
                maxl = b[it.f].y;
            }
        }
    }

    rep(i, n) {
        by_y[a[i].y].push_back({i, 0});
    }
    rep(i, m) {
        by_y[b[i].y].push_back({i, 1});
    }

    rep(y, vy.size()) {
        if (by_y[y].empty()) continue;
        sort(all(by_y[y]), [&](const pii &x, const pii &y){
            return (x.s ? b[x.f].x : a[x.f].x) < (y.s ? b[y.f].x : a[y.f].x);
        });
        int last = -1;
        int maxl = -1;
        for (auto &it : by_y[y]) {
            if (it.s == 0) {
                if (last != -1 && a[last].x > maxl) {
                    ver[it.f] = ver[last];
                } else {
                    ver[it.f] = last_ver++;
                }
                by_ver[ver[it.f]].push_back(it.f);

                last = it.f;
            } else {
                maxl = b[it.f].x;
            }
        }
    }

    fill(col, col + n, -1);
    gen(0);

    cout << ans << endl;
    rep(i, n) {
        if (best[i] == i) {
            get_kill(i).print();
        }
    }

    rep(i, n) {
        if (best[i] > i) {
            get_kill(i, best[i]).print();
        }
    }

    // rep(i, n) {
    //     link(hor[i], ver[i] + last_hor);
    // }


}
