// #include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <cassert>
#include <algorithm>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
using ull = unsigned long long;
#define mp make_pair
#define x first
#define y second
#define f first
#define s second

const int MAXN = 1e6 + 5;
int n, m;
pii a[MAXN];
pii b[MAXN];
vector<int> vx, vy;

struct answer {
    int t, x, y;
    void print() {
        cout << t << ' ' << x << ' ' << y << '\n';
    }
};

answer get_kill(int i) {
    return {1, vx[a[i].x], vy[a[i].y] + 1};
}

answer get_kill(int i, int j) {
    if (a[i].x == a[j].x) {
        if (a[i].y < a[j].y) {
            return {1, vx[a[i].x], vy[a[i].y] + 1};
        } else {
            return {1, vx[a[i].x], vy[a[i].y] - 1};
        }
    } else if (a[i].y == a[j].y) {
        if (a[i].x < a[j].x) {
            return {0, vx[a[i].x] + 1, vy[a[i].y]};
        } else {
            return {0, vx[a[i].x] - 1, vy[a[i].y]};
        }
    } else {
        assert(false);
    }
}

void compress() {
    rep(i, n) {
        vx.push_back(a[i].x);
        vy.push_back(a[i].y);
    }
    rep(i, m) {
        vx.push_back(b[i].x);
        vy.push_back(b[i].y);
    }
    sort(all(vx));
    sort(all(vy));
    vx.resize(unique(all(vx)) - vx.begin());
    vy.resize(unique(all(vy)) - vy.begin());
    rep(i, n) {
        a[i].x = lower_bound(all(vx), a[i].x) - vx.begin();
        a[i].y = lower_bound(all(vy), a[i].y) - vy.begin();
    }
    rep(i, m) {
        b[i].x = lower_bound(all(vx), b[i].x) - vx.begin();
        b[i].y = lower_bound(all(vy), b[i].y) - vy.begin();
    }
}

vector<pii> by_x[MAXN];
int last_hor;
int hor[MAXN];
vector<int> by_hor[MAXN];
vector<pii> by_y[MAXN];
int last_ver;
int ver[MAXN];
vector<int> by_ver[MAXN];
// vector<int> g[MAXN];

// void link(int u, int v) {
//     g[u].push_back(v);
//     g[v].push_back(u);
// }

int ans = 1e9;
int best[MAXN];
int cur;
int col[MAXN];

bool is_bet(int x1, int y1, int x2, int y2, int x, int y) {
    return min(x1, x2) <= x && x <= max(x1, x2) && min(y1, y2) <= y && y <= max(y1, y2);
}

void rec(int iter) {
    bool ok = true;
    rep(i, n) {
        if (col[i] == -1) {
            ok = false;
        }
    }

    if (ok) {
        if (cur < ans) {
            ans = cur;
            rep(i, n) {
                best[i] = col[i];
            }
        }
        return;
    }

    ok = false;
    rep(i, n) {
        if (col[i] != -1) continue;
        for (int j = i + 1; j < n; ++j) {
            if (col[j] != -1 || (a[i].x != a[j].x && a[i].y != a[j].y)) continue;
            bool good = true;
            rep(k, n) {
                if (k == i || k == j || col[k] == -1) continue;
                if (is_bet(a[i].x, a[i].y, a[j].x, a[j].y, a[k].x, a[k].y)) {
                    good = false;
                    break;
                }
            }
            if (good) {
                rep(k, m) {
                    if (is_bet(a[i].x, a[i].y, a[j].x, a[j].y, b[k].x, b[k].y)) {
                        good = false;
                        break;
                    }
                }
            }

            if (!good) continue;
            ok = true;

            col[i] = col[j] = iter;
            cur++;
            rec(iter + 1);
            cur--;
            col[i] = col[j] = -1;
        }
    }

    if (!ok) {
        rep(i, n) {
            if (col[i] != -1) {
                continue;
            }
            col[i] = iter;
            cur++;
            rec(iter + 1);
            cur--;
            col[i] = -1;
        }
    }
}

int main() {
    FAST_IO;
    cin >> n;
    rep(i, n) {
        cin >> a[i].x >> a[i].y;
    }
    cin >> m;
    rep(i, m) {
        cin >> b[i].x >> b[i].y;
    }

    compress();

    fill(col, col + n, -1);
    rec(0);

    cout << ans << '\n';
    rep(i, ans) {
        vector<int> oc;
        rep(j, n) {
            if (best[j] == i) {
                oc.push_back(j);
            }
        }
        assert(oc.size() == 1 || oc.size() == 2);
        if (oc.size() == 1) {
            get_kill(oc[0]).print();
        } else {
            get_kill(oc[0], oc[1]).print();
        }
    }
}
