#include <bits/stdc++.h>

using namespace std;

int read() {
	char c = getchar_unlocked();
	while (c < '0' || c > '9') {
		c = getchar_unlocked();
	}
	int ans = 0;
	while ('0' <= c && c <= '9') {
		ans = ans * 10 + c - '0';
		c = getchar_unlocked();
	}
	return ans;
}

const int M = 1e6 + 7;

vector <int> g[M];
bool u[M];

int edges = 0;

vector <pair <int, int> > dfs_tree, ot;

void dfs(int v, int pr = -1) {
	u[v] = true;
	for (int to : g[v]) {
		if (v < to) edges++;
		if (!u[to]) {
			dfs_tree.push_back({v, to});
			dfs(to, v);
		} else if (to != pr && v < to) {
			ot.push_back({v, to});
		}
	}
}

vector <int> cur[M];
bool vis[M];
vector <pair <pair <int, int>, pair <int, int> > > st;

bool zhfs(int v, int pr) {
	vis[v] = true;
	vector <pair <int, int> > gays;
	for (int to : g[v]) {
		if (vis[to]) continue;
		if (zhfs(to, v)) {
			if (!cur[to].empty()) {
				st.push_back({{v, to}, {to, cur[to].back()}});
				int go = cur[to].back();
				cur[go].pop_back();
				cur[to].pop_back();
			} else if (!cur[v].empty()) {
				st.push_back({{v, to}, {v, cur[v].back()}});
				int go = cur[v].back();
				cur[go].pop_back();
				cur[v].pop_back();
			} else {
				gays.push_back({v, to});
			}
		}
	}
	while (gays.size() > 1) {
		st.push_back({gays.back(), gays[gays.size() - 2]});
		gays.pop_back();
		gays.pop_back();
	}
	if (!gays.empty()) {
		st.push_back({gays.back(), {v, pr}});
		gays.pop_back();
		return false;
	} else {
		return true;
	}
}

set <int> s[M], alive[M];

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif 
	int n = read();
	map <int, vector <pair <int, int> > > l, r;
	vector <pair <int, int> > e;
	for (int i = 0; i < n; i++) {
		int x = read(), y = read();
		l[x].push_back({y, 0});
		r[y].push_back({x, 0});
		e.push_back({x, y});
	}
	int m = read();
	for (int i = 0; i < m; i++) {
		int x = read(), y = read();
		l[x].push_back({y, 1});
		r[y].push_back({x, 1});
	}
	map <pair <int, int>, int> f_l, f_r;
	int sz = 0;
	map <int, int> tx, ty;
	for (auto &c : l) {
		sort(c.second.begin(), c.second.end());
		for (int i = 0; i < (int) c.second.size(); i++) {
			if (c.second[i].second) {
				sz++;
			} else {
				tx[sz] = c.first;
				f_l[{c.first, c.second[i].first}] = sz;
			}
		}
		sz++;
	}
	for (auto &c : r) {
		sort(c.second.begin(), c.second.end());
		for (int i = 0; i < (int) c.second.size(); i++) {
			if (c.second[i].second) {
				sz++;
			} else {
				ty[sz] = c.first;
				f_r[{c.second[i].first, c.first}] = sz;
			}
		}
		sz++;
	}
	for (auto c : e) {
		g[f_l[c]].push_back(f_r[c]);
		g[f_r[c]].push_back(f_l[c]);
	}
	int tot = 0;
	for (int i = 0; i < sz; i++) {
		if (!u[i]) {
			edges = 0;
			dfs_tree.clear(), ot.clear();
			dfs(i);
			tot += (edges + 1) / 2;
			for (auto c : ot) {
				if (!cur[c.first].empty()) {
					int a = c.first, b = cur[c.first].back();
					cur[a].pop_back();
					cur[b].pop_back();
					st.push_back({{a, b}, c});
					continue;
				}
				swap(c.first, c.second);
				if (!cur[c.first].empty()) {
					int a = c.first, b = cur[c.first].back();
					cur[a].pop_back();
					cur[b].pop_back();
					st.push_back({{a, b}, c});
					continue;
				}
				cur[c.first].push_back(c.second);
				cur[c.second].push_back(c.first);
			}
			zhfs(i, -1);
		}
	}
	assert(st.size() == tot);
	vector <pair <int, pair <int, int> > > ans;
	int dobre = 0;
	for (auto c : st) {
		if (c.second.second == -1) {
			int a = c.first.first, b = c.first.second;
			if (a > b) swap(a, b);
			ans.push_back({1, {tx[a] - 1, ty[b]}});
		} else {
			int a = c.first.first, b = c.first.second;
			int C = c.second.first, d = c.second.second;
			alive[a].insert(b);
			alive[b].insert(a);
			alive[C].insert(d);
			alive[d].insert(C);
			if (a > b) swap(a, b);
			if (C > d) swap(C, d);
			if (a == C) {
				s[a].insert(b);
				s[a].insert(d);
			} else {
				s[b].insert(a);
				s[b].insert(C);
			}
			dobre++;
		}
	}
	while (dobre) {
		for (int i = 0; i < sz; i++) {
			for (auto &c : s[i]) {
				auto it = s[i].upper_bound(c);
				if (it != s[i].end() && *alive[i].upper_bound(c) == *it) {
					dobre--;
					int a = i;
					int x = c, y = *it;
					s[a].erase(x), s[a].erase(y);
					alive[x].erase(a), alive[y].erase(a);
					alive[a].erase(x), alive[a].erase(y);
					if (ty.count(a)) {
						ans.push_back({1, {tx[x] + 1, ty[a]}});
					} else {
						ans.push_back({0, {tx[a], ty[x] + 1}});
					}
					break;
				}
			}
		}
	}
	cout << ans.size() << endl;
	for (auto c : ans) {
		cout << c.first << ' ' << c.second.first << ' ' << c.second.second << '\n';
	}
}
