#include <bits/stdc++.h>

using namespace std;

int read() {
	char c = getchar_unlocked();
	while (c < '0' || c > '9') {
		c = getchar_unlocked();
	}
	int ans = 0;
	while ('0' <= c && c <= '9') {
		ans = ans * 10 + c - '0';
		c = getchar_unlocked();
	}
	return ans;
}

const int M = 1e6 + 7;

vector <int> g[M];
bool u[M];

int edges = 0;

vector <pair <int, int> > dfs_tree, ot;

void dfs(int v, int pr = -1) {
	u[v] = true;
	for (int to : g[v]) {
		if (v < to) edges++;
		if (!u[to]) {
			dfs_tree.push_back({v, to});
			dfs(to, v);
		} else if (to != pr && v < to) {
			ot.push_back({v, to});
		}
	}
}

vector <int> cur[M];
bool vis[M];
vector <pair <pair <int, int>, pair <int, int> > > st;

bool zhfs(int v, int pr) {
	vis[v] = true;
	vector <pair <int, int> > gays;
	for (int to : g[v]) {
		if (vis[to]) continue;
		if (zhfs(to, v)) {
			if (!cur[to].empty()) {
				st.push_back({{v, to}, {to, cur[to].back()}});
				int go = cur[to].back();
				cur[go].pop_back();
				cur[to].pop_back();
			} else if (!cur[v].empty()) {
				st.push_back({{v, to}, {v, cur[v].back()}});
				int go = cur[v].back();
				cur[go].pop_back();
				cur[v].pop_back();
			} else {
				gays.push_back({v, to});
			}
		}
	}
	while (gays.size() > 1) {
		st.push_back({gays.back(), gays[gays.size() - 2]});
		gays.pop_back();
		gays.pop_back();
	}
	if (!gays.empty()) {
		st.push_back({gays.back(), {v, pr}});
		gays.pop_back();
		return false;
	} else {
		return true;
	}
}

vector <int> s[M], alive[M];

struct triple {
	int first, second, third, fourth;
	triple(int a, int b, int c): first(a), second(b), third(c), fourth(-1) {
	}
	triple(int a, int b, int c, int d): first(a), second(b), third(c), fourth(-1) {
	}
};

bool operator < (triple a, triple b) {
	return a.first < b.first;
}

vector <triple> l[M], r[M];
int tx[M], ty[M];
int lid[M], rid[M];

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif 
	int n = read();
	vector <int> t;
	vector <int> px, py;
	vector <pair <int, int> > e, f;
	for (int i = 0; i < n; i++) {
		int x = read(), y = read();
		px.push_back(x), py.push_back(y);
		e.push_back({x, y});
	}
	int m = read();
	for (int i = 0; i < m; i++) {
		int x = read(), y = read();
		px.push_back(x), py.push_back(y);
		f.push_back({x, y});
	}
	sort(px.begin(), px.end());
	sort(py.begin(), py.end());
	px.resize(unique(px.begin(), px.end()) - px.begin());
	py.resize(unique(py.begin(), py.end()) - py.begin());
	int ptr = 0;
	for (auto &c : e) {
		c.first = lower_bound(px.begin(), px.end(), c.first) - px.begin();
		c.second = lower_bound(py.begin(), py.end(), c.second) - py.begin();
		l[c.first].push_back({c.second, 0, ptr});
		r[c.second].push_back({c.first, 0, ptr});
		ptr++;
	}
	for (auto &c : f) {
		c.first = lower_bound(px.begin(), px.end(), c.first) - px.begin();
		c.second = lower_bound(py.begin(), py.end(), c.second) - py.begin();
		l[c.first].push_back({c.second, 1, -1});
		r[c.second].push_back({c.first, 1, -1});
	}
	int sz = 0;
	for (int i = 0; i < (int) px.size(); i++) {
		auto &c = l[i];
		sort(c.begin(), c.end());
		int fir = -1;
		int a = i;
		for (int i = 0; i < (int) c.size(); i++) {
			if (c[i].second) {
				if (fir != -1) {
					sz++;
					fir = -1;
				}
			} else {
				fir = sz;
				tx[sz] = a;
				ty[sz] = -1;
				lid[c[i].third] = sz;
			}
		}
		if (fir != -1)
			sz++;
	}
	for (int i = 0; i < (int) py.size(); i++) {
		auto &c = r[i];
		sort(c.begin(), c.end());
		int fir = -1;
		int a = i;
		for (int i = 0; i < (int) c.size(); i++) {
			if (c[i].second) {
				if (fir != -1) {
					sz++;
					fir = -1;
				}
			} else {
				fir = sz;
				ty[sz] = a;
				rid[c[i].third] = sz;
			}
		}
		if (fir != -1)
			sz++;
	}
	for (int i = 0; i < (int) e.size(); i++) {
		int a = lid[i], b = rid[i];
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int tot = 0;
	for (int i = 0; i < sz; i++) {
		if (!u[i]) {
			edges = 0;
			dfs_tree.clear(), ot.clear();
			dfs(i);
			tot += (edges + 1) / 2;
			for (auto c : ot) {
				if (!cur[c.first].empty()) {
					int a = c.first, b = cur[c.first].back();
					cur[a].pop_back();
					cur[b].pop_back();
					st.push_back({{a, b}, c});
					continue;
				}
				swap(c.first, c.second);
				if (!cur[c.first].empty()) {
					int a = c.first, b = cur[c.first].back();
					cur[a].pop_back();
					cur[b].pop_back();
					st.push_back({{a, b}, c});
					continue;
				}
				cur[c.first].push_back(c.second);
				cur[c.second].push_back(c.first);
			}
			zhfs(i, -1);
		}
	}
	assert(st.size() == tot);
	vector <pair <int, pair <int, int> > > ans;
	int dobre = 0;
	vector <triple> p;
	for (auto c : st) {
		if (c.second.second == -1) {
			int a = c.first.first, b = c.first.second;
			if (a > b) swap(a, b);
			ans.push_back({1, {px[tx[a]] - 1, py[ty[b]]}});
		} else {
			int a = c.first.first, b = c.first.second;
			int C = c.second.first, d = c.second.second;
			alive[a].push_back(b);
			alive[b].push_back(a);
			alive[C].push_back(d);
			alive[d].push_back(C);
			if (a > b) swap(a, b);
			if (C > d) swap(C, d);
			if (a == C) {
				s[a].push_back(b);
				s[a].push_back(d);
			} else {
				s[b].push_back(a);
				s[b].push_back(C);
			}
			dobre++;
		}
	}
	for (int i = 0; i < sz; i++) {
		sort(s[i].begin(), s[i].end());
		for (int j = 0; j < (int) s[i].size(); j += 2) {
			p.push_back({s[i][j + 1] - s[i][j], i, s[i][j], s[i][j + 1]});
		}
	}
	sort(p.begin(), p.end());
	for (auto c : p) {
		int a = c.second, x = c.third, y = c.fourth;
		if (ty[a] != -1) {
			ans.push_back({1, {px[tx[x]] + 1, py[ty[a]]}});
		} else {
			ans.push_back({0, {px[tx[a]], py[ty[x]] + 1}});
		}
	}
	/*
	while (dobre) {
		for (int i = 0; i < sz; i++) {
			for (auto &c : s[i]) {
				auto it = s[i].upper_bound(c);
				if (it != s[i].end() && *alive[i].upper_bound(c) == *it) {
					dobre--;
					int a = i;
					int x = c, y = *it;
					s[a].erase(x), s[a].erase(y);
					alive[x].erase(a), alive[y].erase(a);
					alive[a].erase(x), alive[a].erase(y);
					if (ty[a] != -1) {
						ans.push_back({1, {px[tx[x]] + 1, py[ty[a]]}});
					} else {
						ans.push_back({0, {px[tx[a]], py[ty[x]] + 1}});
					}
					break;
				}
			}
		}
	}
	*/
	cout << ans.size() << endl;
	for (auto c : ans) {
		cout << (1 ^ c.first) << ' ' << c.second.first << ' ' << c.second.second << '\n';
	}
}
