#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 4010;
int n, V, a[mx][2], b[mx][2], ans[mx], used[mx], cmp[mx], cmp_cnt;
vector<vector<int> > g, _g;
vector<int> topsort;

void build_graph() {
	g.resize(2 * n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 2; ++j) {
			for (int i1 = 0; i1 < n; ++i1) {
				if (i == i1) {
					continue;
				}
				for (int j1 = 0; j1 < 2; ++j1) {
					if (max(a[i][j], a[i1][j1]) <= min(b[i][j], b[i1][j1])) {
						g[2 * i + j].push_back(2 * i1 + (j1 ^ 1));
					}
				}
			}
		}
	}
	V = 2 * n;
}

void build_topsort(int v) {
	used[v] = 1;
	for (auto v1 : g[v]) {
		if (used[v1] == 0) {
			build_topsort(v1);
		}
	}
	topsort.push_back(v);
}

void cmp_dfs(int v) {
	cmp[v] = cmp_cnt;
	for (auto v1 : _g[v]) {
		if (cmp[v1] == -1) {
			cmp_dfs(v1);
		}
	}
}

void just_dfs(int v) {
	used[v] = 1;
	for (auto v1 : g[v]) {
		if (used[v1] == 0) {
			just_dfs(v1);
		}
	}
}

int process() {
	for (int i = 0; i < V; ++i) {
		if (used[i] == 0) {
			build_topsort(i);
		}
	}
	reverse(all(topsort));

	_g.resize(V);
	for (int i = 0; i < V; ++i) {
		for (auto v : g[i]) {
			_g[v].push_back(i);
		}
	}

	fill(cmp, cmp + V, -1);
	for (int i = 0; i < V; ++i) {
		if (cmp[topsort[i]] == -1) {
			cmp_dfs(topsort[i]);
			cmp_cnt++;
		}
	}

	fill(used, used + V, 0);
	for (int i = 0; i < n; ++i) {
		if (cmp[2 * i] == cmp[2 * i + 1]) {
			return 0;
		}
		if (used[2 * i]) {
			ans[i] = 0;
			continue;
		}
		if (used[2 * i + 1]) {
			ans[i] = 1;
			continue;
		}
		if (cmp[2 * i] > cmp[2 * i + 1]) {
			ans[i] = 0;
			just_dfs(2 * i);
			continue;
		} else {
			ans[i] = 1;
			just_dfs(2 * i + 1);
			continue;
		}
	}
	return 1;
}

void read() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 2; ++j) {
			cin >> a[i][j] >> b[i][j];
		}
	}
}

void check_ans() {
	vector<pair<int, int> > vp;
	for (int i = 0; i < n; ++i) {
		vp.emplace_back(a[i][ans[i]], b[i][ans[i]]);
	}
	sort(all(vp));
	for (int i = 1; i < (int)vp.size(); ++i) {
		assert(vp[i].first > vp[i - 1].second);
	}
}

int main() {
	fast_io();
	read();
	build_graph();
	int can = process();
	if (can) {
		check_ans();
		cout << "Yes\n";
		for (int i = 0; i < n; ++i) {
			cout << ans[i] + 1 << "\n";
		}
	} else {
		cout << "No\n";
	}
}
