#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 1e5 + 228;
const int MX = 2e6;
int n, V, a[mx][2], b[mx][2], ans[mx], used[MX], cmp[MX], cmp_cnt;
vector<vector<int> > g, _g;
vector<int> topsort;
int genre_id[4 * mx], Lv[MX], Rv[MX];

int new_vertex() {
	g.push_back(vector<int> ());
	return (int)g.size() - 1;
}

void build_st(int v, int tl, int tr) {
	if (tl == tr) {
		g[v].push_back(genre_id[tl] ^ 1);
	} else {
		int tm = (tl + tr) >> 1;
		int l = new_vertex();
		int r = new_vertex();
		g[v] = {l, r};
		build_st(l, tl, tm);
		build_st(r, tm + 1, tr);
	}
}

void build_st2(int v, int tl, int tr) {
	if (tl == tr) {
		g[genre_id[tl]].push_back(v);
	} else {
		int tm = (tl + tr) >> 1;
		int l = new_vertex();
		int r = new_vertex();
		Lv[v] = l;
		Rv[v] = r;
		g[l].push_back(v);
		g[r].push_back(v);
		build_st2(l, tl, tm);
		build_st2(r, tm + 1, tr);
	}
}

void make_edges(int v0, int l, int r, int v, int tl, int tr) {
	if (l > r) {
		return;
	}
	if (l == tl && r == tr) {
		g[v0].push_back(v);
		return;
	}
	int tm = (tl + tr) >> 1;
	make_edges(v0, l, min(r, tm), g[v][0], tl, tm);
	make_edges(v0, max(l, tm + 1), r, g[v][1], tm + 1, tr);
}

void make_rev_edges(int v0, int l, int r, int v, int tl, int tr) {
	if (l > r) {
		return;
	}
	if (l == tl && r == tr) {
		g[v].push_back(v0 ^ 1);
		return;
	}
	int tm = (tl + tr) >> 1;
	make_rev_edges(v0, l, min(r, tm), Lv[v], tl, tm);
	make_rev_edges(v0, max(l, tm + 1), r, Rv[v], tm + 1, tr);
}

void build_graph() {
	g.resize(2 * n);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 2; ++j) {
			genre_id[a[i][j]] = 2 * i + j;
			genre_id[b[i][j]] = 2 * i + j;
		}
	}
	int st_root = new_vertex();
	build_st(st_root, 0, 4 * n - 1);
	int st2_root = new_vertex();
	build_st2(st2_root, 0, 4 * n - 1);
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 2; ++j) {
			make_edges(2 * i + j, a[i][j] + 1, b[i][j] - 1, st_root, 0, 4 * n - 1);
			make_rev_edges(2 * i + j, a[i][j] + 1, b[i][j] - 1, st2_root, 0, 4 * n - 1);
		}
	}
	
	V = g.size();
}

void build_topsort(int v) {
	used[v] = 1;
	for (auto v1 : g[v]) {
		if (used[v1] == 0) {
			build_topsort(v1);
		}
	}
	topsort.push_back(v);
}

void cmp_dfs(int v) {
	cmp[v] = cmp_cnt;
	for (auto v1 : _g[v]) {
		if (cmp[v1] == -1) {
			cmp_dfs(v1);
		}
	}
}

void just_dfs(int v) {
	used[v] = 1;
	for (auto v1 : g[v]) {
		if (used[v1] == 0) {
			just_dfs(v1);
		}
	}
}

void print_g() {
	cerr << "V = " << V << endl;
}

int process() {
	print_g();
	for (int i = 0; i < V; ++i) {
		if (used[i] == 0) {
			build_topsort(i);
		}
	}
	reverse(all(topsort));

	_g.resize(V);
	for (int i = 0; i < V; ++i) {
		for (auto v : g[i]) {
			_g[v].push_back(i);
		}
	}

	fill(cmp, cmp + V, -1);
	for (int i = 0; i < V; ++i) {
		if (cmp[topsort[i]] == -1) {
			cmp_dfs(topsort[i]);
			cmp_cnt++;
		}
	}


	fill(used, used + V, 0);
	for (int i = 0; i < n; ++i) {
		if (cmp[2 * i] == cmp[2 * i + 1]) {
			return 0;
		}
		if (used[2 * i]) {
			ans[i] = 0;
			continue;
		}
		if (used[2 * i + 1]) {
			ans[i] = 1;
			continue;
		}
		if (cmp[2 * i] > cmp[2 * i + 1]) {
			ans[i] = 0;
			just_dfs(2 * i);
			continue;
		} else {
			ans[i] = 1;
			just_dfs(2 * i + 1);
			continue;
		}
	}
	return 1;
}

void read() {
	cin >> n;
	vector<pair<int, int> > vp;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 2; ++j) {
			cin >> a[i][j] >> b[i][j];
			vp.emplace_back(a[i][j], -1 - (2 * i + j));
			vp.emplace_back(b[i][j], 2 * i + j);
		}
	}
	sort(all(vp));
	for (int i = 0; i < (int)vp.size(); ++i) {
		if (vp[i].second < 0) {
			int id = -vp[i].second - 1;
			a[id >> 1][id & 1] = i;
		} else {
			int id = vp[i].second;
			b[id >> 1][id & 1] = i;
		}
	}

	// cerr << "seg" << endl;
	// for (int i = 0; i < n; ++i) {
	// 	for (int j = 0; j < 2; ++j) {
	// 		cerr << a[i][j] << " " << b[i][j] << " ";
	// 	}
	// 	cerr << endl;
	// }
}

void check_ans() {
	vector<pair<int, int> > vp;
	for (int i = 0; i < n; ++i) {
		vp.emplace_back(a[i][ans[i]], b[i][ans[i]]);
	}
	sort(all(vp));
	for (int i = 1; i < (int)vp.size(); ++i) {
		assert(vp[i].first > vp[i - 1].second);
	}
}

int main() {
	fast_io();
	read();
	build_graph();
	int can = process();
	if (can) {
		check_ans();
		cout << "Yes\n";
		for (int i = 0; i < n; ++i) {
			cout << ans[i] + 1 << "\n";
		}
	} else {
		cout << "No\n";
	}
}
