#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct pt {
	int x, y;
	pt(int _x, int _y): x(_x), y(_y) {}
	pt(): x(0), y(0) {}
};

int distance(const pt &a, const pt &b) {
	return abs(a.x - b.x) + abs(a.y - b.y);
}

pt middle(const pt &a, const pt &b) {
	return pt((a.x + b.x) / 2, (a.y + b.y) / 2);
}

pt adj(const pt &a) {
	return pt(a.x + 1, a.y);
}

void read(int &n, vector<pt> &a) {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
}

int n, m;
vector<pt> a, stones;
vector<vector<int> > ans;

void remove_two(int i, int j) {
	int type = -1;
	if (a[i].x == a[j].x) {
		type = 1;
	}
	if (a[i].y == a[j].y) {
		type = 0;
	}
	assert(type != -1);
	pt pp = middle(a[i], a[j]);
	ans.push_back({type, pp.x, pp.y});
}

void remove_one(int i) {
	pt pp = adj(a[i]);
	ans.push_back({0, pp.x, pp.y});
}

int can(int i, int j) {
	int type = -1;
	if (a[i].x == a[j].x) {
		type = 1;
	}
	if (a[i].y == a[j].y) {
		type = 0;
	}
	if (type == -1) {
		return 0;
	}
	for (auto pp : stones) {
		if (distance(a[i], pp) + distance(pp, a[j]) == distance(a[i], a[j])) {
			return 0;
		}
	}
	return 1;
}

const int mx = 2e3 + 228;
vector<vector<int> > g;
int dead[mx];

void dfs(int v, int pv) {
	if (v != pv && dead[pv] == 0) {
		remove_two(v, pv);
		dead[v] = 1;
		dead[pv] = 1;
	}
	for (auto v1 : g[v]) {
		if (v1 != pv && dead[v1] == 0) {
			dfs(v1, v);
		}
	}
	if (dead[v] == 0) {
		remove_one(v);
		dead[v] = 1;
	}
}

int deg[mx];

int main() {
	fast_io();
	read(n, a);
	read(m, stones);

	g.resize(n);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (a[i].x == a[j].x || a[i].y == a[j].y) {
				if (can(i, j)) {
					// cerr << "edge " << i << " " << j << endl;
					g[i].push_back(j);
					g[j].push_back(i);
					deg[i]++;
					deg[j]++;
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		assert(deg[i] <= 2);
		if (deg[i] <= 1 && dead[i] == 0) {
			dfs(i, i);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (dead[i] == 0) {
			dfs(i, i);
		}
	}

	cout << ans.size() << endl;
	for (auto v : ans) {
		for (auto x : v) {
			cout << x << " ";
		}
		cout << endl;
	}
}
