#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct pt {
	int x, y;
	pt(int _x, int _y): x(_x), y(_y) {}
	pt(): x(0), y(0) {}
};

int distance(const pt &a, const pt &b) {
	return abs(a.x - b.x) + abs(a.y - b.y);
}

pt middle(const pt &a, const pt &b) {
	return pt((a.x + b.x) / 2, (a.y + b.y) / 2);
}

pt adj(const pt &a) {
	return pt(a.x + 1, a.y);
}

void read(int &n, vector<pt> &a) {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
}

int n, m;
vector<pt> a, stones;
vector<vector<int> > ans;

void remove_two(int i, int j) {
	int type = -1;
	if (a[i].x == a[j].x) {
		type = 1;
	}
	if (a[i].y == a[j].y) {
		type = 0;
	}
	assert(type != -1);
	pt pp = middle(a[i], a[j]);
	ans.push_back({type, pp.x, pp.y});
}

void remove_one(int i) {
	pt pp = adj(a[i]);
	ans.push_back({0, pp.x, pp.y});
}

vector<int> xc, yc;
const int INF = 1e9;
const int mx = 4e3 + 228;
int len, id[2][mx], dp[mx][2][2], go[mx][2][2], go_m1[mx][2][2], go_m2[mx][2][2], bad[mx];

void calc_dp() {
	for (int i = 0; i <= len; ++i) {
		for (int m1 = 0; m1 < 2; ++m1) {
			for (int m2 = 0; m2 < 2; ++m2) {
				dp[i][m1][m2] = INF;
			}
		}
	}

	dp[0][0][0] = 0;

	for (int i = 0; i < len; ++i) {
		for (int m1 = 0; m1 < 2; ++m1) {
			for (int m2 = 0; m2 < 2; ++m2) {
				if (id[0][i] >= 0 && id[1][i] >= 0 && chkmin(dp[i + 1][m1 ^ 1][m2 ^ 1], dp[i][m1][m2])) {
					go[i + 1][m1 ^ 1][m2 ^ 1] = 1;
					go_m1[i + 1][m1 ^ 1][m2 ^ 1] = m1;
					go_m2[i + 1][m1 ^ 1][m2 ^ 1] = m2;
				}
				int up = 0, _m1 = m1, _m2 = m2;
				if (id[0][i] >= 0) {
					_m1 ^= 1;
				}
				if (id[1][i] >= 0) {
					_m2 ^= 1;
				}
				if (id[0][i] == -1) {
					_m1 = 0;
					up += m1;
				}
				if (id[0][i] == -1) {
					_m2 = 0;
					up += m2;
				}
				if (chkmin(dp[i + 1][_m1][_m2], dp[i][m1][m2] + up)) {
					go[i + 1][_m1][_m2] = 0;
					go_m1[i + 1][_m1][_m2] = m1;
					go_m2[i + 1][_m1][_m2] = m2;
				}
			}
		}
	}
}

void restore_dp() {
	int best = INF;
	int pos = len, m1 = -1, m2 = -1;
	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < 2; ++j) {
			if (chkmin(best, dp[pos][i][j])) {
				m1 = i;
				m2 = j;
			}
		}
	}

	while (pos) {
		if (go[pos][m1][m2]) {
			bad[pos - 1] = 1;
		}
		int _m1 = go_m1[pos][m1][m2];
		int _m2 = go_m2[pos][m1][m2];
		pos--;
		m1 = _m1;
		m2 = _m2;
	}
}

void update(int &c, int x) {
	if (x == -2) {
		return;
	}
	if (c == -1 && x == -1) {
		return;
	}
	if (c == -1 && x != -1) {
		c = x;
	}
	if (c != -1 && x == -1) {
		remove_one(c);
		c = -1;
	}
	if (c != -1 && x != -1) {
		remove_two(c, x);
		c = -1;
	}
}

int cache[2];

void build_ans() {
	cache[0] = -1;
	cache[1] = -1;
	for (int i = 0; i < len; ++i) {
		if (bad[i]) {
			remove_two(id[0][i], id[1][i]);
		} else {
			update(cache[0], id[0][i]);
			update(cache[1], id[1][i]);
		}
	}
}

int main() {
	fast_io();
	read(n, a);
	read(m, stones);

	for (int i = 0; i < n; ++i) {
		xc.push_back(a[i].x);
		yc.push_back(a[i].y);
	}
	for (int i = 0; i < m; ++i) {
		xc.push_back(stones[i].x);
		yc.push_back(stones[i].y);
	}
	sort(all(xc));
	xc.erase(unique(all(xc)), xc.end());
	sort(all(yc));
	yc.erase(unique(all(yc)), yc.end());
	assert(yc.size() == 2);

	len = xc.size() + 1;
	id[len - 1][0] = -1;
	id[len - 1][1] = -1;
	for (int i = 0; i < 2; ++i) {
		for (int j = 0; j < len; ++j) {
			id[i][j] = -2;
		}
	}

	for (int i = 0; i < n; ++i) {
		int _x = lower_bound(all(xc), a[i].x) - xc.begin();
		int _y = lower_bound(all(yc), a[i].y) - yc.begin();
		id[_y][_x] = i;
	}
	for (int i = 0; i < m; ++i) {
		int _x = lower_bound(all(xc), a[i].x) - xc.begin();
		int _y = lower_bound(all(yc), a[i].y) - yc.begin();
		id[_y][_x] = -1;
	}
	calc_dp();
	restore_dp();
	build_ans();

	cout << ans.size() << endl;
	for (auto v : ans) {
		for (auto x : v) {
			cout << x << " ";
		}
		cout << endl;
	}
}
