#include "bits/stdc++.h"

#define random anotehsaontehsnaohesn
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

namespace random {
	using namespace std::chrono;
	mt19937 rng(duration_cast<milliseconds>(
		system_clock::now().time_since_epoch()).count());
	uniform_real_distribution<> prob_dist(0.0, 1.0);
};

using namespace random;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	return os;
}

const int N = (1 << 19);
vector<int> in[2 * N + 1];
const int OFFT = 4 * N;
const int OFF = OFFT + 2 * (2 * N + 1500000);
const int M = OFF + 2 * 100000;
vector<int> g[M];

void add_edge(int a, int b) {
	if (a >= M) exit(0);
	if (b >= M) exit(0);
	// assert(a < M);
	// assert(b < M);
	g[a].pb(b);
}

vector<bool> used;
vector<int> top;
void topsort(int v) {
	used[v] = true;
	for (int sub : g[v]) {
		if (used[sub]) continue;
		topsort(sub);
	}
	top.pb(v);
}
vector<int> at;

void dfs(int v, int comp) {
	at[v] = comp;
	used[v] = true;
	for (int sub : g[v]) {
		if (used[sub]) continue;
		dfs(sub, comp);
	}
}

void act() {
	for (int i = 0; i < 2 * N + 1; i++) {
		in[i].clear();
		in[i].shrink_to_fit();
	}
	used = vector<bool>(M, false);
	for (int i = 0; i < M; i++) {
		if (used[i]) continue;
		topsort(i);
	}
	reverse(top.begin(), top.end());
	vector<pii> edges;
	for (int i = 0; i < M; i++) {
		for (int j : g[i]) {
			edges.emplace_back(j, i);
		}
		g[i].clear();
		g[i].shrink_to_fit();
	}
	for (pii e : edges) {
		g[e.x].pb(e.y);
	}	
	edges.clear();
	edges.shrink_to_fit();
	used = vector<bool>(M, false);
	int comp = 0;
	at.resize(M, -1);
	for (int i : top) {
		if (used[i]) continue;
		dfs(i, comp);
		comp++;
	}
}

void connect(int i, int tl, int tr, int ql, int qr, int source) {
	if (tr <= ql || qr <= tl) return;
	if (ql <= tl && tr <= qr) {
		in[i].pb(source);
	} else {
		int m = (tl + tr) / 2;
		connect(i * 2 + 1, tl, m, ql, qr, source);
		connect(i * 2 + 2, m, tr, ql, qr, source);
	}
}

int n;
struct Perf {
	pii f, s;
};
vector<Perf> v;
vector<int> cords;
void disable(int source, int l, int r) {
	l = lower_bound(cords.begin(), cords.end(), l) - cords.begin();
	r = lower_bound(cords.begin(), cords.end(), r) - cords.begin();
	connect(0, 0, N, l, r + 1, source);
}
void init(int i, int tl, int tr) {
	if (tl + 1 != tr) {
		int m = (tl + tr) / 2;
		in[i * 2 + 1].pb(i * 2);
		in[i * 2 + 2].pb(i * 2);
		// add_edge(i * 2 + 1, (i * 2 + 1) * 2 + 1);
		// add_edge(i * 2 + 1, (i * 2 + 2) * 2 + 1);
		init(i * 2 + 1, tl, m);
		init(i * 2 + 2, m, tr);
	}
}
int it = 0;
void belfast(int i, int tl, int tr) {
	for (int j = 0; j < len(in[i]); j++) {
		if (j > 0) {
			add_edge(OFFT + it + j, in[i][j - 1] ^ 1);
			add_edge(OFFT + it + j, OFFT + it + (j - 1));
		}
	}
	for (int j = len(in[i]) - 1; ~j; j--) {
		if (j + 1 < len(in[i])) {
			add_edge(OFFT + it + len(in[i]) + j, in[i][j + 1] ^ 1);
			add_edge(OFFT + it + len(in[i]) + j,
				OFFT + it + len(in[i]) + (j + 1));
		}
	}
	for (int j = 0; j < len(in[i]); j++) {
		add_edge(in[i][j], OFFT + it + j);
		add_edge(in[i][j], OFFT + it + len(in[i]) + j);
		// for (int subx : in[i]) {
		// 	if (subx == sub) continue;
		// 	add_edge(sub, subx ^ 1);
		// }
	}
	it += 2 * len(in[i]);
	for (int sub : in[i]) {
		add_edge(sub, i * 2);
		add_edge(i * 2 + 1, sub ^ 1);
	}
	if (tl + 1 != tr) {
		int m = (tl + tr) / 2;
		belfast(i * 2 + 1, tl, m);
		belfast(i * 2 + 2, m, tr);
	}
}
void run() {
	cin >> n;
	v.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].f.x >> v[i].f.y >> v[i].s.x >> v[i].s.y;
		cords.pb(v[i].f.x);
		cords.pb(v[i].f.y);
		cords.pb(v[i].s.x);
		cords.pb(v[i].s.y);
	}
	sort(cords.begin(), cords.end());
	cords.resize(unique(cords.begin(), cords.end()) - cords.begin());
	for (int i = 0; i < n; i++) {
		disable(OFF + i * 2, v[i].f.x, v[i].f.y);
		disable(OFF + i * 2 + 1, v[i].s.x, v[i].s.y);
	}
	cords.clear();
	cords.shrink_to_fit();
	v.clear();
	v.shrink_to_fit();
	init(0, 0, N);
	belfast(0, 0, N);
	act();
	for (int i = 0; i < M; i++) {
		if (OFFT <= i && i < OFF) continue;
		if (at[i] == at[i ^ 1]) {
			// cout << i - OFF << endl;
			cout << "No" << endl;
			return;
		}
	}
	cout << "Yes" << "\n";
	for (int i = 0; i < n; i++) {
		if (at[OFF + i * 2] > at[OFF + i * 2 + 1]) {
			cout << 1 << "\n";	
		} else {
			cout << 2 << "\n";	
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}