#include "bits/stdc++.h"

#define random anotehsaontehsnaohesn
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

namespace random {
	using namespace std::chrono;
	mt19937 rng(duration_cast<milliseconds>(
		system_clock::now().time_since_epoch()).count());
	uniform_real_distribution<> prob_dist(0.0, 1.0);
};

using namespace random;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	return os;
}

int n, m;
vector<vector<int>> g;
vector<int> match;
void add_edge(int a, int b) {
	assert(a != b);
	g[a].pb(b);
	g[b].pb(a);
}
vector<bool> used;
bool izban(int v) {
	used[v] = true;
	shuffle(g[v].begin(), g[v].end(), rng);
	for (int sub : g[v]) {
		if (match[sub] == -1) {
			match[v] = sub;
			match[sub] = v;
			return true;
		}
	}
	for (int sub : g[v]) {
		int t = match[sub];
		if (used[t]) continue;
		match[t] = -1;
		match[v] = sub;
		match[sub] = v;
		if (izban(t)) {
			return true;
		} else {
			match[v] = -1;
			match[sub] = t;
			match[t] = sub;
		}
	}
	return false;
}
vector<pii> boxes;

bool between(int i, int j, int k) {
	if (boxes[i].x == boxes[j].x && boxes[j].x == boxes[k].x) {
		return boxes[i].y < boxes[k].y && boxes[k].y < boxes[j].y;
	} else {
		return boxes[i].x < boxes[k].x && boxes[k].x < boxes[j].x;
	}
}

void run() {
	cin >> n;
	boxes.resize(n);
	g.resize(n);
	vector<int> cordsX;
	vector<int> cordsY;
	for (int i = 0; i < n; i++) {
		cin >> boxes[i].x >> boxes[i].y;
		cordsX.pb(boxes[i].x);
		cordsY.pb(boxes[i].y);
	}
	cin >> m;
	vector<pii> stones(m);
	for (int i = 0; i < m; i++) {
		cin >> stones[i].x >> stones[i].y;
		cordsX.pb(stones[i].x);
		cordsY.pb(stones[i].y);
	}
	sort(cordsX.begin(), cordsX.end());
	cordsX.resize(unique(cordsX.begin(), cordsX.end()) - cordsX.begin());
	sort(cordsY.begin(), cordsY.end());
	cordsY.resize(unique(cordsY.begin(), cordsY.end()) - cordsY.begin());
	auto zip = [](vector<int> &cords, int val) {
		return lower_bound(cords.begin(), cords.end(), val) - cords.begin();
	};
	vector<vector<pii>> atX(len(cordsX));
	vector<vector<pii>> atY(len(cordsY));
	for (int i = 0; i < n; i++) {
		boxes[i].x = zip(cordsX, boxes[i].x);
		boxes[i].y = zip(cordsY, boxes[i].y);

		atX[boxes[i].x].emplace_back(boxes[i].y, i);
		atY[boxes[i].y].emplace_back(boxes[i].x, i);
	}
	for (int i = 0; i < m; i++) {
		stones[i].x = zip(cordsX, stones[i].x);
		stones[i].y = zip(cordsY, stones[i].y);

		atX[stones[i].x].emplace_back(stones[i].y, -1);
		atY[stones[i].y].emplace_back(stones[i].x, -1);
	}
	for (int i = 0; i < len(atX); i++) {
		vector<pii> elems = atX[i];
		elems.emplace_back(2e9, -1);
		sort(elems.begin(), elems.end());
		vector<int> buf;
		for (pii p : elems) {
			if (p.y == -1) {
				for (int i = 0; i < len(buf); i++) 
					for (int j = i + 1; j < len(buf); j++)
						add_edge(buf[i], buf[j]);
				buf.clear();
			} else buf.pb(p.y);
		}
	}
	for (int i = 0; i < len(atY); i++) {
		vector<pii> elems = atY[i];
		elems.emplace_back(2e9, -1);
		sort(elems.begin(), elems.end());
		vector<int> buf;
		for (pii p : elems) {
			if (p.y == -1) {
				for (int i = 0; i < len(buf); i++) 
					for (int j = i + 1; j < len(buf); j++)
						add_edge(buf[i], buf[j]);
				buf.clear();
			} else buf.pb(p.y);
		}
	}
	match.resize(n, -1);
	for (int test = 0; test < 100; test++) {
		vector<int> all(n);
		iota(all.begin(), all.end(), 0);
		shuffle(all.begin(), all.end(), rng);
		for (int i : all) {
			if (match[i] == -1) {
				used = vector<bool>(n, false);
				izban(i);
			}
		}
	}
	int unmatched = 0;
	for (int i = 0; i < n; i++) {
		if (match[i] == -1) {
			unmatched++;
		}
	}
	// cout << unmatched << endl;
	vector<pii> to_del;
	for (int i = 0; i < len(atX); i++) {
		vector<pii> elems = atX[i];
		elems.emplace_back(2e9, -1);
		sort(elems.begin(), elems.end());
		vector<int> buf;
		for (pii p : elems) {
			if (p.y == -1) {
				vector<int> cur;
				for (int x : buf) {
					if (match[x] != -1 && boxes[match[x]].x == boxes[x].x) {
						cur.pb(x);
					}
				}
				assert(len(cur) % 2 == 0);
				for (int i = 0; i < len(cur); i += 2)
					to_del.emplace_back(cur[i], cur[i + 1]);
				buf.clear();
			} else buf.pb(p.y);
		}
	}
	for (int i = 0; i < len(atY); i++) {
		vector<pii> elems = atY[i];
		elems.emplace_back(2e9, -1);
		sort(elems.begin(), elems.end());
		vector<int> buf;
		for (pii p : elems) {
			if (p.y == -1) {
				vector<int> cur;
				for (int x : buf) {
					if (match[x] != -1 && boxes[match[x]].y == boxes[x].y) {
						cur.pb(x);
					}
				}
				assert(len(cur) % 2 == 0);
				for (int i = 0; i < len(cur); i += 2)
					to_del.emplace_back(cur[i], cur[i + 1]);
				buf.clear();
			} else buf.pb(p.y);
		}
	}
	// to del	
	vector<bool> del(n, false);
	vector<int> blocks(len(to_del));
	vector<pii> st;
	for (int i = 0; i < len(to_del); i++) {
		for (int j = 0; j < n; j++) {
			blocks[i] += (between(to_del[i].x, to_del[i].y, j));
		}
		if (blocks[i] == 0) {
			st.pb(to_del[i]);
		}
	}
	for (int i = 0; i < n; i++) {
		if (match[i] == -1) st.emplace_back(i, i);
	}
	cout << unmatched + (n - unmatched) / 2 << "\n";
	while (!st.empty()) {
		pii t = st.back();
		st.pop_back();
		if (del[t.x]) continue;
		del[t.x] = true;
		del[t.y] = true;
		vector<int> checkout;
		if (t.x == t.y) {
			cout << 0 << " " << cordsX[boxes[t.x].x] + 1 << " " << cordsY[boxes[t.x].y] << "\n";
			checkout.pb(t.x);
		} else {
			if (boxes[t.x].x == boxes[t.y].x) {
				cout << 1 << " " << cordsX[boxes[t.x].x] << " " << cordsY[boxes[t.x].y] + 1 << "\n"; 
			} else {
				cout << 0 << " " << cordsX[boxes[t.x].x] + 1 << " " << cordsY[boxes[t.x].y] << "\n"; 
			}
			// if (boxes[t.x].x == boxes[t.y].x) cout << 1;
			// else cout << 0;

			// cout << " " << (cordsX[boxes[t.x].x] + cordsX[boxes[t.y].x]) / 2 << " "
			// << (cordsY[boxes[t.x].y] + cordsY[boxes[t.y].y]) / 2 << "\n"; 
			checkout.pb(t.x);
			checkout.pb(t.y);
		}	
		for (int c: checkout)
		for (int i = 0; i < len(to_del); i++) {
			if (between(to_del[i].x, to_del[i].y, c)){
				blocks[i]--;
				if (blocks[i] == 0) {
					st.pb(to_del[i]);	
				}	
			}
		}
		if (st.empty() && del != vector<bool>(n, true)) {
			vector<int> ava;
			for (int i = 0; i < n; i++) {
				ava.pb(i);
			}
			int pick = ava[rng() % len(ava)];
			st.pb(to_del[pick]);
		}	
	}
	// for (int i = 0; i < len(to_del); i++) {
	// 	pii t = to_del[i];
	// 	if (!del[t.x]) {
	// 	}
	// }
	// assert(del == vector<bool>(n, true));
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}