#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;

const int N = 1e6 + 100;
struct seg
{
	int l, r, i;
	seg() {}
	seg(int a, int b, int j) {
		l = a, r = b;
		i = j;
	}
	void in() {
		std::cin >> l >> r;
	}
	friend bool operator<(seg a, seg b) {
		if (a.l == b.l) {
			if (a.r == b.r) {
				return a.i < b.i;
			}
			return a.r < b.r;
		}
		return a.l < b.l;
	}
};
bool inter(seg a, seg b) {
	return std::max(a.l, b.l) <= std::min(a.r, b.r);
}
std::pair<seg,seg> segt[N];
int used[N], cmp[N];
std::vector<int> g[N], gr[N];
void addEdge(int a, int b) {
	g[a].pb(b);
	gr[b].pb(a);
}
std::pair<seg, seg> segments[N];
std::vector<int> order;
void dfs1(int v) {
	used[v] = 1;
	for (auto e : gr[v]) {
		if (!used[e]) {
			dfs1(e);
		}
	}
	order.pb(v);
}
int clr = 1;
void dfs2(int v) {
	cmp[v] = clr;
	for (auto e : g[v]) {
		if (!cmp[e]) {
			dfs2(e);
		}
	}
}
int tree[4 * N][2];
int nowVertex = 0;
void build(int now, int v, int tl, int tr, std::vector<int> &x) {
	if (tl == tr) {
		tree[v][now] = x[tl];
		return;
	}
	int tm = (tl + tr) / 2;
	build(now, v * 2, tl, tm, x);
	build(now, v * 2 + 1, tm + 1, tr, x);
	tree[v][now] = nowVertex++;
	if (now == 0) {
		addEdge(tree[v][now], tree[v * 2][now]);
		addEdge(tree[v][now], tree[v * 2 + 1][now]);
	}
	else {
		addEdge(tree[v * 2][now], tree[v][now]);
		addEdge(tree[v * 2 + 1][now], tree[v][now]);
	}
}
void addEdges(int v, int tl, int tr, int l, int r, int from) {
	if (l > r) return;
	if (tl == l && tr == r) {
		// debug(l << ' ' << r << ' ' << from / 2)
		addEdge(from, tree[v][0]);
		addEdge(tree[v][1], from ^ 1);
		return;
	}
	int tm = (tl + tr) / 2;
	addEdges(v * 2, tl, tm, l, std::min(r, tm), from);
	addEdges(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r, from);
}
const int INF = 1e9 + 1;
int main() {
	int n;
	std::cin >> n;
	std::vector<seg> toSort;
	FOR(i, n) {
		segt[i].first.in();
		segt[i].second.in();
		segt[i].first.i = 2 * i;
		segt[i].second.i = 2 * i + 1;
		toSort.pb(segt[i].first);
		toSort.pb(segt[i].second);
		addEdge(4 * i + 1, 4 * i + 2);
		addEdge(4 * i + 3, 4 * i);
		segments[2 * i] = {segt[i].first, {4 * i, 4 * i + 1, -1}};
		segments[2 * i + 1] = {segt[i].second, {4 * i + 2, 4 * i + 3, -1}};
	}
	nowVertex = 4 * n;
	std::sort(toSort.begin(), toSort.end());
	std::vector<int> tr, fl;
	FOR(i, toSort.size()) {
		tr.pb(toSort[i].i * 2);
		fl.pb(toSort[i].i * 2 + 1);
		// debug(toSort[i].l << ' ' << toSort[i].r)
	}
	build(0, 1, 0, (int)toSort.size() - 1, fl);
	build(1, 1, 0, (int)toSort.size() - 1, tr);
	FOR(i, toSort.size()) {
		auto it1 = std::lower_bound(toSort.begin(), toSort.end(), seg(toSort[i].l, -1, -1)) - toSort.begin();
		auto it2 = std::upper_bound(toSort.begin(), toSort.end(), seg(toSort[i].r, INF, INF)) - toSort.begin() - 1;
		int from = toSort[i].i * 2;
		// debug(it1 << ' ' << it2 << ' ' << toSort[i].l << ' ' << toSort[i].r)
		addEdges(1, 0, (int)toSort.size() - 1, it1, i - 1, from);
		addEdges(1, 0, (int)toSort.size() - 1, i + 1, it2, from);
	}
	FOR(i, 4 * n) {
		if (!used[i]) {
			dfs1(i);
		}
	}
	std::reverse(order.begin(), order.end());
	for (auto e : order) {
		if (!cmp[e]) {
			dfs2(e);
			clr++;
		}
	}
	FOR(i, 2 * n) {
		if (cmp[2 * i] == cmp[2 * i + 1]) {
			std::cout << "No";
			return 0;
		}
	}
	std::cout << "Yes\n";
	FOR(i, n) {
		if (cmp[4 * i] < cmp[4 * i + 1]) {
			std::cout << 1 << '\n';
		}
		else {
			std::cout << 2 << '\n';
		}
	}
}