#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAX_N = 8e3 + 10;

int n;
vector<int> edges[MAX_N], iedges[MAX_N];

void addEdge(int u, int v) {
	// cout << "If " << u << ", then " << v << endl;
	edges[u].push_back(v);
	iedges[v].push_back(u);
}

pii firstOption[MAX_N], secondOption[MAX_N];

bool isIntersecting(pii a, pii b) {
	return max(a.x, b.x) <= min(a.y, b.y);
}

pair<bool, bool> intersect(pii a, int j) {
	return {isIntersecting(a, firstOption[j]), isIntersecting(a, secondOption[j])};
}

char used[MAX_N];
int color[MAX_N];
vector<int> order;

void getOrder(int u) {
	if (used[u] == 1)
		return;
	used[u] = 1;
	for (int v : edges[u])
		getOrder(v);
	order.push_back(u);
}

void colorDFS(int u, int cc) {
	if (color[u] != -1)
		return;
	// cout << "color dfs" << u << " " << cc << endl;
	color[u] = cc;
	for (int v : iedges[u])
		colorDFS(v, cc);
}

void addFor(pii cut, int vertex, int index) {
	for (int i = 0; i < n; ++i) {
		if (i == index)
			continue;
		bool b1, b2;
		tie(b1, b2) = intersect(cut, i);
		if (b1)
			addEdge(vertex, 2 * i + 1);
		if (b2)
			addEdge(vertex, 2 * i);
	}
}

char ans[MAX_N];

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> firstOption[i].x >> firstOption[i].y >> secondOption[i].x >> secondOption[i].y;
	for (int i = 0; i < n; ++i) {
		addFor(firstOption[i], 2 * i, i);
		addFor(secondOption[i], 2 * i + 1, i);
	}
	for (int i = 0; i < 2 * n; ++i)
		getOrder(i);
	reverse(all(order));
	fill(color, color + 2 * n, -1);
	int cc = 0;
	for (int u : order)
		if (color[u] == -1)
			colorDFS(u, cc++);
	// for (int i = 0; i < 2 * n; ++i)
	// 	cout << color[i] << " ";
	// cout << "\n";
	for (int i = 0; i < n; ++i) {
		if (color[2 * i] == color[2 * i + 1])
			return cout << "No\n", 0;
		ans[i] = color[2 * i] < color[2 * i + 1];
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i)
		cout << ans[i] + 1 << "\n";
	return 0;
}