#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAX_N = 131072, MAX_NODES = 1e7;

pii option[2][MAX_N];

int n;
vector<int> edges[MAX_NODES], iedges[MAX_NODES];
int nodes;

vector<pii> rtree[2][2 * MAX_N];

int permPos[2][MAX_N];
char ans[MAX_N];

pair<pii, int> lSorted[2][MAX_N];

char used[MAX_NODES];
int color[MAX_NODES];
vector<int> order;

void addEdge(int u, int v) {
	// cout << ">>> If " << u << ", then " << v << endl;
	edges[u].push_back(v);
	iedges[v].push_back(u);
}

int ind = 0;

int allocVertex() {
	assert(nodes < MAX_NODES);
	return nodes++;
}

bool rcmp(pii a, pii b) {
	return option[ind][a.x].y > option[ind][b.x].y;
}
// <real_index, node>
void buildTree(int i, int l, int r) {
	if (l == r - 1) {
		// cout << i << " " << l << " " << r << " -> " << lSorted[ind][l].y << " " << lSorted[ind][l].y + (n * int(ind == 0)) << "\n";
		rtree[ind][i].push_back({lSorted[ind][l].y, lSorted[ind][l].y + (n * int(ind == 0))});
		return;
	}
	int mid = (l + r) / 2;
	buildTree(2 * i + 1, l, mid);
	buildTree(2 * i + 2, mid, r);
	rtree[ind][i].resize(sz(rtree[ind][2 * i + 1]) + sz(rtree[ind][2 * i + 2]));
	merge(all(rtree[ind][2 * i + 1]), all(rtree[ind][2 * i + 2]), rtree[ind][i].begin(), rcmp);
	// cout << "adding on " << i << " " << l << " " << r << endl;
	for (int j = 0; j < sz(rtree[ind][i]); ++j) {
		rtree[ind][i][j].y = allocVertex();
		// cout << rtree[ind][i][j].x << " -> " << permPos[ind][rtree[ind][i][j].x] << "\n";
		addEdge(rtree[ind][i][j].y, rtree[ind][i][j].x + (n * int(ind == 0)));
		if (j)
			addEdge(rtree[ind][i][j].y, rtree[ind][i][j - 1].y);
	}
	// cout << "added" << endl;
}

void getOrder(int u) {
	if (used[u] == 1)
		return;
	used[u] = 1;
	for (int v : edges[u])
		getOrder(v);
	order.push_back(u);
}

void colorDFS(int u, int cc) {
	if (color[u] != -1)
		return;
	// cout << "color dfs" << u << " " << cc << endl;
	color[u] = cc;
	for (int v : iedges[u])
		colorDFS(v, cc);
}

/*void addFor(pii cut, int vertex, int index) {
	for (int i = 0; i < n; ++i) {
		if (i == index)
			continue;
		bool b1, b2;
		tie(b1, b2) = intersect(cut, i);
		if (b1)
			addEdge(vertex, 2 * i + 1);
		if (b2)
			addEdge(vertex, 2 * i);
	}
}*/

void addEdges(int orignode, int ql, int qr, int x, int i, int l, int r) {
	if (ql <= l && r <= qr) {
		//Do work
		// cout << orignode << " " << ql << " " << qr << " " << x << " " << i << " " << l << " " << r << endl;
		// cout << "work" << endl;
		int l = -1, r = rtree[ind][i].size();
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (option[ind][rtree[ind][i][mid].x].y < x)
				r = mid;
			else
				l = mid;
		}
		// cout << l << " " << r << endl;
		if (l != -1)
			addEdge(orignode, rtree[ind][i][l].y);
		return;
	}
	if (qr <= l || r <= ql)
		return;
	int mid = (l + r) / 2;
	addEdges(orignode, ql, qr, x, 2 * i + 1, l, mid);
	addEdges(orignode, ql, qr, x, 2 * i + 2, mid, r);
}

void addFor(int curr_ind, int i) {
	pii value = option[curr_ind][i];
	// cout << "add for ind=" << curr_ind << " i=" << i << endl;
	int endIndex = lower_bound(lSorted[ind], lSorted[ind] + n, make_pair(make_pair(value.y + 1, -1), -1)) - lSorted[ind];
	// cout << endIndex << "\n";
	if (endIndex == 0)
		return;
	int another = permPos[ind][i];
	// cout << another << endl;
	if (curr_ind == 1)
		i += n;
	// cout << curr_ind << " " << i << endl;
	if (another < endIndex) {
		addEdges(i, 0, another, value.x, 0, 0, n);
		addEdges(i, another + 1, endIndex, value.x, 0, 0, n);
	} else {
		addEdges(i, 0, endIndex, value.x, 0, 0, n);
	}
	// cout << "added" << endl;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> option[0][i].x >> option[0][i].y >> option[1][i].x >> option[1][i].y;
		lSorted[0][i] = {option[0][i], i};
		lSorted[1][i] = {option[1][i], i};
	}
	sort(lSorted[0], lSorted[0] + n);
	sort(lSorted[1], lSorted[1] + n);
	// for (int i = 0; i < n; ++i)
	// 	cout << lSorted[0][i].x.x << ":" << lSorted[0][i].x.y << " ";
	// cout << "\n";
	// for (int i = 0; i < n; ++i)
	// 	cout << lSorted[1][i].x.x << ":" << lSorted[1][i].x.y << " ";
	// cout << "\n";
	for (int i = 0; i < n; ++i)
		permPos[0][lSorted[0][i].y] = i,
		permPos[1][lSorted[1][i].y] = i;
	// for (int i = 0; i < n; ++i)
	// 	cout << permPos[0][i] << " " << permPos[1][i] << "\n";
	nodes = 2 * n;
	ind = 0;
	buildTree(0, 0, n);
	ind = 1;
	buildTree(0, 0, n);
	for (int i = 0; i < n; ++i) {
		ind = 0;
		addFor(0, i);
		ind = 1;
		addFor(0, i);
		ind = 0;
		addFor(1, i);
		ind = 1;
		addFor(1, i);
	}
	// for (int i = 0; i < n; ++i)
	// 	cout << permPos[0][i] << " " << permPos[1][i] << "\n";
	/*for (int i = 0; i < n; ++i) {
		addFor(option[0][i], 2 * i, i);
		addFor(option[1][i], 2 * i + 1, i);
	}*/
	for (int i = 0; i < nodes; ++i)
		getOrder(i);
	reverse(all(order));
	fill(color, color + nodes, -1);
	int cc = 0;
	for (int u : order)
		if (color[u] == -1)
			colorDFS(u, cc++);
	// for (int i = 0; i < 2 * n; ++i)
	// 	cout << color[i] << " ";
	// cout << "\n";
	for (int i = 0; i < n; ++i) {
		if (color[i] == color[n + i])
			return cout << "No\n", 0;
		ans[i] = color[i] < color[n + i];
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i)
		cout << ans[i] + 1 << "\n";
	return 0;
}