#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()

const int N = 1e6;

int neg(int v) {
	return v ^ 1;
}

namespace sat {
int n;
vector<int> g[N];
vector<int> r[N];
vector<int> order;
bool value[N];
int comp[N];
int curcomp;

int addvertex() {
	assert(n + 2 < N);
	int v = n;
	n += 2;
	return v;
}
string str(int v) {
	return to_string(v / 2) + to_string(v % 2 + 1);
}
void addedge(int v, int u) {
	g[v].push_back(u);
	r[u].push_back(v);
	g[neg(u)].push_back(neg(v));
	r[neg(v)].push_back(neg(u));
}
void topsort(int v) {
	comp[v] = true;
	for (int u : g[v]) {
		if (!comp[u]) {
			topsort(u);
		}
	}
	order.push_back(v);
}
void color(int v) {
	comp[v] = curcomp;
	for (int u : r[v]) {
		if (comp[u] == -1) {
			color(u);
		}
	}
}
bool solve() {
	order.clear();
	order.reserve(n);
	fill_n(comp, N, false);
	for (int i = 0; i < n; ++i) {
		if (!comp[i]) {
			topsort(i);
		}
	}
	reverse(all(order));
	fill_n(comp, N, -1);
	curcomp = 0;
	for (int i : order) {
		if (comp[i] == -1) {
			color(i);
			++curcomp;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (comp[i] == comp[neg(i)]) {
			return false;
		}
		value[i] = comp[i] > comp[neg(i)];
	}
	return true;
}
};

bool cross(int a, int b, int x, int y) {
	return max(a, x) <= min(b, y);
}

int n;
int v[N];
int a[N], b[N], c[N], d[N];

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		v[i] = sat::addvertex();
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			bool f11 = cross(a[i], b[i], a[j], b[j]);
			bool f12 = cross(a[i], b[i], c[j], d[j]);
			bool f21 = cross(c[i], d[i], a[j], b[j]);
			bool f22 = cross(c[i], d[i], c[j], d[j]);
			int si = i;
			int sj = j;
			i = v[i];
			j = v[j];
			if (f11) {
				sat::addedge(i, neg(j));
			}
			if (f12) {
				sat::addedge(i, j);
			}
			if (f21) {
				sat::addedge(neg(i), neg(j));
			}
			if (f22) {
				sat::addedge(neg(i), j);
			}
			i = si;
			j = sj;
		}
	}
	if (!sat::solve()) {
		cout << "No\n";
		return 0;
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (sat::value[i]) {
			cout << 1 << "\n";
		} else {
			cout << 2 << "\n";
		}
	}
	return 0;
}
