#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()

const int N = 1e7 + 100;

int neg(int v) {
	return v ^ 1;
}

namespace sat {
int n;
vector<int> g[N];
vector<int> r[N];
vector<int> order;
bool value[N];
int comp[N];
int curcomp;

int addvertex() {
	assert(n + 2 < N);
	int v = n;
	n += 2;
	return v;
}
string str(int v) {
	return to_string(v / 2) + to_string(v % 2 + 1);
}
void addedge(int v, int u) {
	if (v < 0 || u < 0) {
		return;
	}
	g[v].push_back(u);
	r[u].push_back(v);
	g[neg(u)].push_back(neg(v));
	r[neg(v)].push_back(neg(u));
}
void topsort(int v) {
	comp[v] = true;
	for (int u : g[v]) {
		if (!comp[u]) {
			topsort(u);
		}
	}
	order.push_back(v);
}
void color(int v) {
	comp[v] = curcomp;
	for (int u : r[v]) {
		if (comp[u] == -1) {
			color(u);
		}
	}
}
bool solve() {
	order.clear();
	order.reserve(n);
	fill_n(comp, N, false);
	for (int i = 0; i < n; ++i) {
		if (!comp[i]) {
			topsort(i);
		}
	}
	reverse(all(order));
	fill_n(comp, N, -1);
	curcomp = 0;
	for (int i : order) {
		if (comp[i] == -1) {
			color(i);
			++curcomp;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (comp[i] == comp[neg(i)]) {
			return false;
		}
		value[i] = comp[i] > comp[neg(i)];
	}
	return true;
}
};

bool cross(int a, int b, int x, int y) {
	return max(a, x) <= min(b, y);
}

int n;
int v[N];
int a[N], b[N], c[N], d[N];

int lef[N], rig[N];
int sorted[N];

const int F = 2e5 + 100;
int fen[N];

int z[N];
int sz = 0;

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n;
	
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		z[sz++] = a[i];
		z[sz++] = b[i];
		z[sz++] = c[i];
		z[sz++] = d[i];
		lef[2 * i] = a[i];
		rig[2 * i] = b[i];
		lef[2 * i + 1] = c[i];
		rig[2 * i + 1] = d[i];
		v[i] = sat::addvertex();
	}
	sort(z, z + sz);
	for (int i = 0; i < 2 * n; ++i) {
		lef[i] = int(lower_bound(z, z + sz, lef[i]) - z);
		rig[i] = int(lower_bound(z, z + sz, rig[i]) - z);
	}

	iota(sorted, sorted + 2 * n, 0);
	sort(sorted, sorted + 2 * n, [&](int i, int j) {
		return rig[i] > rig[j];
	});
	
	fill_n(fen, F, -1);
	for (int ind = 0; ind < 2 * n; ++ind) {
		int cur = sorted[ind];
		assert(0 <= lef[cur] && lef[cur] <= rig[cur] && rig[cur] < F);
		for (int i = rig[cur]; i >= 0; i = (i & (i + 1)) - 1) {
			sat::addedge(cur, fen[i]);
		}
		for (int i = lef[cur]; i < F; i |= i + 1) {
			int u = sat::addvertex();
			sat::addedge(u, fen[i]);
			sat::addedge(u, neg(cur));
			fen[i] = u;
		}
	}

	if (!sat::solve()) {
		cout << "No\n";
		return 0;
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (sat::value[v[i]]) {
			cout << 1 << "\n";
		} else {
			cout << 2 << "\n";
		}
	}
	return 0;
}
