#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()


int neg(int v) {
	return v ^ 1;
}

void waassert(bool c) {
	if (!c) {
		cout << "wa" << endl;
		exit(0);
	}
}

namespace sat {
const int N = 4.3e6 + 100;
int n;
vector<int> g[N];
vector<int> r[N];
vector<int> order;
bool value[N];
int comp[N];
int curcomp;

int addvertex() {
	waassert(n + 2 < N);
	int v = n;
	n += 2;
	return v;
}
string str(int v) {
	return to_string(v / 2) + to_string(v % 2 + 1);
}
void addedge(int v, int u) {
	if (v < 0 || u < 0) {
		return;
	}
	g[v].push_back(u);
	r[u].push_back(v);
	g[neg(u)].push_back(neg(v));
	r[neg(v)].push_back(neg(u));
}
int q[N];
int p[N];
const int IN = 0;
const int OUT = 1;

void topsort(int v) {
	int ptr = 0;
	q[ptr++] = v;
	while (ptr) {
		v = q[ptr - 1];
		comp[v] = true;
		if (p[v] < (int)g[v].size()) {
			int u = g[v][p[v]++];
			if (!comp[u]) {
				q[ptr++] = u;
			}
		} else {
			--ptr;
			order.push_back(v);
		}
	}
}
void color(int v) {
	int ql = 0;
	int qr = 0;
	q[qr++] = v;
	comp[v] = curcomp;
	while (ql < qr) {
		v = q[ql++];
		for (int u : r[v]) {
			if (comp[u] == -1) {
				comp[u] = curcomp;
				q[qr++] = u;
			}
		}
	}
}
bool solve() {
	fill_n(p, N, 0);
	order.clear();
	order.reserve(n);
	fill_n(comp, N, false);
	for (int i = 0; i < n; ++i) {
		if (!comp[i]) {
			topsort(i);
		}
	}
	reverse(all(order));
	fill_n(comp, N, -1);
	curcomp = 0;
	for (int i : order) {
		if (comp[i] == -1) {
			color(i);
			++curcomp;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (comp[i] == comp[neg(i)]) {
			return false;
		}
		value[i] = comp[i] > comp[neg(i)];
	}
	return true;
}
};

const int F = 4e5 + 100;
int n;
int v[F];
int a[F], b[F], c[F], d[F];
int lef[F], rig[F];
int sorted[F];
int fen[F];
int z[F];
int sz = 0;

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n;
	
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		z[sz++] = a[i];
		z[sz++] = b[i];
		z[sz++] = c[i];
		z[sz++] = d[i];
		lef[2 * i] = a[i];
		rig[2 * i] = b[i];
		lef[2 * i + 1] = c[i];
		rig[2 * i + 1] = d[i];
		v[i] = sat::addvertex();
	}
	sort(z, z + sz);
	for (int i = 0; i < 2 * n; ++i) {
		lef[i] = int(lower_bound(z, z + sz, lef[i]) - z);
		rig[i] = int(lower_bound(z, z + sz, rig[i]) - z);
	}

	iota(sorted, sorted + 2 * n, 0);
	sort(sorted, sorted + 2 * n, [&](int i, int j) {
		return rig[i] > rig[j];
	});

	fill_n(fen, F, -1);
	for (int ind = 0; ind < 2 * n; ++ind) {
		int cur = sorted[ind];
		assert(0 <= lef[cur] && lef[cur] <= rig[cur] && rig[cur] < F);
		for (int i = rig[cur]; i >= 0; i = (i & (i + 1)) - 1) {
			sat::addedge(cur, fen[i]);
		}
		for (int i = lef[cur]; i < F; i |= i + 1) {
			int u = sat::addvertex();
			sat::addedge(u, fen[i]);
			sat::addedge(u, neg(cur));
			fen[i] = u;
		}
	}
	if (!sat::solve()) {
		cout << "No\n";
		return 0;
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (sat::value[v[i]]) {
			cout << 1 << "\n";
		} else {
			cout << 2 << "\n";
		}
	}
	return 0;
}
