#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()



/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////


const int B = 1 << 12;

char input[B];
int inlen = 0;
int inptr = 0;

bool eof() {
	if (inlen == inptr) {
		inlen = (int)fread(input, 1, B, stdin);
		inptr = 0;
	}
	return inlen == inptr;
}

char gc() {
	return eof() ? -1 : input[inptr++];
}

char readchar() {
	char c = gc();
	while (c == ' ') {
		c = gc();
	}
	return c;
}

int readint() {
	int sign = +1;
	int sum  = 0;
	char c = readchar();
	if (c == '-') {
		sign = -1;
		c = gc();
	}
	while ('0' <= c && c <= '9') {
		sum = 10 * sum + c - '0';
		c = gc();
	}
	return sign * sum;
}

char output[B];
int outptr = 0;

void flush() {
	fwrite(output, 1, outptr, stdout);
	outptr = 0;
}

struct flusher {
	~flusher() {
		flush();
	}
} instance;

void pc(char c) {
	if (outptr == B) {
		flush();
	}
	output[outptr++] = c;
}

void writeint(int x, char e = 0) {
	static char s[30];
	if (x < 0) {
		x *= -1;
		pc('-');
	}
	int n = 0;
	while (!n || x > 0) {
		s[n++] = char('0' + x % 10);
		x /= 10;
	}
	while (--n >= 0) {
		pc(s[n]);
	}
	if (e) {
		pc(e);
	}
}

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

const int N = 1e6;
int n;
int m;
int vx[N];
int vy[N];
int sx[N];
int sy[N];

int z[N];
int zsize = 0;

set<pair<int, int>> bx[N];
set<pair<int, int>> by[N];

int zip(int x) {
	return int(lower_bound(z, z + zsize, x) - z);
}

int xless(int v) {
	auto it = by[vy[v]].lower_bound({vx[v], INT_MIN});
	if (it == by[vy[v]].begin()) {
		return -1;
	}
	--it;
	return it->second;
}

int xgreater(int v) {
	auto it = by[vy[v]].upper_bound({vx[v], INT_MAX});
	if (it == by[vy[v]].end()) {
		return -1;
	}
	return it->second;
}

int yless(int v) {
	auto it = bx[vx[v]].lower_bound({vy[v], INT_MIN});
	if (it == bx[vx[v]].begin()) {
		return -1;
	}
	--it;
	return it->second;
}

int ygreater(int v) {
	auto it = bx[vx[v]].upper_bound({vy[v], INT_MAX});
	if (it == bx[vx[v]].end()) {
		return -1;
	}
	return it->second;
}

bool used[N];

int deg(int v) {
	assert(bx[vx[v]].size() && by[vy[v]].size());
	int d = xless(v) != -1;
	d += xgreater(v) != -1;
	d += yless(v) != -1;
	d += ygreater(v) != -1;
	return d;
}

void del(int v) {
	used[v] = true;
	bx[vx[v]].erase({vy[v], v});
	by[vy[v]].erase({vx[v], v});
}

vector<tuple<int, int, int>> answer;
int zx[N];
int zy[N];

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	
	n = readint();
	for (int i = 0; i < n; ++i) {
		vx[i] = readint();
		vy[i] = readint();
	}
	m = readint();
	for (int i = 0; i < m; ++i) {
		sx[i] = readint();
		sy[i] = readint();
	}

	zsize = n + m;
	copy_n(vx, n, z);
	copy_n(sx, m, z + n);
	sort(z, z + zsize);
	copy_n(z, zsize, zx);
	for (int i = 0; i < n; ++i) {
		vx[i] = zip(vx[i]);
	}
	for (int i = 0; i < m; ++i) {
		sx[i] = zip(sx[i]);
	}
	copy_n(vy, n, z);
	copy_n(sy, m, z + n);
	sort(z, z + zsize);
	copy_n(z, zsize, zy);
	for (int i = 0; i < n; ++i) {
		vy[i] = zip(vy[i]);
	}
	for (int i = 0; i < m; ++i) {
		sy[i] = zip(sy[i]);
	}

	for (int i = 0; i < n; ++i) {
		bx[vx[i]].emplace(vy[i], i);
		by[vy[i]].emplace(vx[i], i);
	}
	for (int i = 0; i < m; ++i) {
		bx[sx[i]].emplace(sy[i], -1);
		by[sy[i]].emplace(sx[i], -1);
	}

	
	for (int cnt = 0; cnt < n; ) {
		int v = -1;
		for (int u = 0; u < n; ++u) {
			if (used[u]) {
				continue;
			}
			if (v == -1 || deg(v) > deg(u)) {
				v = u;
			}
		}
		assert(v != -1);
		int u = max({xless(v), xgreater(v), yless(v), ygreater(v)});
		++cnt;
		del(v);
		if (u != -1) {
			assert(v != u);
			++cnt;
			del(u);
			if (vx[v] == vx[u]) {
				//cerr << "killx " << v + 1 << " " << u + 1 << endl;
				assert(vy[v] != vy[u]);
				answer.emplace_back(1, (zx[vx[v]] + zx[vx[u]]) / 2, (zy[vy[v]] + zy[vy[u]]) / 2);
			} else {
				//cerr << "killy " << v + 1 << " " << u + 1 << endl;
				assert(vy[v] == vy[u]);
				answer.emplace_back(1, (zx[vx[v]] + zx[vx[u]]) / 2, (zy[vy[v]] + zy[vy[u]]) / 2);
			}
		} else {
			answer.emplace_back(1, zx[vx[v]], zy[vy[v]] + 1);
		}
	}
	
	writeint((int)answer.size(), '\n');
	for (auto e : answer) {
		int a, b, c;
		tie(a, b, c) = e;
		writeint(a, ' ');
		writeint(b, ' ');
		writeint(c, '\n');
	}

	return 0;
}
