#include <bits/stdc++.h>

using namespace std;

vector <vector <int>> g;
vector <int> t;
vector <bool> used;

void dfs(int u) {
	used[u] = 1;
	for (auto v : g[u]) {
		if (!used[v]) {
			dfs(v);
		}
	}
	t.push_back(u);
}

void add(int a, int b, bool fl) {
	while (g.size() <= a) g.push_back(vector <int> ());
	while (g.size() <= b) g.push_back(vector <int> ());
	if (fl) g[a].push_back(b);
	else g[b].push_back(a);
}

const int N = 1e5 + 7;

int cmp[2 * N];

int cnt = 0;

int n;

void jhfs(int u) {
	used[u] = 1;
	if (u < 2 * n) cmp[u] = cnt;
	for (auto v : g[u]) {
		if (!used[v]) {
			jhfs(v);
		}
	}
}

vector <int> gs[4 * N];
vector <int> num[4 * N];

void go(int x, int y) {
	for (int i = x; i < 4 * N; i |= i + 1) {
		gs[i].push_back(y);
	}
}

int uk;

void addEdges(int x, int y, int id, bool fl) {
	for (int i = x; i < 4 * N; i |= i + 1) {
		for (int j = lower_bound(gs[i].begin(), gs[i].end(), y) - gs[i].begin(); j < gs[i].size(); j |= j + 1) {
			if (num[i][j] != -1) {
				add(uk, num[i][j], fl);
			}
			add(uk, id, fl);
			num[i][j] = uk++;
		}
	}
}

void goBad(int x, int y, int id, bool fl) {
	for (int i = x; i >= 0; i &= i + 1, --i) {
		for (int j = upper_bound(gs[i].begin(), gs[i].end(), y) - gs[i].begin() - 1; j >= 0; j &= j + 1, --j) {
			if (num[i][j] != -1) add(id, num[i][j], fl);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	cin >> n;
	vector <pair <int, int>> a(n), b(n);
	vector <int> c;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second >> b[i].first >> b[i].second;
		c.push_back(a[i].first);
		c.push_back(a[i].second);
		c.push_back(b[i].first);
		c.push_back(b[i].second);
	}
	sort(c.begin(), c.end());
	c.resize(unique(c.begin(), c.end()) - c.begin());
	for (int i = 0; i < n; ++i) {
		a[i].first = lower_bound(c.begin(), c.end(), a[i].first) - c.begin();
		b[i].first = lower_bound(c.begin(), c.end(), b[i].first) - c.begin();
		a[i].second = lower_bound(c.begin(), c.end(), a[i].second) - c.begin();
		b[i].second = lower_bound(c.begin(), c.end(), b[i].second) - c.begin();
		go(a[i].first, -a[i].second);
		go(b[i].first, -b[i].second);
	}
	uk = 2 * n;
	for (int i = 0; i < 4 * N; ++i) {
		sort(gs[i].begin(), gs[i].end());
		gs[i].resize(unique(gs[i].begin(), gs[i].end()) - gs[i].begin());
		gs[i].shrink_to_fit();
		num[i].resize(gs[i].size());
		num[i].shrink_to_fit();
		for (int j = 0; j < (int)gs[i].size(); ++j) num[i][j] = -1;
	}


	for (int i = 0; i < n; ++i) {
		goBad(a[i].second, -a[i].first, 2 * i, 1);
		goBad(b[i].second, -b[i].first, 2 * i + 1, 1);
		addEdges(a[i].first, -a[i].second, 2 * i + 1, 1);
		addEdges(b[i].first, -b[i].second, 2 * i, 1);
	}

	for (int i = 0; i < 4 * N; ++i) {
		fill(num[i].begin(), num[i].end(), -1);
	}

	for (int i = n - 1; i >= 0; --i) {
		goBad(a[i].second, -a[i].first, 2 * i, 1);
		goBad(b[i].second, -b[i].first, 2 * i + 1, 1);
		addEdges(a[i].first, -a[i].second, 2 * i + 1, 1);
		addEdges(b[i].first, -b[i].second, 2 * i, 1);
	}

	used.resize(uk, 0);

	for (int i = 0; i < uk; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}

	reverse(t.begin(), t.end());
	fill(used.begin(), used.end(), 0);
	for (int i = 0; i < uk; ++i) {
		g[i].clear();
		g[i].shrink_to_fit();
	}

	for (int i = 0; i < 4 * N; ++i) {
		fill(num[i].begin(), num[i].end(), -1);
	}

	uk = 2 * n;

	for (int i = 0; i < n; ++i) {
		goBad(a[i].second, -a[i].first, 2 * i, 0);
		goBad(b[i].second, -b[i].first, 2 * i + 1, 0);
		addEdges(a[i].first, -a[i].second, 2 * i + 1, 0);
		addEdges(b[i].first, -b[i].second, 2 * i, 0);
	}

	for (int i = 0; i < 4 * N; ++i) {
		fill(num[i].begin(), num[i].end(), -1);
	}

	for (int i = n - 1; i >= 0; --i) {
		goBad(a[i].second, -a[i].first, 2 * i, 0);
		goBad(b[i].second, -b[i].first, 2 * i + 1, 0);
		addEdges(a[i].first, -a[i].second, 2 * i + 1, 0);
		addEdges(b[i].first, -b[i].second, 2 * i, 0);
	}

	for (int x : t) {
		if (!used[x]) {
			jhfs(x);
			++cnt;
		}
	}

	for (int i = 0; i < n; ++i) {
		if (cmp[2 * i] == cmp[2 * i + 1]) {
			cout << "No\n";
			return 0;
		}	
	}

	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (cmp[2 * i] > cmp[2 * i + 1]) {
			cout << "1\n";
		} else {
			cout << "2\n";
		}
	}
}