#include <iostream>
#include <algorithm>
#include <cmath>
#include <cctype>
#include <vector>
#include <string>
#include <utility>
#include <queue>
#include <stack>
#define fi first
#define se second
using namespace std;

const int MAXN = 400005;

int n, m;
struct Box
{
    int u=-1, d=-1, l=-1, r=-1;
    int links=0;
    bool boom=false;
    int pos;
};
Box g[MAXN];

struct Answer
{
    bool type;
    int r, c;
};
Answer ans[MAXN];

pair <pair <int, int>, pair<int, bool> > a[2*MAXN]; //row, col; position, box (1) / rock (0)

bool cmp1 (pair <pair <int, int>, pair<int, bool> > A, pair <pair <int, int>, pair<int, bool> > B)
{
    if (A.fi.fi!=B.fi.fi)
        return A.fi.fi<B.fi.fi;
    return A.fi.se<B.fi.se;
}

bool cmp2 (pair <pair <int, int>, pair<int, bool> > A, pair <pair <int, int>, pair<int, bool> > B)
{
    if (A.fi.se!=B.fi.se)
        return A.fi.se<B.fi.se;
    return A.fi.fi<B.fi.fi;
}

bool cmp3 (pair <pair <int, int>, pair<int, bool> > A, pair <pair <int, int>, pair<int, bool> > B)
{
    return A.se.fi<B.se.fi;
}

void Init ()
{
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>a[i].fi.fi>>a[i].fi.se;
        a[i].se.fi=i;
        a[i].se.se=1;
    }
    cin>>m;
    for (int i=n; i<m+n; i++)
    {
        cin>>a[i].fi.fi>>a[i].fi.se;
        a[i].se.fi=i;
        a[i].se.se=0;
    }
}

void Build_Graph ()
{
    sort (a, a+n+m, cmp1);
    for (int i=0; i<m+n-1; i++)
        if (a[i].fi.fi==a[i+1].fi.fi && a[i].se.se && a[i+1].se.se)
        {
            g[a[i].se.fi].r=a[i+1].se.fi;
            g[a[i].se.fi].links++;
            g[a[i+1].se.fi].l=a[i].se.fi;
            g[a[i+1].se.fi].links++;
        }

    sort (a, a+n+m, cmp2);
    for (int i=0; i<m+n-1; i++)
        if (a[i].fi.se==a[i+1].fi.se && a[i].se.se && a[i+1].se.se)
        {
            g[a[i].se.fi].d=a[i+1].se.fi;
            g[a[i].se.fi].links++;
            g[a[i+1].se.fi].u=a[i].se.fi;
            g[a[i+1].se.fi].links++;
        }
    sort (a, a+n+m, cmp3); //sort by order of input
    for (int i=0; i<n; i++)
    {
        g[i].pos=i;
        //cout<<i<<": "<<g[i].l<<' '<<g[i].r<<' '<<g[i].u<<' '<<g[i].d<<endl;
    }
}

int main ()
{
    Init ();
    Build_Graph ();
    int booms=0;
    int killed=0;
    for (int i=0; i<n; i++)
    {
        if (killed==n) break;
        if (g[i].boom) continue;
        if (g[i].links==0)
        {
            ans[booms].type=1;
            ans[booms].r=a[i].fi.fi;
            ans[booms].c=a[i].fi.se+1;
            booms++;
            killed++;
            g[i].boom=true;
            continue;
        }
        int j=i, j1=-1;
        bool f=false;
        while (g[j].links!=1)
        {
            if (j==i && !f) f=true;
            if (j==i && f) break;
            if (g[j].u>=0 && g[j].u!=j1)
            {
                j1=j;
                j=g[j].u;
                continue;
            }
            if (g[j].d>=0 && g[j].d!=j1)
            {
                j1=j;
                j=g[j].d;
                continue;
            }
            if (g[j].l>=0 && g[j].l!=j1)
            {
                j1=j;
                j=g[j].l;
                continue;
            }
            if (g[j].r>=0 && g[j].r!=j1)
            {
                j1=j;
                j=g[j].r;
                continue;
            }
        }

        if (g[j].links==2) //We are in a loop
        {
            if (g[j].u>=0)
            {
                g[j].links--;
                g[g[j].u].links--;
                g[g[j].u].d=-1;
                g[j].u=-1;
            }
            else if (g[j].d>=0)
            {
                g[j].links--;
                g[g[j].d].links--;
                g[g[j].d].u=-1;
                g[j].d=-1;
            }
        }
        while (g[j].links==1)//We have found the beginning of the line - it is J
        {
            if (g[j].u>=0)
            {
                j1=g[j].u;
                if (!g[j].boom)
                {
                    ans[booms].type=0;
                    ans[booms].r=a[j].fi.fi-1;
                    ans[booms].c=a[j].fi.se;
                    booms++;
                    g[j].boom=true;
                    g[j1].boom=true;
                    killed+=2;
                    g[j1].d=-1;
                    g[j1].links--;
                }
                else
                    if (!g[j1].boom)
                    {
                        g[j1].d=-1;
                        g[j1].links--;
                    }
                j=j1;
                continue;
            }
            if (g[j].d>=0)
            {
                j1=g[j].d;
                if (!g[j].boom)
                {
                    ans[booms].type=0;
                    ans[booms].r=a[j].fi.fi+1;
                    ans[booms].c=a[j].fi.se;
                    booms++;
                    g[j].boom=true;
                    g[j1].boom=true;
                    killed+=2;
                    g[j1].u=-1;
                    g[j1].links--;
                }
                else
                    if (!g[j1].boom)
                    {
                        g[j1].u=-1;
                        g[j1].links--;
                    }
                j=j1;
                continue;
            }
            if (g[j].l>=0)
            {
                j1=g[j].l;
                if (!g[j].boom)
                {
                    ans[booms].type=1;
                    ans[booms].r=a[j].fi.fi;
                    ans[booms].c=a[j].fi.se-1;
                    booms++;
                    g[j].boom=true;
                    g[j1].boom=true;
                    killed+=2;
                    g[j1].r=-1;
                    g[j1].links--;
                }
                else
                    if (!g[j1].boom)
                    {
                        g[j1].r=-1;
                        g[j1].links--;
                    }
                j=j1;
                continue;
            }
            if (g[j].r>=0)
            {
                j1=g[j].r;
                if (!g[j].boom)
                {
                    ans[booms].type=1;
                    ans[booms].r=a[j].fi.fi;
                    ans[booms].c=a[j].fi.se+1;
                    booms++;
                    g[j].boom=true;
                    g[j1].boom=true;
                    killed+=2;
                    g[j1].l=-1;
                    g[j1].links--;
                }
                else
                    if (!g[j1].boom)
                    {
                        g[j1].l=-1;
                        g[j1].links--;
                    }
                j=j1;
            }
        }
        if (!g[j].boom) //if 1 more is left alive
        {
            ans[booms].type=1;
            ans[booms].r=a[j].fi.fi;
            ans[booms].c=a[j].fi.se+1;
            booms++;
            g[j].boom=true;
            killed++;
        }
    }
    cout<<booms<<endl;
    for (int i=0; i<booms; i++)
    {
        cout<<ans[i].type<<' '<<ans[i].r<<' '<<ans[i].c<<endl;
    }
    return 0;
}
