#include <iostream>
#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

vector<bool> used;
vector<vector<int>> g, g2;
vector<int> mt;
vector<int> col;

bool kuhn(int v){
    if(used[v]) return false;
    used[v] = true;
    for(int i : g2[v]){
        if(mt[i] == -1 || kuhn(mt[i])){
            mt[i] = v;
            return true;
        }
    }
}

void dfs(int v, int c){
    col[v] = c;
    for(int i : g[v]){
        if(!col[i]){
            dfs(i, -1 * c);
        }
    }
}



int main()
{
    int n, m;
    cin >> n;
    g.resize(n);
    vector<int> newid(n);
    vector<pair<int, int>> data;
    vector <pair<pair<int, int>, int>> am1, am2;
    for(int i = 0; i < n; i++){
        int x, y; cin >> x >> y;
        data.push_back({x, y});
        am1.push_back({{x, y}, i});
        am2.push_back({{y, x}, i});
    }
    cin >> m;
    for(int i = 0; i < m; i++){
        int x, y; cin >> x >> y;
        am1.push_back({{x, y}, -1});
        am2.push_back({{y, x}, -1});
    }
    sort(am1.begin(), am1.end());
    sort(am2.begin(), am2.end());
    for(int i = 1; i < n + m; i++){
        if(am1[i].second != -1){
            if(am1[i - 1].second != -1 && am1[i].first == am1[i].first){
                int id1 = am1[i - 1].second, id2 = am1[i].second ;
                g[id1].push_back(id2);
                g[id2].push_back(id1);
            }
        }
    }
    for(int i = 1; i < m + n; i++){
        if(am2[i].second != -1){
            if(am2[i - 1].second != -1 && am2[i].first == am2[i].first){
                int id1 = am2[i - 1].second, id2 = am2[i].second ;
                g[id1].push_back(id2);
                g[id2].push_back(id1);
            }
        }
    }
    col.resize(n);
    for(int i = 0; i < n; i++){
        if(!col[i]){
            dfs(i, 1);
        }
    }
    vector<int> f, s;
    int cnt1 = 0, cnt2 = 0;
    for(int i = 0; i < n; i++){
        if(col[i] == 1){
            newid[i] = cnt1;
            f.push_back(i);
            cnt1++;
        } else {
            newid[i] = cnt2;
            s.push_back(i);
            cnt2++;
        }
    }
    g2.resize(cnt1);
    for(int i = 0; i < n; i++){
        if(col[i] == 1){
            for(int j : g[i]){
                g2[newid[i]].push_back(newid[j]);
            }
        }
    }
    mt.resize(cnt2);
    for(int i = 0; i < cnt2; i++){
        mt[i] = -1;
    }
    used.resize(cnt1);
    for(int i = 0; i < cnt1; i++){
        for(int j = 0; j < cnt1; j++){
            used[i] = false;
        }
        kuhn(i);
    }
    vector<pair<int, pair<int, int> >> ans;
    for(int i = 0; i < cnt2; i++){
        if(mt[i] != -1){
            int u = f[mt[i]], v = s[i];
            if(data[u].first == data[v].first){
                ans.push_back({1, {data[u].first, (data[u].second + data[v].second)/2}});
            } else {
                ans.push_back({0, {(data[u].first + data[v].first)/2, data[u].second}});
            }
        }
    }
    for(int i = 0; i < cnt2; i++){
        int u = s[i];
        if(mt[i] == -1){
            ans.push_back({1, {data[u].first, data[u].second - 1}});
        }
    }
    cout << ans.size() << endl;
    for(int i = 0; i < ans.size(); i++){
        cout << ans[i].first << " " << ans[i].second.first << " " << ans[i].second.second << endl;
    }
    return 0;
}
